<%@ page contentType="text/html; charset=UTF-8" %>
<%@ include file="/common/taglibs.jsp" %>
<style type="text/css">@import "admin/styles/preference.css";</style>
<script language="JavaScript" src="admin/scripts/dynamicRows.js"></script>

<script type="text/javascript" src="common/scripts/jquery.cascade.js"></script>
<script type="text/javascript" src="common/scripts/jquery.field.js"></script>
<script language="JavaScript" src="admin/scripts/preference.js"></script>

<style type="text/css">@import "common/styles/sasStyles.css";</style>
<style type="text/css">@import "includes/view.css";</style>
<script language="JavaScript" src="includes/view.js"></script>

<script type="text/javascript">
// debugger;
    var segmentList = [];
    var segmentFieldMap = {};
    var masterFields = {};
    var tenantPrefixList = {};

	var modifiedFieldList = {};  // list of fields being modified

	var templateType = '${esapi:encodeForJavaScript(templateType)}';

    // common segments
    <c:set var="tenantOrgNodeId" value="-1"/>
	tenantPrefixList["${tenantOrgNodeId}"] = "";
	segmentList.push({section: "S${tenantOrgNodeId}", desc: "<fmt:message key="fcm.preferences.gridTemplate.allFieldsOfSystem.txt" />"});
    <c:forEach var="segment" items="${activityType.segmentDescriptions}">
    	segmentList.push({section: "S${tenantOrgNodeId}", id: "${segment.id}", desc: "${segment.acronym} - ${esapi:encodeForJavaScript(segment.description)}"});
    	segmentFieldMap["${segment.id}"] = [];
    </c:forEach>

<!-- c:if test="${templateType ne 'XAMS'}" //RAPTOR-2187 -->
	<c:set var="tenant" value=""/>
    <c:forEach var="segment" items="${activityType.flexSegmentDescriptions}">
    	<c:if test="${callCenterType == 'T'}">
    		<c:set var="tenant" value="[${esapi:encodeForJavaScript(segment.tenantOrgNodeLabel)}] "/>
     	</c:if>
    	<c:if test="${tenantOrgNodeId ne segment.tenantOrgNodeId}">
	    	tenantPrefixList["${segment.tenantOrgNodeId}"] = "${tenant}";
	    	<c:choose>
	    	<c:when test="${callCenterType == 'P'}">
		 		segmentList.push({section: "S${segment.tenantOrgNodeId}", desc: "<fmt:message key="fcm.preferences.gridTemplate.allFieldsOfTenant.txt"/>"});
	     	</c:when>
	    	<c:when test="${callCenterType == 'T'}">
		 		segmentList.push({section: "S${segment.tenantOrgNodeId}", desc: "<fmt:message key="fcm.preferences.gridTemplate.allFieldsOfTenant.txt.fmt"><fmt:param>${tenant}</fmt:param></fmt:message>"});
	     	</c:when>
	     	</c:choose>
	    	<c:set var="tenantOrgNodeId" value="${segment.tenantOrgNodeId}"/>
 		</c:if>

    	segmentList.push({section: "S${tenantOrgNodeId}", id: "${segment.id}", desc: "${tenant}${segment.prefixAlt} - ${esapi:encodeForJavaScript(segment.description)}"});
    	segmentFieldMap["${segment.id}"] = [];
    </c:forEach>
<!-- /c:if -->

    <c:forEach var="fieldDef" items="${activityType.unSelectedFieldDefinitions}">
<!--  c:if test="${templateType ne 'XAMS' or empty fieldDef.tenantOrgNodeId}" //RAPTOR-2187 -->

    segmentFieldMap["${fieldDef.segmentId}"].push("f${fieldDef.id}");
    masterFields["f${fieldDef.id}"] = {
      	  id: ${fieldDef.id},
           segmentId: ${fieldDef.segmentId},
           name: "${esapi:encodeForJavaScript(fieldDef.practicalName)}",
           desc: "${esapi:encodeForJavaScript(fieldDef.desc)}",
			  alignment: "${esapi:encodeForJavaScript(fieldDef.alignment)}",
           label: "${esapi:encodeForJavaScript(fieldDef.label)}",
           labelDesc: "${esapi:encodeForJavaScript(fieldDef.labelDesc)}",
           dataPopEnabled: ${fieldDef.dataPopEnabled},
           dataPopAvailable: ${fieldDef.dataPopAttrValue == null or fieldDef.dataPopAttrValue == ""  ? false : true},
           selected: ${fieldDef.selected},
           permanentSelected: ${fieldDef.permanentSelected},
           order: ${fieldDef.order},
           version: ${fieldDef.gridConfigVersion},
           supInfo: "<sfmfmt:formatGridFieldSupplementalInfo value="${fieldDef}" timeZone="${userTimeZone}" />",
           tenantOrgNodeId: ${fieldDef.tenantOrgNodeId ==null ? -1 : fieldDef.tenantOrgNodeId}
    };
<!-- /c:if -->
    </c:forEach>

	var selectedFieldList = [];
    <c:forEach var="fieldDef" items="${activityType.selectedFieldDefinitions}">
    selectedFieldList.push("f${fieldDef.id}");
    segmentFieldMap["${fieldDef.segmentId}"].push("f${fieldDef.id}");
    masterFields["f${fieldDef.id}"] = {
   		 id: ${fieldDef.id},
          segmentId: ${fieldDef.segmentId},
          name: "${esapi:encodeForJavaScript(fieldDef.practicalName)}",
          desc: "${esapi:encodeForJavaScript(fieldDef.desc)}",
			 alignment: "${esapi:encodeForJavaScript(fieldDef.alignment)}",
          label: "${esapi:encodeForJavaScript(fieldDef.label)}",
          labelDesc: "${esapi:encodeForJavaScript(fieldDef.labelDesc)}",
          dataPopEnabled: ${fieldDef.dataPopEnabled},
           dataPopAvailable: ${fieldDef.dataPopAttrValue == null or fieldDef.dataPopAttrValue == ""  ? false : true},
          selected: ${fieldDef.selected},
          permanentSelected: ${fieldDef.permanentSelected},
          order: ${fieldDef.order},
          version: ${fieldDef.gridConfigVersion},
          supInfo: "<sfmfmt:formatGridFieldSupplementalInfo value="${fieldDef}" timeZone="${userTimeZone}" />",
          tenantOrgNodeId: ${fieldDef.tenantOrgNodeId ==null ? -1 : fieldDef.tenantOrgNodeId}
    };
    </c:forEach>

   var editMetadata = {
<c:if test="${templateType eq 'ANALYST' }">
   	6:'textfield',
   	7:'textarea'
</c:if>
<c:if test="${templateType ne 'ANALYST' and xmlEditable}">
		4:'textfield'
</c:if>
    };

    $(document).ready(function(){
        var $s = $("#segmentFilter");
        for(var i=0; i < segmentList.length; i++)
        {

         	if ( segmentList[i].id )
        		$s.append($("<option>").attr("value", segmentList[i].id).text(segmentList[i].desc));
        	else
        		$s.append($("<option>").attr("value", segmentList[i].section).text(segmentList[i].desc).css("font-weight", "bold"));
        }
	    $s.prop("selectedIndex", 1).change();

	    loadSelectedFieldsTable(selectedFieldList, "${esapi:encodeForJavaScript(templateType)}");

	   	$('#availableTable').mousedown({'templateType': templateType}, selectFieldHandler);
	   	$('#selectedTable').mousedown(editMetadata,saveEdits)
	   	 							.mousedown(editMetadata,makeEditable)
	   	 							.mousedown({'templateType': templateType}, unselectFieldHandler);
    });

</script>

<div>
<%-- TODO: Error handling code --%>
<c:url var="reloadURL" value="/preference.sj?method=viewPreferencesTree&grid_templateId=${esapi:encodeForURL(activityType.gridTemplateId)}&grid_accountId=${esapi:encodeForURL(activityType.accountTypeId)}&grid_activityId=${activityType.id}" />
<tiles:insert page="/admin/adminDetailErrorHandling.jsp" flush="true">
	<tiles:put name="reloadURL" value="${reloadURL}" />
	<tiles:put name="refreshURL" value="${reloadURL}&refresh=true" />
	<tiles:put name="objectTypeName" value="Grid Activity" />
</tiles:insert>

<%-- defines row templates --%>
<div style="display:none"><table>
	<tr id="availableRowClone" style="cursor:pointer" onmousedown="highlightRowById(this,'rowSelected')">
		<td class="imageTableCell"></td><%-- num --%>
		<td class="imageTableCell"></td><%-- segID --%>
		<td class="textTableCell"></td><%-- name --%>
		<td class="textTableCell"></td><%-- desc --%>

	<c:if test="${templateType eq 'ANALYST' }">
		<td class="textTableCell"></td><%-- alignment --%>
		<%-- datapop --%>
		<td class="textTableCell">
			<input type='checkbox' name='datapop' disabled='disabled' onchange='saveModifiedFieldChange(this);'/>
		</td>
		<td class="textTableCell editable"></td><%-- field label --%>
		<td class="textTableCell editable" ></td><%-- field label desc --%>
	</c:if>
	<c:if test="${templateType ne 'ANALYST'}">
		<td class="textTableCell ${xmlEditable ? 'editable' : '' }"></td><%-- field label --%>
	</c:if>

	<c:if test="${updatePrefs}">
		<td class="textTableCell lastCol"><img src='admin/images/arrowDownAdd.gif' alt="<fmt:message key='fcm.preferences.content.select.txt'/>" name="moveField"/></td>
	</c:if>
	<c:if test="${!updatePrefs}">
		<td class="textTableCell lastCol"><img src='admin/images/arrowDownAdd_disabled.gif' alt="<fmt:message key='fcm.preferences.content.noSelect.txt'/>" /></td>
	</c:if>
	</tr>

    <tr id="selectedRowClone"  style="cursor:pointer;" onmousedown="highlightRowById(this,'rowSelected');">
		<td class="imageTableCell"></td><%-- num --%>
		<td class="imageTableCell"></td><%-- segID --%>
		<td class="textTableCell"></td><%-- name --%>
		<td class="textTableCell"></td><%-- desc --%>

	<c:if test="${templateType eq 'ANALYST' }">
    	<td class="textTableCell">
        	<select name='alignment' class="famSelect" onchange="saveModifiedFieldChange(this);">
                <option value="left"><fmt:message key='fcm.preferences.gridTemplate.fieldAlignment.left.txt'/></option>
                <option value="center"><fmt:message key='fcm.preferences.gridTemplate.fieldAlignment.center.txt'/></option>
                <option value="right"><fmt:message key='fcm.preferences.gridTemplate.fieldAlignment.right.txt'/></option>
        	</select>
    	</td>
    	<td nowrap class="textTableCell">
            <input type='checkbox' name='datapop' onchange="saveModifiedFieldChange(this);"/>
    	</td>
		<td class="textTableCell editable"></td><%-- field label --%>
		<td class="textTableCell editable" ></td><%-- field label desc --%>
	</c:if>
	<c:if test="${templateType ne 'ANALYST' }">
		<td class="textTableCell ${xmlEditable ? 'editable' : '' }"></td><%-- xml label --%>
	</c:if>

	    <td class="textTableCell lastCol">
	        <c:choose>
	        <c:when test="${!updatePrefs}">
	            <img src="admin/images/ArrowUpRemove_disabled.gif" ALT="<fmt:message key='fcm.preferences.content.noRemove.txt'/>" >
	        </c:when>
	        <c:otherwise>
	            <img style="display:none" name="moveField" src="admin/images/arrowUpRemove.gif" ALT="<fmt:message key='fcm.preferences.content.remove.txt'/>" >
	            <img style="display:none" name="noMoveField" src="admin/images/ArrowUpRemove_disabled.gif" ALT="<fmt:message key='fcm.preferences.content.noRemove.txt'/>" >
	        </c:otherwise>
	        </c:choose>
	   </td>
	</tr>
</table></div>

<%--  top table  --%>
<div style="margin-left:5px;margin-right:5px;width:98%">
<table border="0" cellspacing="0" cellpadding="0" style="width:100%">

	<tr align="left" valign="top" >
		<td class="configurationTableSectionNoHover" style="padding:5px;">${esapi:encodeForHTML(activityType.name)}</td>
	</tr>
	<tr>
		<td valign="top" align="left">
			<table class="mainTable" cellpadding="0" cellspacing="0" border="0" style="width:100%">
				<tr valign="top" >
					<th width="70%" align="left" valign="top" class="configurationTableTitle" style="margin-top:20px;white-space:nowrap">
						<span style="white-space:nowrap"><fmt:message key="fcm.preferences.gridTemplate.activityFields.txt"/></span>
                        <select id="segmentFilter" name="segments" class="famSelect" onChange="showAvailableFieldsBySegment('availableTable',this.value, segmentFieldMap, segmentList, '${esapi:encodeForJavaScript(templateType)}');" style="margin:2px;">
                        </select>
					</th>
					<th width="30%" align="right" valign="top" class="configurationTableTitle" style="margin-top:20px;white-space:nowrap">&nbsp;
						<c:if test="${templateType eq 'ANALYST'}">
							<span style="white-space:nowrap"><fmt:message key="fcm.preferences.gridTemplate.activityTabName.txt"/></span>
							<input type="text" class="famTextEntry" value="${esapi:encodeForHTMLAttribute(activityType.name)}" maxlength="12" onchange="$('#activityName').val(this.value);"/>
						</c:if>
					</th>
				</tr>
				<tr align="left" valign="top" >
	                <td colspan="2" class="configurationTableSectionNoHover" style="padding:5px;"><fmt:message key="fcm.preferences.gridTemplate.availableCols.txt" /></td>
				</tr>
				<tr align="left" valign="top">
					<td colspan="2" style="padding:0px;">
						<div id="collapseDiv1" style="display:inline">
						<%-- main content -- scroll bar and content --%>
						<table align="center" border="0" cellspacing="0" cellpadding="0" width="100%">
							<tr>
								<td style="padding:0px;">
									<div id="availableDiv" class="preferencesGrid" onscroll="repositionTHs(this)">
									<table id="availableTable" cellspacing="0"  cellpadding="0"  class="mainTable"  style="border:none;border-collapse:separate;width:100%" >
										<thead>
											<tr class="tableColumnHeaderRow">
												<c:if test="${templateType eq 'ANALYST'}">
													<th nowrap width="5%" class="centeredTableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.count.header.title" /></th>
                                                	<th nowrap width="5%" class="centeredTableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.segmentId.header.title" /> &nbsp;</th>
													<th nowrap width="15%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.columnName.header.title" /> &nbsp;</th>
													<th nowrap width="20%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.colDescription.header.title" /> &nbsp;</th>
													<th nowrap width="10%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.alignment.header.title" /> &nbsp;</th>
													<th nowrap width="6%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.dataPop.header.title" /> &nbsp;</th>
													<th nowrap width="15%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.columnLabel.header.title" /> &nbsp;</th>
													<th nowrap width="20%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.labelDescription.header.title" /> &nbsp;</th>
												</c:if>

        										<c:if test="${templateType ne 'ANALYST'}">
													<th nowrap width="5%" class="centeredTableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.count.header.title" /></th>
													<th nowrap width="5%" class="centeredTableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.segmentId.header.title" /> &nbsp;</th>
													<th nowrap width="20%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.columnName.header.title" /> &nbsp;</th>
													<th nowrap width="45%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.colDescription.header.title" /> &nbsp;</th>
													<th nowrap width="20%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.xmlName.header.title" /> &nbsp;</th>
        										</c:if>

												<th nowrap class="tableHeader" style="min-width:35px;border-top:none;border-right:none; cursor:pointer;">
                                                <c:choose>
                                                    <c:when test="${!updatePrefs}">
                                                        <img src="admin/images/ArrowDownAddAll_disabled.gif" ALT="<fmt:message key='fcm.preferences.content.selectNone.txt'/>" />
                                                    </c:when>
                                                    <c:otherwise>
                                                        <img src="admin/images/arrowDownAddAll.gif" ALT="<fmt:message key='fcm.preferences.content.selectAll.txt'/>" onclick="selectAllFields('${esapi:encodeForJavaScript(templateType)}');" />
                                                    </c:otherwise>
                                                </c:choose>
											    </th>
											 </tr>
										</thead>

										<tbody id="availableTableBody">

										</tbody>
									</table>
									</div>
								</td>
							</tr>
						</table>
						<%--  end available main content -- only content, no up/down arrow  --%>
						</div>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td valign="top" align="left">
	<div class="configurationTableNote" style="margin-top:8px">
		(<fmt:message key="fcm.preferences.content.ordering.txt" />)
	</div>
		</td>
	</tr>
	<tr>
		<td valign="top" align="left">
	<table border="0" cellspacing="0" cellpadding="0" style="width:100%">
	    <tr>
	        <td valign="top" align="left">

	<%--  main content header  --%>
	        <table class="mainTable"  cellpadding="0" cellspacing="0" border="0" style="width:100%">
	            <tr align="left" valign="top" >
	                <td class="configurationTableSectionNoHover" style="padding:5px;"><fmt:message key="fcm.preferences.content.selectedCols.txt" /></td>
	            </tr>

	            <tr>
	                <td style="padding:0px;">
	                    <div id="collapseDiv2" style="display:inline">
	                    <%--  main content -- up/down and content  --%>

	                    <table align="center" border="0" cellspacing="0" cellpadding="0" width="100%">
	                        <tr>
	                            <td style="padding:0px">
	                                <div id="selectedDiv" class="preferencesGrid" onscroll="repositionTHs(this)">

	                                <%--  main content header  --%>
	                                <table id="selectedTable" cellspacing="0"  cellpadding="0"  class="mainTable"  style="border:none;border-collapse:separate;width:100%"  >
	                                    <thead>
	                                        <tr class="tableColumnHeaderRow">

	                                            <c:if test="${templateType eq 'ANALYST'}">
		                                            <th nowrap width="5%" class="centeredTableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.order.header.title" /> </th>
		                                            <th nowrap width="5%" class="centeredTableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.segmentId.header.title" /> &nbsp;</th>
		                                            <th nowrap width="15%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.columnName.header.title" /> &nbsp;</th>
		                                            <th nowrap width="20%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.colDescription.header.title" /> &nbsp;</th>
	                                            	<th nowrap width="10%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.alignment.header.title" /> &nbsp;</th>
	                                            	<th nowrap width="6%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.dataPop.header.title" /> &nbsp;</th>
	                                            	<th nowrap width="15%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.columnLabel.header.title" /> &nbsp;</th>
	                                            	<th nowrap width="20%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.labelDescription.header.title" /> &nbsp;</th>
	                                            </c:if>

	        									<c:if test="${templateType ne 'ANALYST'}">
		                                            <th nowrap width="5%" class="centeredTableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.order.header.title" /> </th>
		                                            <th nowrap width="5%" class="centeredTableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.segmentId.header.title" /> &nbsp;</th>
		                                            <th nowrap width="20%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.columnName.header.title" /> &nbsp;</th>
		                                            <th nowrap width="45%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.colDescription.header.title" /> &nbsp;</th>
	        										<th nowrap width="20%" class="tableHeader" style="border-top:none;"><fmt:message key="fcm.preferences.content.xmlName.header.title" /> &nbsp;</th>
	        									</c:if>

	                                            <th nowrap class="tableHeader" style="min-width:20px;border-top:none;border-right:none; cursor:pointer;">
	                                                <c:choose>
	                                                    <c:when test="${!updatePrefs}">
	                                                        <img src="admin/images/ArrowUpRemoveAll_disabled.gif" ALT="<fmt:message key='fcm.preferences.content.removeNone.txt'/>" />
	                                                    </c:when>
	                                                    <c:otherwise>
	                                                        <img src="admin/images/arrowUpRemoveAll.gif" onclick="unselectAllFields('${esapi:encodeForJavaScript(templateType)}');" alt="<fmt:message key='fcm.preferences.content.removeAll.txt'/>" />
	                                                    </c:otherwise>
	                                                </c:choose>
	                                            </th>
	                                        </tr>
	                                    </thead>

	                                    <tbody id="selectedTableBody">
	                                    </tbody>
	                                </table>
	                                <%--  end main content  --%>

	                                </div>
	                            </td>
	                        </tr>
	                    </table>

	                    <%--  end selected main content --  content, up/down arrow  --%>
	                    </div>

	                </td>
	            </tr>
	        </table>
	<%--  end main content header  --%>
	        </td>
	        <%-- With Analyst Grids, the RQO ALT date/time fields are always the first two and cannot be moved --%>
	        <c:set var="moveStartRow" value="${templateType == 'ANALYST' ? 3 : 1 }"/>
	        <td valign="top" align="right">
	            <a title="<fmt:message key='fcm.preferences.content.moveToTop.txt'/>" href="javascript:customMove('selectedDiv','selectedTable',${moveStartRow},'top')" ><img src="common/images/arrow-up-end-default.gif" width="11" height="14" border="0" vspace="2" hspace="2"></a><br />
	            <a title="<fmt:message key='fcm.preferences.content.moveUp.txt'/>" href="javascript:customMove('selectedDiv','selectedTable',${moveStartRow},'up')"><img src="common/images/arrow-up-default.gif" width="11" height="12" border="0" vspace="2" hspace="2"></a><br />
	            <a title="<fmt:message key='fcm.preferences.content.moveDown.txt'/>" href="javascript:customMove('selectedDiv','selectedTable',${moveStartRow},'down')"><img src="common/images/arrow-down-default.gif" width="11" height="12" border="0" vspace="2" hspace="2"></a><br />
	            <a title="<fmt:message key='fcm.preferences.content.moveToBottom.txt'/>" href="javascript:customMove('selectedDiv','selectedTable',${moveStartRow},'bottom')"><img src="common/images/arrow-down-end-default.gif" width="11" height="14" border="0" vspace="2" hspace="2"></a>
	        </td>
	    </tr>
	</table>
		</td>
	</tr>
	<tr>
		<td valign="top" align="left">
	<table border="0" cellspacing="0" cellpadding="0" style="width:100%;margin-top:20px" >
		<tr>
			<td>

<form id="gridActivityTypeForm" name="gridActivityTypeForm" action="<c:url value='/gridActivityType.sj'/>" method="post" onsubmit="return submitGridActivityTypeForm(this);" >
<input type="hidden" name="method" value="saveActivityType">
<input type="hidden" name="id" value="${activityType.id}">
<input type="hidden" name="version" value="${activityType.version}">
<input type="hidden" name="gridTemplateId" value="${activityType.gridTemplateId}">
<input type="hidden" name="accountTypeId" value="${activityType.accountTypeId}">
<input type="hidden" name="activityTypeId" value="${activityType.id}">
<input type="hidden" name="templateType" value="${templateType}">
<input id="activityName" type="hidden" name="name" value="${esapi:encodeForHTMLAttribute(activityType.name)}"/>

				<table cellpadding="0" cellspacing="0" border="0" style="border:1px solid #c6cad0; background-color: #e0e2e5;width:100%">
					<tr class="configurationTableDataRow">
						<td style="padding:5px; text-align: left;width:50%;">
							<span style="font-weight: bold;color: #353535;"><fmt:message key="fcm.preferences.fieldPropagation.txt"/>:</span>
							<label><input type="radio" name="fieldPropagationPolicy" value="GRID" onclick="$('#fieldChangesConfiguration').show()"><fmt:message key="fcm.preferences.fieldPropagation.Grid.txt"/></label>
							<label><input type="radio" name="fieldPropagationPolicy" value="ACCT_TYPE" onclick="$('#fieldChangesConfiguration').show()"><fmt:message key="fcm.preferences.fieldPropagation.AccountType.txt"/></label>
							<label><input type="radio" name="fieldPropagationPolicy" value="TXN_ACTIVITY" checked="checked" onclick="$('#fieldChangesConfiguration').hide()"> <fmt:message key="fcm.preferences.fieldPropagation.None.txt"/></label>
						</td>
						<td id="fieldChangesConfiguration" style="display:none; text-align: left;width:50%;">
							<span style="font-weight: bold;color: #353535;"><fmt:message key="fcm.preferences.propagateFieldChanges.txt"/>:</span>
						<c:if test="${templateType eq 'ANALYST' or xmlEditable}">
							<label><input type="checkbox" name="propagateFieldEdits" value="true" checked="checked"><fmt:message key="fcm.preferences.propagateFieldEdits.txt"/></label>
						</c:if>
							<label><input type="checkbox" name="propagateFieldSelections" value="true" checked="checked"><fmt:message key="fcm.preferences.propagateFieldSelections.txt"/></label>
							<label><input type="checkbox" name="propagateFieldDeselections" value="true" checked="checked"><fmt:message key="fcm.preferences.propagateFieldDeselections.txt"/></label>
						</td>
					</tr>
				</table>
</form>
			</td>
		</tr>
	</table>
		</td>
	</tr>
</table>
</div>

</div>
<script type="text/javascript">
<c:if test="${not empty fieldPropagationPolicy}">
	$(':radio[name="fieldPropagationPolicy"][value="${fieldPropagationPolicy}"]').click();
</c:if>
<c:if test="${not empty propagateFieldEdits}">
	$(':checkbox[name="propagateFieldEdits"]').prop('checked',${propagateFieldEdits});
</c:if>
<c:if test="${not empty propagateFieldSelections}">
	$(':checkbox[name="propagateFieldSelections"]').prop('checked',${propagateFieldSelections});
</c:if>
<c:if test="${not empty propagateFieldDeselections}">
	$(':checkbox[name="propagateFieldDeselections"]').prop('checked',${propagateFieldDeselections});
</c:if>
</script>

<c:if test="${!updatePrefs}">
  <script language="JavaScript">
    setFormsReadOnly();
  </script>
</c:if>
