<%@ page contentType="text/html; charset=UTF-8" %>
<%@ include file="/common/taglibs.jsp" %>

<style type="text/css">@import "common/styles/cf.css";</style>
<style type="text/css">@import "admin/styles/admin.css";</style>

<script language="JavaScript" src="admin/scripts/listboxAssignments.js"></script>
<script language="JavaScript" src="admin/scripts/admin.js"></script>

<script language="JavaScript">
//<!--
	// alert("ok");
	var submitFormAlerts = new Array();
	submitFormAlerts.push("<fmt:message key='fcm.notification.jsp.submitForm.alert0.txt' />");
	submitFormAlerts.push("<fmt:message key='fcm.notification.jsp.submitForm.alert1.txt' />");


   var _teams = new Array();
   var _teamMap = new Array();
   var _userList = new Array();
   // alert("Loading teams");
   <c:forEach var="team" items="${teams}">
      var teamName = '${esapi:encodeForJavaScript(team.groupName)}' + ' - ' + '${esapi:encodeForJavaScript(team.name)}';
      _teams.push(teamName);
      _teamMap['${team.id}'] = teamName;
   </c:forEach>

   // alert("loading users");
   <c:if test="${activeUsers != null}">
      <c:forEach var="user" items="${activeUsers}">
         var user = new Object();
         user.id = '${user.id}';
         user.teamId = "${user.teamId}";
         // find if the user is assigned to a team
         if(user.teamId != "" && isDefined(_teamMap[user.teamId]))
         {
            user.teamName = _teamMap[user.teamId];
            user.isAssigned = false;
            // alert("user Assigned");
         }
         else
         {
            user.isAssigned = false;
            user.teamName = '';
         }
         user.label = "${esapi:encodeForJavaScript(esapi:encodeForHTML(user.lastName))}, ${esapi:encodeForJavaScript(esapi:encodeForHTML(user.firstName))}";
         user.text = "(${esapi:encodeForJavaScript(esapi:encodeForHTML(user.username))})";
         <c:choose>
            <c:when test="${not empty user.teamId}">
               var userTeam = _teamMap['${esapi:encodeForJavaScript(user.teamId)}'];
               if(isDefined(userTeam))
               {
                  user.text += " Member of the " + userTeam;
               }
               else
               {
               	user.label = "- "+user.label;
                  user.text += ' Not a member of any group/team';
               }
            </c:when>
            <c:otherwise>
            	user.label = "- "+user.label;
               user.text += ' Not a member of any group/team';
            </c:otherwise>
      </c:choose>
         _userList.push(user);
      </c:forEach>
   </c:if>

   function submitForm(alertList)
   {
      var formObj = document.notificationsForm;
      if(!validateNotEmpty($i18n("fcm.notification.js.message.txt"), formObj.messageText.value))
      {
         formObj.messageText.select();
         formObj.messageText.focus();
         return;
      }
      if(!validateDescriptionLength(formObj.messageText.value, 2000))
      {
        alert(alertList[0]);
         formObj.messageText.select();
         formObj.messageText.focus();
         return;
      }
      // Check to see if there is at least one recipient
      var recipientExists = false;
      for(var i =0; i < _userList.length; i++)
      {
         if(_userList[i].isAssigned)
         {
            recipientExists = true;
            break;
         }
      }
      if(!recipientExists)
      {
         alert(alertList[1]);
         return;
      }
      postAssignedUsers();
      //setBusyDetail();
//      formObj.saveButton.disabled = true;
      formObj.submit();
      //subForm(formObj);

   }

   function postAssignedUsers()
   {
      var elem = document.createElement("input");
      elem.type = "hidden";
      elem.name = "users";

      var userIds = "";
      for(var i =0; i < _userList.length; i++)
      {
         if(_userList[i].isAssigned)
         {
            userIds += _userList[i].id + ",";
         }
      }
      elem.value = userIds;
      document.notificationsForm.appendChild(elem);
   }

   function showUnassignedRepsByTeam(lbx,selectedTeam, list)
   {
      var valueArray = new Array();
      var labelArray = new Array();

      if(selectedTeam == "NONE")// show all unassigned reps
      {
         loadListboxByAssignment(list,lbx.parentNode.id,false);
      }
      else
      {
         for(var i = 0, len = _userList.length; i < len; i++)
         {
            if(!list[i].isAssigned && list[i].teamName == selectedTeam)
            {
               labelArray.push(list[i].label);
               valueArray.push(i);
            }
         }
         loadListbox(lbx.parentNode.id,valueArray,labelArray);

         // select all members for this team by default
         // to do this we have to get a "fresh" reference to the listbox
         // since it was just repopulated using innerHTML
         for(var i = 0; i < document.forms.length; i++)
         {//which form is it?
            if(document.forms[i].elements[lbx.name])
               lbx = document.forms[i].elements[lbx.name];
         }
         // select all options
         for(var i = 0; i < valueArray.length; i++)
            lbx.options[i].selected = true;
      }

   }

   // Reset selection on the listbox which was previously selected
   // E.g. if the user pciked an option on the right listbox the left side
   // selection is cleared
   function resetSelectionAndDesc(listBoxToReset)
   {
      listBoxToReset.selectedIndex = -1;
      hideDescription();
   }

   function showDescriptionLocal(anchor, srcArrayListName )
   {
      // the selected list could be either from unassigned or assigned users
      // try them both
      var assignedUsers = document.getElementById('assignedUsersList');
      showDescription(anchor, srcArrayListName, assignedUsers);
      var unassignedUsers = document.getElementById('unassignedUsersList');
      showDescription(anchor, srcArrayListName, unassignedUsers);

   }
//-->
</script>


<!-- Main Content -->

<div style="margin:10 10 10 10" align="center">
	<tiles:insert definition="fcmSystemMessages" flush="true"/>
</div>

<form name="notificationsForm" action="a_notifications.sj" method="post">
<input type="hidden" name="method" value="saveNotification">
<input type="hidden" name="selectedTab" value="${esapi:encodeForHTMLAttribute(selectedTab)}">

<%@ include file="descriptionWindow.html" %>
<script>document.getElementById("descriptionWindowTextArea").style.height="200px";</script>

<div>

<table id="notificationDefinitionTable"  class="configurationTable minWidthConfigTable"
   style="width:600px;margin-left:5px"
    border="0" cellspacing="0" cellpadding="0">
    <tr align="left" valign="top" >
      <td colspan="3" class="configurationTableSectionNoHover" style="padding:5px;"><fmt:message key="fcm.notification.definition.txt" /></td>
    </tr>
   <tr class="configurationTableDataRow" ><td colspan="2">&nbsp;</td></tr>
   <tr class="configurationTableDataRow" valign="top">
      <td scope="col"> <fmt:message key="fcm.notification.message.txt" /> </td>
      <td valign="middle" scope="col" style="padding-right:10px">
      	<textarea class="famTextEntry" name="messageText" cols="70" rows="8" wrap="PHYSICAL" onKeyDown="limitChars(this,1000);" onKeyUp="limitChars(this,1000,true);" ></textarea>
      	<br>&nbsp;
      </td>
   </tr>
   <tr>
      <td align="left" colspan="2" class="configurationTableSectionNoHover" style="padding:5px;"> <fmt:message key="fcm.notification.representatives.txt" />  </td>
   </tr>
   <tr class="configurationTableDataRow" align="left" valign="top">
      <td colspan="2">
         <div id="repGrid" style="display:block">
            <table border ="0" width="90%" border="0" cellpadding="0" cellspacing="0" >
               <tr class="configurationTableDataRow">
                  <td colspan="3" align="left">
                     <b style="margin:2px;"> <fmt:message key="fcm.notification.filter.txt" /> </b><br>
                     <select name="teams" class="famSelect" onChange="showUnassignedRepsByTeam(document.notificationsForm.unassignedUsersList,document.notificationsForm.teams.options[slbx.selectedIndex].value, _userList);" style="width:27em;margin:2px;">
                        <option value="NONE" selected> <fmt:message key="fcm.notification.allRepresentative.txt" /> </option>
                     </select>
                  </td>
                  <!-- <td>&nbsp;</td> -->
               </tr>
               <tr class="configurationTableDataRow">
               <td align="left" valign="bottom" width="25%" >
                  <b style="margin:2px;"> <fmt:message key="fcm.notification.selectFrom.txt" /> </b><br/>
                  <div id="unassignedUsers" style="display:inline">
                     <select name="unassignedUsersList" class="famSelect" size="15" style="width:17em;margin:2px;"
                     multiple="multiple" onChange="resetSelectionAndDesc(document.notificationsForm.assignedUsersList);">
                     </select>
                  </div>
               </td>
               <td align ="center" valign="middle" width="5%">
                  <p align="center"><br/>
                     <a href="javascript:moveSelectedOptions(document.notificationsForm.unassignedUsersList,document.notificationsForm.assignedUsersList,true,_userList);
                        javascript:showUnassignedRepsByTeam(document.notificationsForm.unassignedUsersList,document.notificationsForm.teams.options[slbx.selectedIndex].value, _userList);" 
                        title="">
<!--                     	<img src="common/images/ArrowRightAdd.gif" width="16" height="16" border="0"> -->
                      	<span class="sapUiBtnIco sapUiBtnIcoL sapUiIcon" style="font-family: sas-icons" data-sap-ui-icon-content="&#xf039;"></span>
                     </a>
                     <br />
                     <a href="javascript:moveAllOptions(document.notificationsForm.unassignedUsersList,document.notificationsForm.assignedUsersList,true,_userList);
                              javascript:showUnassignedRepsByTeam(document.notificationsForm.unassignedUsersList,document.notificationsForm.teams.options[slbx.selectedIndex].value, _userList);"
                              title="">
<!--                        <img src="common/images/ArrowRightAddAll.gif" width="16" height="16" border="0"> -->
                      	<span class="sapUiBtnIco sapUiBtnIcoL sapUiIcon" style="font-family: sas-icons" data-sap-ui-icon-content="&#xf038;"></span>
                     </a>
                     <br/>
                     <br />
                     <a href="javascript:moveSelectedOptions(document.notificationsForm.assignedUsersList,document.notificationsForm.unassignedUsersList,false,_userList);
                              javascript:showUnassignedRepsByTeam(document.notificationsForm.unassignedUsersList,document.notificationsForm.teams.options[slbx.selectedIndex].value, _userList);"
                              title="">
<!--                        <img src="common/images/ArrowLeftRemove.gif" width="16" height="16" border="0"> -->
                      	<span class="sapUiBtnIco sapUiBtnIcoL sapUiIcon" style="font-family: sas-icons" data-sap-ui-icon-content="&#xf037;"></span>
                     </a>
                     <br />
                     <a href="javascript:moveAllOptions(document.notificationsForm.assignedUsersList,document.notificationsForm.unassignedUsersList,false,_userList);
                              javascript:showUnassignedRepsByTeam(document.notificationsForm.unassignedUsersList,document.notificationsForm.teams.options[slbx.selectedIndex].value, _userList);"
                              title="">
<!--                        <img src="common/images/ArrowLeftRemoveAll.gif" width="16" height="16" border="0"> -->
                      	<span class="sapUiBtnIco sapUiBtnIcoL sapUiIcon" style="font-family: sas-icons" data-sap-ui-icon-content="&#xf036;"></span>
                     </a>
                     <br/>
                     <br />
                  </p>
               </td>
               <td align="left" valign="top" width="70%">
                  <b style="margin:2px;"> <fmt:message key="fcm.notification.selectTo.txt" /> </b><br/>
                  <div id="assignedUsers" style="display:inline">
                     <select id="assignedUsersList" class="famSelect" size="15" style="width:17em;margin:2px;" multiple="multiple"
                     onChange="resetSelectionAndDesc(document.notificationsForm.unassignedUsersList);">
                     </select>
                  </div>
                  <script>
                     slbx = document.notificationsForm.teams;
                     for(i=0; i < _teams.length; i++)
                     {
                        slbx.options[slbx.options.length]=new Option(_teams[i],_teams[i]);

                     }
                     loadListboxByAssignment(_userList,'unassignedUsers',false);
                     loadListboxByAssignment(_userList,'assignedUsers',true);
                  </script>
               </td>
            </tr>
            <tr>
            	<td colspan="3" style="text-align:left">&nbsp; <fmt:message key="fcm.notification.indicates.txt" />  </td>
            </tr>
           <tr><td>&nbsp;</td></tr>
         </table>
       </div>
     </td>
   </tr>

   <tr>
      <td valign="top" colspan="2" class="configurationTableSectionNoHover" style="text-align:right;padding:5px 10px;">

      <button class="cfSectionBtn sapMBarChild sapMBtn sapMBtnBase sasMButton" type="button" onclick="submitForm(submitFormAlerts)">
		<span class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMBtnText sapMFocusable sapMIE">
    		<span class="sapMBtnContent"><fmt:message key="fcm.notification.sendNotification.txt" /></span>
    		<span class="sapMBtnFocusDiv"></span>
  		</span>
	  </button>
      </td>
   </tr>

      <%-- ---------------------------- End Rep ----------------------------- --%>


</table>
</div>

</form>

<c:if test="${not empty createNotification && !createNotification}">
   <script language="JavaScript">
      setFormsReadOnly();
   </script>
</c:if>
