<%@ page contentType="text/html; charset=UTF-8" %>
<%@ include file="/common/taglibs.jsp" %>


<c:if test="${enableHTML}">
<script type="text/javascript" src="common/scripts/jHtmlArea-0.8.js"></script>
<script type="text/javascript" src="common/scripts/jquery-ui.js"></script>
<link rel="stylesheet" type="text/css" href="common/styles/jHtmlArea.css" />
<link rel="stylesheet" type="text/css" href="common/styles/jquery-ui.css"/>

<style type="text/css">
@import "common/styles/jHtmlArea-sas.css";

.ui-dialog .ui-dialog-titlebar-close {
	background: url(common/images/closeX.gif);
}
</style>

<script type="text/javascript">

	function selectHtmlMemo()
	{
		var memo = _memos[event.target.selectedIndex];
		$("#memoText").htmlarea("html", memo);
	}

	$(document).ready(function() {
		$("#memoTemplateID").unbind("change").change(selectHtmlMemo);

        $("#memoText").htmlarea({
	    	//  toolbar: ["html", "|", "link", "unlink"],
        	toolbar: ["link", "unlink"],
        	toolbarText: $.extend({}, jHtmlArea.defaultOptions.toolbarText, {
	        	html:   "<esapi:encodeForJavaScript><fmt:message key="jhtmlarea.toolbar.tooltip.html.txt"/></esapi:encodeForJavaScript>",
				link: 	"<esapi:encodeForJavaScript><fmt:message key="jhtmlarea.toolbar.tooltip.insertLink.txt"/></esapi:encodeForJavaScript>",
				unlink: "<esapi:encodeForJavaScript><fmt:message key="jhtmlarea.toolbar.tooltip.unlink.txt"/></esapi:encodeForJavaScript>"
		    }),
        	promptText: $.extend({}, jHtmlArea.defaultOptions.promptText, {
				title: 	"<esapi:encodeForJavaScript><fmt:message key="jhtmlarea.prompt.title.txt"/></esapi:encodeForJavaScript>",
				buttonOk: 	"<esapi:encodeForJavaScript><fmt:message key="jhtmlarea.prompt.button.ok.txt"/></esapi:encodeForJavaScript>",
				linkURL: 	"<esapi:encodeForJavaScript><fmt:message key="jhtmlarea.prompt.linkURL.txt"/></esapi:encodeForJavaScript>",
				linkURLErrors: ["<esapi:encodeForJavaScript><fmt:message key="jhtmlarea.prompt.linkURLError0.txt"/></esapi:encodeForJavaScript>",
					"<esapi:encodeForJavaScript><fmt:message key="jhtmlarea.prompt.linkURLError1.txt"/></esapi:encodeForJavaScript>"]
		    })
         });
	});

</script>
</c:if>

<style type="text/css">
	#saveNext:disabled, #saveBack:disabled, #saveFinish:disabled {
		cursor: not-allowed !important;
		opacity: 0.5;
	}
</style>

<div id="wrapGrid" class="u-border" style="display:;">
<table class="mainTable minWidthTableX" border="0" cellspacing="0" cellpadding="0" height="100%" style="display:;border-top:none;background-color:#e0e2e5">
	<tr>
		<td style="border:none;padding:1px;width:25%" nowrap><fieldset style="min-height:8.5em;height:auto;">
			<legend><fmt:message key="fcm.alert.result.txt"/></legend>
			<table width="100%" border="0" cellspacing="0" cellpadding="0" style="padding-right:3px;">
				<tr>
					<td style="padding:0px;">
						<fmt:message key="fcm.alert.assessment.txt"/>: <br/>
						<select name="callResult" id="callResult" class="famSelect" onChange="handleCallResult(this.selectedIndex);" style="width:25em;">
						</select>
					</td>
				</tr>
				<tr>
					<td style="padding:0px;">
						<span style="display:none;" id="QCR_REROUTE_QUEUES">
							<fmt:message key="fcm.alert.queue.txt"/>: <br>
							<select name="rerouteToQueue" id="rerouteToQueue" class="famSelect" style="width:25em;margin-top:2px;">
								<option value="" selected><fmt:message key="fcm.alert.selectQueue.txt"/></option>
							</select>
							<br/><br/>
						</span>

						<span style="display:none;" id="QCR_RESURFACE_TIMESTAMP">
							<fmt:message key="fcm.alert.resurfaceWhen.txt"/>:<br>
							<input type="text" id="calTarget1" name="resurfaceStr" class="famTextEntry" size="25" readonly style="vertical-align:middle">
							<a href="#" id="calAnchor1" data="${esapi:encodeForHTMLAttribute(rescheduleCalendarDays)}"><img src="analyst/images/calendarIcon.gif" id="calendarImg" class="icon" width="16" height="15"/></a>
						</span>

						<span style="display:none;" id="QCR_FRAUD_TYPES">
							<fmt:message key="fcm.alert.reasonCode.txt"/>: <br>
							<select id="fraudType" name="fraudType" class="famSelect" style="width:25em;margin-top:2px;">
								<option value="" selected><fmt:message key="fcm.alert.selectReasonCode.txt"/></option>
							</select>
						</span>
					</td>
				</tr>
			</table>
			</fieldset>
		</td>

<%-- S1314727: Alert memo field does not wrap -- remove td's nowrap attribute which the memo textarea inherited --%>
		<td style="border:0px;padding:1px;"><fieldset style="min-height:8.5em;padding-right:6px;">
			<legend><fmt:message key="fcm.alert.memo.txt"/></legend>
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
				<tr>
					<td style="padding:1px;">&nbsp;
						<c:if test="${not empty displayEntity.currentAlert.predefinedMemos}">
							<fmt:message key="fcm.alert.template.txt"/>:
							<select id="memoTemplateID" name="memoTemplateID" class="famSelect" style="width:25em;margin-top:2px;">
								<option value=""></option>
								<script>
									document.write(_memoOpts.join(' '));
									_memoOpts = undefined;
								</script>
							</select>
						</c:if>
						&nbsp;
					</td>
				</tr>
				<tr>
					<td style="padding:1px;">
						<textarea id="memoText" name="memoText" class="famTextEntry" rows="4" maxLength="${memoMaxSize}" wrap="soft"></textarea>
					</td>
				</tr>
			</table>
			</fieldset>
		</td>
	</tr>
	<tr>
		<td nowrap style="border:none;padding:1px;"><fieldset style="min-height:8.5em;">
			<legend><fmt:message key="fcm.alert.action.txt"/></legend>
			<table border="0" cellspacing="0" cellpadding="0">
				<tr>
					<td style="border:none"><input type="checkbox" name="msgHomePhoneFlag" id="msgAtHome" value="true" style="vertical-align:middle"/><label for="msgAtHome"><fmt:message key="fcm.alert.msgHome.txt"/></label></td>
					<td style="border:none">
						<input type="checkbox" name="sendLetterFlag" id="sendLetter" value="true" style="vertical-align:middle" disabled="disabled" /><label for="sendLetter" id="sendLetterLabel" style="margin-right:2px" disabled="disabled"><fmt:message key="fcm.alert.sendLetter.txt"/></label>
						<c:choose>
							<c:when test="${enableTemplates=='true'}">
								<a id="letterAnchor"><img id="letterImg" src="analyst/images/altAddressDisabled.gif" class="icon" width="16" height="16"/></a></td>
								<c:if test="${not empty displayEntity.currentAlert.letterTemplates}">
									<script>enableSendLetter();</script>
								</c:if>
							</c:when>
							<c:otherwise>
								<img id="letterImg" src="analyst/images/altAddressDisabled.gif" class="icon" /></td>
								<script>enableLetterSent();</script>
							</c:otherwise>
						</c:choose>
				</tr>
				<tr>
					<td style="border:none"><input type="checkbox" name="msgWorkPhoneFlag" id="msgAtWork" value="true" style="vertical-align:middle"/><label for="msgAtWork"><fmt:message key="fcm.alert.msgWork.txt"/></label></td>
					<td style="border:none" nowrap><input type="checkbox" name="sendEmailFlag" id="sendEmail" value="true" style="vertical-align:middle" disabled="disabled" /><label for="sendEmail" id="sendEmailLabel" disabled="disabled"><fmt:message key="fcm.alert.sendEmail.txt"/></label>
					<c:choose>
						<c:when test="${enableTemplates=='true'}">
							<a id="emailAnchor"><img id="emailImg" src="analyst/images/emailDisabled.gif" class="icon" width="16" height="16"/></a></td>
							<%-- Per Ian & Lisa request: removed the check for contactDetails.email --%>
							<c:if test="${not empty displayEntity.currentAlert.emailTemplates}">
								<script>enableSendEmail();</script>
							</c:if>
						</c:when>
						<c:otherwise>
								<img id="emailImg" src="analyst/images/emailDisabled.gif" class="icon" width="16" height="16"/></td>
								<script>enableEmailSent();</script>
						</c:otherwise>
					</c:choose>
				</tr>
				<tr>
					<td style="border:none;" nowrap><input type="checkbox" name="msgMobilePhoneFlag" id="msgOnMobile" value="true" style="vertical-align:middle"/><label for="msgOnMobile"><fmt:message key="fcm.alert.msgMobile.txt"/></label>&nbsp; &nbsp; &nbsp; &nbsp; </td>
					<td style="border:none"><input type="checkbox" name="sendSmsFlag" id="sendSms" value="true" style="vertical-align:middle" disabled="disabled"/><label for="sendSms" id="sendSmsLabel" disabled="disabled"><fmt:message key="fcm.alert.sendSms.txt"/></label>

					<c:choose>
						<c:when test="${enableTemplates=='true'}">
							<a id="smsAnchor"><img id="smsImg" src="analyst/images/smsDisabled.gif" class="icon" width="16" height="16"/></a></td>
							<c:if test="${not empty displayEntity.currentAlert.smsTemplates }">
								<script>enableSendSms();</script>
							</c:if>
						</c:when>
						<c:otherwise>
							<img id="smsImg" src="analyst/images/smsDisabled.gif" class="icon" width="16" height="16"/></td>
							<script>enableSmsSent();</script>
						</c:otherwise>
					</c:choose>

					</td>
				</tr>
				<tr>
					<td style="border:none;" nowrap><input type="checkbox" name="invalidContactDetails" id="invalidContactDetails" value="true" style="vertical-align:middle"/><label for="invalidContactDetails"><fmt:message key="fcm.alert.invalidContactDetails.txt"/></label>&nbsp; &nbsp; &nbsp;</td>
					<td style="border:none;" nowrap><input type="checkbox" name="sendSecureMessage" id="msgSecure" value="true" style="vertical-align:middle"/><label for="msgSecure"><fmt:message key="fcm.alert.sendSecureMsg.txt"/></label>&nbsp; &nbsp; &nbsp; </td>
				</tr>
			</table>
			</fieldset>
		</td>
		<td style="border:none;">
			<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%" style="padding:0px">
				<tr>
					<td style="border:none;padding:1px;vertical-align:middle"><fieldset style="min-height:8.5em;">
						<legend><fmt:message key="fcm.alert.block.txt"/></legend>
						<table border="0" cellspacing="4" cellpadding="0" style="margin:6px 3px 3px 6px" >
							<tr>
								<td style="border:none;"><fmt:message key="fcm.alert.system.txt"/>:</td>
								<td style="border:none;" nowrap>
									<div id="systemBlockDIV">
										<fmt:message key="fcm.alert.na.txt"/>
									</div>
								</td>
							</tr>
							<c:if test="${enableSystemBlockDate=='true'}">
							<tr style="display:none;align:left;vertical-align:middle" id="systemBlockDateDIV">
								<td style="border:none;">
								</td>
								<td style="border:none;" nowrap>
									<fmt:message key="fcm.alert.until.txt"/>:
									<input type="text" id="calTarget3" name="systemBlockUntilStr" class="famTextEntry" size="25" readonly>
									<script>document.forms['alertForm'].systemBlockUntilStr.value=DateUtil.formatDateTime(DateUtil.parseDateTime('<fmt:formatDate value="${systemBlockDate}" pattern="yyyy/M/d HH:mm" timeZone="${userTimeZone}"/>','yyyy/M/d HH:mm'));</script>
									<a href="#" id="calAnchor3" data="${esapi:encodeForHTMLAttribute(maxSystemBlockDays)}">
									<img src="analyst/images/calendarIcon.gif" id="calendarImg3" width="16" height="15"/>
									</a>
								</td>
							</tr>
							</c:if>

							<tr>
								<td style="border:none;"><fmt:message key="fcm.alert.transaction.txt"/>:</td>
								<td style="border:none;" nowrap>
									<div id="transactionBlockDIV">
											<fmt:message key="fcm.alert.na.txt"/>
									</div>
								</td>
							</tr>
							<c:if test="${enableTransactionBlockDate=='true'}">
							<tr style="display:none;align:left;" id="transactionBlockDateDIV">
								<td style="border:none;">
								</td>
								<td style="border:none;" nowrap>
									<fmt:message key="fcm.alert.until.txt"/>:
									<input type="text" id="calTarget4" name="transactionBlockUntilStr" class="famTextEntry" size="25" readonly>
									<script>document.forms['alertForm'].transactionBlockUntilStr.value=DateUtil.formatDateTime(DateUtil.parseDateTime('<fmt:formatDate value="${transactionBlockDate}" pattern="yyyy/M/d HH:mm" timeZone="${userTimeZone}"/>','yyyy/M/d HH:mm'));</script>
									<a href="#" id="calAnchor4" data="${esapi:encodeForHTMLAttribute(maxTransactionBlockDays)}"><img src="analyst/images/calendarIcon.gif" id="calendarImg4" width="16" height="15"/></a>
								</td>
							</tr>
							</c:if>
						</table>
						</fieldset>
					</td>

					<td align="center" style="width:300px" nowrap><fieldset style="min-width:8em;min-height:8.2em;text-align:center;vertical-align:bottom;padding:10px 6px;">

						<input type="hidden" id="nextAlertID" name="nextAlertID" value=""/>
						<input type="hidden" id="afterSaveOption" name="afterSaveOption" value="STAY"/>
						<input type="hidden" name="method" value="wrapup">
						<c:if test="${enableAlertUpdate}">
					    <button class="sapMBarChild sapMBtn sapMBtnBase sasMButton" type="button" id="save">
						  <span class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMBtnText sapMFocusable sapMIE">
				    		<span class="sapMBtnContent"><fmt:message key="fcm.alert.update.txt"/></span>
				    		<span class="sapMBtnFocusDiv"></span>
				  		  </span>
					    </button>
						<span style="display:none;">
							<br clear="left">
						    <button class="sapMBarChild sapMBtn sapMBtnBase sasMButton" type="button" id="saveNext" disabled="true">
							  <span class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMBtnText sapMFocusable sapMIE">
					    		<span class="sapMBtnContent"><fmt:message key="fcm.alert.nextAlert.txt"/></span>
					    		<span class="sapMBtnFocusDiv"></span>
					  		  </span>
						    </button>
						</span>
						<span style="display:none;">
							<br clear="left">
						    <button class="sapMBarChild sapMBtn sapMBtnBase sasMButton" type="button" id="saveBack" disabled="true">
							  <span class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMBtnText sapMFocusable sapMIE">
					    		<span class="sapMBtnContent"><fmt:message key="fcm.alert.backToOriginalContact.txt"/></span>
					    		<span class="sapMBtnFocusDiv"></span>
					  		  </span>
						    </button>
						</span>

						<span style="display:none;">
							<br clear="left">
						    <button class="sapMBarChild sapMBtn sapMBtnBase sasMButton" type="button" id="saveFinish" disabled="true">
							  <span class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMBtnText sapMFocusable sapMIE">
					    		<span class="sapMBtnContent"><fmt:message key="fcm.alert.returnToSummary.txt"/></span>
					    		<span class="sapMBtnFocusDiv"></span>
					  		  </span>
						    </button>
						</span>
						</c:if>

						<c:if test="${not enableAlertUpdate}">
						<span style="display:none;">
							<br clear="left">
						    <button class="sapMBarChild sapMBtn sapMBtnBase sasMButton" type="button" id="saveNext" disabled="true">
							  <span class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMBtnText sapMFocusable sapMIE">
					    		<span class="sapMBtnContent"><fmt:message key="fcm.alert.saveNext.txt"/></span>
					    		<span class="sapMBtnFocusDiv"></span>
					  		  </span>
						    </button>
						</span>

						<span style="display:none;">
							<br clear="left">
						    <button class="sapMBarChild sapMBtn sapMBtnBase sasMButton" type="button" id="saveFinish" disabled="true">
							  <span class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMBtnText sapMFocusable sapMIE">
					    		<span class="sapMBtnContent"><fmt:message key="fcm.alert.saveFinish.txt"/></span>
					    		<span class="sapMBtnFocusDiv"></span>
					  		  </span>
						    </button>
						</span>
						</c:if>

						</fieldset>
					</td>
				</tr>
			</table>
		</td>
	</tr>
</table>
</div>

<div id="calDiv1"  style="position:absolute;visibility:hidden;background-color:white;z-index:99"></div>
<div id="calDiv2"  style="position:absolute;visibility:hidden;background-color:white;z-index:99"></div>
<div id="calDiv3"  style="position:absolute;visibility:hidden;background-color:white;z-index:99"></div>
<div id="calDiv4"  style="position:absolute;visibility:hidden;background-color:white;z-index:99"></div>

<%-- since navigation panel may not be there, we should check current alert's service state --%>
<c:set var="entity" value="${displayEntity.currentAlert}"/>
<c:set var="alertStatus" value="${entity.alertStatus}"/>
<c:set var="checkoutUser" value="${entity.checkoutUser}"/>
<c:set var="lastCallResult" value="${entity.lastCallResult}"/>
<c:set var="alertServiceable" value="${not sfmfn:isFutureTime(entity.nextServiceTimestamp)}"/>

<c:choose>
	<c:when test="${alertStatus eq 'CHECKOUT' and checkoutUser ne username}"><c:set var="serviceState" value="0"/></c:when>
	<c:when test="${alertStatus eq 'ACTIVE' and not empty entity.suspendUser}"><c:set var="serviceState" value="0"/></c:when>
	<c:when test="${(alertStatus eq 'ACTIVE' or alertStatus eq 'CHECKOUT') and (alertServiceable or empty lastCallResult)}"><c:set var="serviceState" value="1"/></c:when>
	<c:when test="${(alertStatus eq 'ACTIVE' or alertStatus eq 'CHECKOUT')}"><c:set var="serviceState" value="2"/></c:when>
	<c:otherwise><c:set var="serviceState" value="0"/></c:otherwise>
</c:choose>

<script language="JavaScript">

/* ****** use buttons ****** */

$(document).ready(function(){

	$("#save").click(function () {
		if (!$mainForm.isDirty())
		{
			alert ($i18n("fcm.alert.js.doSave.update.noData.txt"));
			return;
		}

		$mainForm[0].dirty.value = true;

		$('#afterSaveOption').val('STAY');

		//assessment is optional
		doSave(true);
	});

<c:if test="${enableAlertUpdate}">
	// enable/disable save buttons
	$("#callResult").change(function () {
		var state = (this.selectedIndex == 0) && ${serviceState eq 1};
		$("#saveNext, #saveBack, #saveFinish").prop("disabled", state); // RAPTOR-2399
	}).change();

	$("#saveNext").click(function () {
		$mainForm[0].dirty.value = $mainForm.isDirty();

		$('#afterSaveOption').val('CONTINUE');

		var optional = ${serviceState eq 2};
		doSave(optional);
	});

	$("#saveBack").click(function () {
		$mainForm[0].dirty.value = $mainForm.isDirty();

		$("#nextAlertID").val(${checkoutManager.primaryContactNextAlertID});

		$('#afterSaveOption').val('CONTINUE');

		var optional = ${serviceState eq 2};
		doSave(optional);
	});

	$("#saveFinish").click(function () {
		$mainForm[0].dirty.value = $mainForm.isDirty();

		$('#afterSaveOption').val('FINISH');

		var optional = ${serviceState eq 2};
		doSave(optional);
	});

	<c:choose>
		<c:when test="${checkoutManager.nextAvailable}">
			$("#saveNext").parent().show();
		</c:when>
		<c:otherwise>
			$("#saveNext").parent().hide();
		</c:otherwise>
	</c:choose>

	<c:choose>
		<c:when test="${checkoutManager.backAvailable}">
			$("#saveBack").parent().show();
		</c:when>
		<c:otherwise>
			$("#saveBack").parent().hide();
		</c:otherwise>
	</c:choose>

	<c:choose>
		<c:when test="${checkoutManager.returnAvailable}">
			$("#saveFinish").parent().show();
		</c:when>
		<c:otherwise>
			$("#saveFinish").parent().hide();
		</c:otherwise>
	</c:choose>

</c:if>

<c:if test="${not enableAlertUpdate}">

	// enable/disable save buttons
	$("#callResult").change(function () {
		$("#saveNext, #saveFinish").prop("disabled", (this.selectedIndex == 0)); // RAPTOR-2399
	}).change();

	<c:if test="${checkoutManager.outboundServiceMode}">
			$("#saveNext").click(function () {
			$mainForm[0].dirty.value = $mainForm.isDirty();

			// go to next alert from  priority/direct servicing
			$('#afterSaveOption').val('CONTINUE');

			// assessment is required
			doSave(false);
		});
		$("#saveNext").parent().show();
	</c:if>

	$("#saveFinish").click(function () {
		$mainForm[0].dirty.value = $mainForm.isDirty();

		$('#afterSaveOption').val('FINISH');

		// assessment is required
		doSave(false);
	});
	$("#saveFinish").parent().show();
</c:if>

	 $("#debugInfo").append(": enableAlertUpdate=${enableAlertUpdate}");

});

</script>

