// sasSolutions JavaScript functions
// Copyright (c) 2003 by SAS Institute Inc. All rights reserved.


// Global Variables:
var sasVersion='9.1',xOp7=false,xOp5or6=false,xIE=false,xNN4=false;
var xUA=navigator.userAgent.toLowerCase();
if(window.opera){
  xOp7=(xUA.indexOf('opera 7')!=-1 || xUA.indexOf('opera/7')!=-1);
  if (!xOp7) xOp5or6=(xUA.indexOf('opera 5')!=-1 || xUA.indexOf('opera/5')!=-1 || xUA.indexOf('opera 6')!=-1 || xUA.indexOf('opera/6')!=-1);
}
else if(document.layers) xNN4=true;
else {xIE=document.all && xUA.indexOf('msie')!=-1 && parseInt(navigator.appVersion)>=4;}
var xDom=document.getElementById;

// Slide Panel Variables
var showImg = new Image();
var hideImg = new Image();
var showAlt ="";
var hideAlt ="";

// Calendar variables
var fixedX = -1; // x position (-1 if to appear below control)
var fixedY = -1; // y position (-1 if to appear below control)
var startDay = 0; // 0 - sunday ; 1 - monday
var showWeekNumber = 0; // 0 - don't show; 1 - show
var showToday = 1;      // 0 - don't show; 1 - show
var calendarImgDir = "";    // directory for images ... e.g. var calendarImgDir="/img/"
var bShow = false;
var bPageLoaded=false;

var xObj, xMonthObj, xYearObj, monthSelected, yearSelected, dateSelected, omonthSelected,
oyearSelected, odateSelected, monthConstructed, yearConstructed, intervalID1, intervalID2,
timeoutID1, timeoutID2, ctlForValue, ctlNow, dateFormat, nStartingYear;

// Calendar Date variables
var today = new Date();
var dateNow  = today.getDate();
var monthNow = today.getMonth();
var yearNow  = today.getYear();

//   default calendar object
var cal = new CalendarObject(0,1,0,"","Go to current month", "Today: ", "Wk",
                             "Click to scroll left", "Click to scroll right",
                             "Click to select month", "Click to select year", "select date",
                             new Array("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"),
                             new Array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"),
                             new Array("Sun","Mon","Tue","Wed","Thu","Fri","Sat"),
                             "right.gif","right.gif","left.gif", "left.gif", "drop.gif", "drop.gif", "divider.gif");

// SAS Solutions functions
function subset(frm)
{
   document.forms[frm].submit();
}

function doAction(frm, cmd)
{
    document.forms[frm].command.value=cmd;
    document.forms[frm].submit();
}

function navResize(object, width, height)
{
    obj = document.getElementById(object);
    if (!document.all)
    {
        bannerBG = document.getElementById('bannerBG');
        primaryMenu = document.getElementById('primaryMenu');
        secondaryMenu = document.getElementById('secondaryMenu');
        topHeight = bannerBG.offsetHeight + primaryMenu.offsetHeight +
                    secondaryMenu.offsetHeight;
    }
    else
        topHeight = bannerBG.offsetHeight + primaryMenu.offsetHeight +
                    secondaryMenu.offsetHeight + 5;
    newHeight = height - topHeight;
    obj.style.height = newHeight;
}


// Begin SAS Solutions CORE JavaScript functions
function doShow(e)
{
   if(!(e=getElement(e))) return;
   if(e.style && isDefined(e.style.visibility)) e.style.visibility='inherit';
      else if(isDefined(e.visibility)) e.visibility='show';
}

function doHide(e)
{
   if(!(e=getElement(e))) return;
   if(e.style && isDefined(e.style.visibility)) e.style.visibility='hidden';
      else if(isDefined(e.visibility)) e.visibility='hide';
}


function getElement(e)
{
   if(typeof(e)!="string") return e;
   if(document.getElementById) e=document.getElementById(e);
   else if(document.all) e=document.all[e];
   else if(document.layers) e=nsLayer(e);
   else e=null;
   return e;
}

function nsLayer(id,root) { // only for nn4
  var i,layer,found=null;
  if (!root) root=window;
  for(i=0; i<root.document.layers.length; i++) {
    layer=root.document.layers[i];
    if(layer.id==id) return layer;
    if(layer.document.layers.length) found=nsLayer(id,layer);
    if(found) return found;
  }
  return null;
}

function isDefined()
{
   for(var i=0; i<arguments.length; ++i){
      if(typeof(arguments[i])=="" || typeof(arguments[i])=="undefined") return false;
   }
   return true;
}

function ignore(evt)
{
   evt = (evt) ? evt : ((event) ? event : null);
   if (evt) {evt.cancelBubble = true;}
}

function getPageX(e)
{
   if (!(e=getElement(e))) return 0;
   if (isDefined(e.pageX)) return e.pageX;
   var x = 0;
   while(e)
   {
      if (isDefined(e.offsetLeft)) x += e.offsetLeft;
      e = getParent(e);
   }
  return x;
}

function getParent(e)
{
   if (!(e=getElement(e))) return null;
   var p=null;
   if (e.parentLayer)
   {
      if (e.parentLayer!=window) p=e.parentLayer;
   }
   else
   {
      if (e.offsetParent) p=e.offsetParent;
         else if (e.parentNode) p=e.parentNode;
         else if (e.parentElement) p=e.parentElement;
   }
   return p;
}

function getHeight(e,uH)
{
   if(!(e=getElement(e)) || (uH && uH<0)) return 0;
   uH=Math.round(uH);
   var css=isDefined(e.style);
   if(css && isDefined(e.style.height,e.offsetHeight) && typeof(e.style.height)=="string")
   {
      if(arguments.length>1) setCH(e, uH);
      uH=e.offsetHeight;
   }
   else if(css && isDefined(e.style.pixelHeight))
   {
      if(arguments.length>1) e.style.pixelHeight=uH;
      uH=e.style.pixelHeight;
   }
   else if(isDefined(e.clip) && isDefined(e.clip.bottom))
   {
      if(arguments.length>1) e.clip.bottom=uH;
      uH=e.clip.bottom;
   }
   return uH;
}

function getWidth(e,uH)
{
   if(!(e=getElement(e)) || (uH && uH<0)) return 0;
   uH=Math.round(uH);
   var css=isDefined(e.style);
   if(css && isDefined(e.style.width,e.offsetWidth) && typeof(e.style.width)=="string")
   {
      if(arguments.length>1) setCW(e, uH);
      uH=e.offsetWidth;
   }
   else if(css && isDefined(e.style.pixelWidth))
   {
      if(arguments.length>1) e.style.pixelWidth=uH;
      uH=e.style.pixelWidth;
   }
   else if(isDefined(e.clip) && isDefined(e.clip.right))
   {
      if(arguments.length>1) e.clip.right=uH;
      uH=e.clip.right;
   }
   return uH;
}


function doMoveTo(e,iX,iY)
{
   getLeft(e,iX);
   getTop(e,iY);
}

function getLeft(e,iX)
{
   if(!(e=getElement(e))) return 0;
   var css=isDefined(e.style);
   if (css && isDefined(e.style.left) && typeof(e.style.left)=="string")
   {
      if(arguments.length>1) e.style.left=iX+"px";
      else
      {
         iX=parseInt(e.style.left);
         if(isNaN(iX)) iX=0;
      }
   }
   else if(css && isDefined(e.style.pixelLeft))
   {
      if(arguments.length>1) e.style.pixelLeft=iX;
      else iX=e.style.pixelLeft;
   }
   else if(isDefined(e.left))
   {
      if(arguments.length>1) e.left=iX;
      else iX=e.left;
   }
   return iX;
}

function getTop(e,iY)
{
   if(!(e=getElement(e))) return 0;
   var css=isDefined(e.style);
   if(css && isDefined(e.style.top) && typeof(e.style.top)=="string")
   {
      if(arguments.length>1) e.style.top=iY+"px";
      else
      {
         iY=parseInt(e.style.top);
         if(isNaN(iY)) iY=0;
      }
   }
   else if(css && isDefined(e.style.pixelTop))
   {
      if(arguments.length>1) e.style.pixelTop=iY;
      else iY=e.style.pixelTop;
   }
   else if(isDefined(e.top))
   {
      if(arguments.length>1) e.top=iY;
      else iY=e.top;
   }
   return iY;
}

function setCW(ele,uH)
{
   if(uH<0) return;
   var pt=0,pb=0,bt=0,bb=0;
   if(isDefined(document.defaultView) && isDefined(document.defaultView.getComputedStyle))
   {
      pt=getCS(ele,"padding-left");
      pb=getCS(ele,"padding-right");
      bt=getCS(ele,"border-left-width");
      bb=getCS(ele,"border-right-width");
   }
   else if(isDefined(ele.currentStyle,document.compatMode))
   {
      if(document.compatMode=="CSS1Compat"){
         pt=parseInt(ele.currentStyle.paddingLeft);
         pb=parseInt(ele.currentStyle.paddingRight);
         bt=parseInt(ele.currentStyle.borderLeftWidth);
         bb=parseInt(ele.currentStyle.borderRightWidth);
      }
   }
   else if(isDefined(ele.offsetWidth,ele.style.width))
   {
    ele.style.width=uH+"px";
    pt=ele.offsetWidth-uH;
   }
   if(isNaN(pt)) pt=0; if(isNaN(pb)) pb=0; if(isNaN(bt)) bt=0; if(isNaN(bb)) bb=0;
   var cssH=uH-(pt+pb+bt+bb);
   if(isNaN(cssH)||cssH<0) return;
   else ele.style.width=cssH+"px";
}

function setCH(ele,uH)
{
   if(uH<0) return;
   var pt=0,pb=0,bt=0,bb=0;
   if(isDefined(document.defaultView) && isDefined(document.defaultView.getComputedStyle))
   {
      pt=getCS(ele,"padding-top");
      pb=getCS(ele,"padding-bottom");
      bt=getCS(ele,"border-top-width");
      bb=getCS(ele,"border-bottom-width");
   }
   else if(isDefined(ele.currentStyle,document.compatMode))
   {
      if(document.compatMode=="CSS1Compat"){
         pt=parseInt(ele.currentStyle.paddingTop);
         pb=parseInt(ele.currentStyle.paddingBottom);
         bt=parseInt(ele.currentStyle.borderTopWidth);
         bb=parseInt(ele.currentStyle.borderBottomWidth);
      }
   }
   else if(isDefined(ele.offsetHeight,ele.style.height))
   {
    ele.style.height=uH+"px";
    pt=ele.offsetHeight-uH;
   }
   if(isNaN(pt)) pt=0; if(isNaN(pb)) pb=0; if(isNaN(bt)) bt=0; if(isNaN(bb)) bb=0;
   var cssH=uH-(pt+pb+bt+bb);
   if(isNaN(cssH)||cssH<0) return;
   else ele.style.height=cssH+"px";
}

function getCS(ele,sP)
{
   return parseInt(document.defaultView.getComputedStyle(ele,"").getPropertyValue(sP));
}

function getClientWidth()
{
   var w=0;
   if(xOp5or6) w=window.innerWidth;
   else if(xIE && document.documentElement && document.documentElement.clientWidth)
       w=document.documentElement.clientWidth;
   else if(document.body && document.body.clientWidth)
       w=document.body.clientWidth;
   else if(isDefined(window.innerWidth,window.innerHeight,document.height))
   {
       w=window.innerWidth;
       if(document.height>window.innerHeight) w-=16;
   }
   return w;
}

function getClientHeight()
{
   var h=0;
   if(xOp5or6) h=window.innerHeight;
   else if(xIE && document.documentElement && document.documentElement.clientHeight)
      h=document.documentElement.clientHeight;
   else if(document.body && document.body.clientHeight)
      h=document.body.clientHeight;
   else if(isDefined(window.innerWidth,window.innerHeight,document.width))
   {
      h=window.innerHeight;
      if(document.width>window.innerWidth) h-=16;
   }
   return h;
}

function toggleDiv(name, isOn)
{
    element = getElement(name);
    if (isOn)
        element.style.display = "none";
    else
        element.style.display = "block";
}

function hideDiv(name)
{
    element = getElement(name);
    element.style.display = "none";
}

function showDiv(name)
{
    element = getElement(name);
    element.style.display = "block";
}

function toggleSection(sec)
{
      var thisSection = getElement(sec);
      var btn = sec + "_btn"; //change SectionViewTag if this is changed.
      var thisImg = getElement(btn);
      var hiddenid = thisSection.id + '_hidden';
      var thisHidden = getElement(hiddenid);
      if (thisSection.style.display == "none") {
         thisSection.style.display="block";
         thisImg.src=hideImg.src;
         thisImg.setAttribute('alt', hideAlt);
         thisHidden.value = 'true';
      }
      else  {
         thisSection.style.display="none";
         thisImg.src=showImg.src;
         thisImg.setAttribute('alt',showAlt);
         thisHidden.value = 'false';
      }
}

// Calendar Pop-up Functions
// ...start...

function CalendarObject(sWk, sTo, sDay, iDir, goTo, toDay, week, scrL, scrR, sMon, sYr, sDate,
                        months, shortMonths, days, imgRt0, imgRt1, imgLt0, imgLt1, imgDr0, imgDr1, dv)
{
   this.showWeekNumber = sWk;
   this.showToday = sTo;
   this.startDay = sDay
   this.imgDir = iDir;
   this.goTo = goTo;
   this.today = toDay;
   this.week = week;
   this.scrollLeft = scrL;
   this.scrollRight = scrR;
   this.selectedMonth = sMon;
   this.selectedYear = sYr;
   this.selectedDate = sDate;
   this.monthName = months;
   this.shortMonthName = shortMonths;
   this.dayName = days;
   this.scrollRightImgOff = imgRt0;
   this.scrollRightImgOn = imgRt1;
   this.scrollLeftImgOff = imgLt0;
   this.scrollLeftImgOn  = imgLt1;
   this.dropdownImgOff = imgDr0;
   this.dropdownImgOn  = imgDr1;
   this.dividerImg = dv;
}


/* hides <select> and <applet> objects (for IE only) during calendar display */
function hideTags( elmID, overDiv )
{
  if( xIE )
  {
    for( i = 0; i < document.all.tags( elmID ).length; i++ )
    {
      obj = document.all.tags( elmID )[i];
      if( !obj || !obj.offsetParent )
      {
         continue;
      }
      obj.style.visibility = "hidden";

      // Find the element's offsetTop and offsetLeft relative to the BODY tag.
//      objLeft   = obj.offsetLeft;
//      objTop    = obj.offsetTop;
//      objParent = obj.offsetParent;

//      while( objParent.tagName.toUpperCase() != "BODY" )
//      {
//         objLeft  += objParent.offsetLeft;
//         objTop   += objParent.offsetTop;
//         objParent = objParent.offsetParent;
//      }

//      objHeight = obj.offsetHeight;
//      objWidth = obj.offsetWidth;

//      if(( overDiv.offsetLeft + overDiv.offsetWidth ) <= objLeft );
//      else if(( overDiv.offsetTop + overDiv.offsetHeight ) <= objTop );
//      else if( overDiv.offsetTop >= ( objTop + objHeight ));
//      else if( overDiv.offsetLeft >= ( objLeft + objWidth ));
//      else
//      {
//         obj.style.visibility = "hidden";
//      }
    }
  }
}


/*
 * unhides <select> and <applet> objects (for IE only)
 */
function showTags( eID )
{
   if( xIE )
   {
      for( i = 0; i < document.all.tags( eID ).length; i++ )
      {
         obj = document.all.tags( eID )[i];

         if( !obj || !obj.offsetParent )
         {
           continue;
         }

         obj.style.visibility = "";
      }
   }
}


function swapImage(srcImg, destImg)
{
   if (xIE){ document.getElementById(srcImg).setAttribute("src", destImg); }
}

function init()
{
   if (!xNN4)
   {
      if (!xIE) { yearNow += 1900   }
      xObj=(xDom)?document.getElementById("sas_calendar").style : xIE? document.all.calendar : document.calendar;
      hideCalendar();

      xMonthObj=(xDom)?document.getElementById("selectMonth").style : xIE? document.all.selectMonth : document.selectMonth;

      xYearObj=(xDom)?document.getElementById("selectYear").style : xIE? document.all.selectYear : document.selectYear;

      monthConstructed=false;
      yearConstructed=false;

      if (cal.showToday==1)
      {
         document.getElementById("lblToday").innerHTML = cal.today + " <a class='calendarToday' onmousemove='window.status=\""+cal.goTo+"\"' onmouseout='window.status=\"\"' title='"+cal.goTo+"' href='javascript:monthSelected=monthNow;yearSelected=yearNow;constructCalendar();'>"+cal.dayName[(today.getDay()-cal.startDay==-1)?6:(today.getDay()-cal.startDay)]+", " + dateNow + " " + cal.monthName[monthNow].substring(0,3) + " " + yearNow + "</a>";
      }

      sHTML1= "<span id='spanLeft'  class='calendarTitleCtrlNormal' onmouseover='swapImage(\"changeLeft\", cal.scrollLeftImgOn);this.className=\"calendarTitleCtrlSelect\";window.status=\""+cal.scrollLeft+"\"' onclick='javascript:decMonth()' onmouseout='clearInterval(intervalID1);swapImage(\"changeLeft\",cal.scrollLeftImgOff);this.className=\"calendarTitleCtrlNormal\";window.status=\"\"' onmousedown='clearTimeout(timeoutID1);timeoutID1=setTimeout(\"StartDecMonth()\",500)' onmouseup='clearTimeout(timeoutID1);clearInterval(intervalID1)'>&nbsp<img id='changeLeft' src='"+cal.scrollLeftImgOff+"' width=10 height=11 border=0>&nbsp</span>&nbsp;";
      sHTML1+="<span id='spanRight' class='calendarTitleCtrlNormal' onmouseover='swapImage(\"changeRight\", cal.scrollRightImgOn);this.className=\"calendarTitleCtrlSelect\";window.status=\""+cal.scrollRight+"\"' onmouseout='clearInterval(intervalID1);swapImage(\"changeRight\", cal.scrollRightImgOff);this.className=\"calendarTitleCtrlNormal\";window.status=\"\"' onclick='incMonth()' onmousedown='clearTimeout(timeoutID1);timeoutID1=setTimeout(\"StartIncMonth()\",500)'  onmouseup='clearTimeout(timeoutID1);clearInterval(intervalID1)'>&nbsp<img id='changeRight' src='"+cal.scrollRightImgOff+"' width=10 height=11 border=0>&nbsp</span>&nbsp";
      sHTML1+="<span id='spanMonth' class='calendarTitleCtrlNormal' onmouseover='swapImage(\"changeMonth\", cal.dropdownImgOn);this.className=\"calendarTitleCtrlSelect\";window.status=\""+cal.selectedMonth+"\"' onmouseout='swapImage(\"changeMonth\",cal.dropdownImgOff);this.className=\"calendarTitleCtrlNormal\";window.status=\"\"' onclick='popUpMonth()'></span>&nbsp;";
      sHTML1+="<span id='spanYear'  class='calendarTitleCtrlNormal' onmouseover='swapImage(\"changeYear\", cal.dropdownImgOn);this.className=\"calendarTitleCtrlSelect\";window.status=\""+cal.selectedYear+"\"'    onmouseout='swapImage(\"changeYear\",cal.dropdownImgOff);this.className=\"calendarTitleCtrlNormal\";window.status=\"\"' onclick='popUpYear()'></span>&nbsp;";

      document.getElementById("caption").innerHTML = sHTML1;
      bPageLoaded=true;
   }
}

function hideCalendar()
{
   xObj.visibility="hidden";
   if (xMonthObj != null){xMonthObj.visibility="hidden"};
   if (xYearObj != null){xYearObj.visibility="hidden"};
   showTags('SELECT');
   showTags('APPLET');
}

function padZero(num)
{
   return (num < 10)? '0' + num : num ;
}

function constructDate(d,m,y)
{
   tempval = dateFormat;
   tempval = tempval.replace("dd","<e>");
   tempval = tempval.replace("d","<d>");
   tempval = tempval.replace("<e>",padZero(d));
   tempval = tempval.replace("<d>",d);
   tempval = tempval.replace("mmm","<o>");
   tempval = tempval.replace("mm","<n>");
   tempval = tempval.replace("m","<m>");
   tempval = tempval.replace("<m>",m+1);
   tempval = tempval.replace("<n>",padZero(m+1));
   tempval = tempval.replace("<o>",cal.shortMonthName[m]);
   tempval = tempval.replace("yyyy",y);
   return tempval.replace ("yy",padZero(y%100));
}

function closeCalendar()
{
   var tempval;
   hideCalendar();
   ctlForValue.value=constructDate(dateSelected,monthSelected,yearSelected);
}

/*** Month Pulldown ***/

function StartDecMonth()
{
   intervalID1=setInterval("decMonth()",80)
}

function StartIncMonth()
{
   intervalID1=setInterval("incMonth()",80)
}

function incMonth ()
{
   monthSelected++;
   if (monthSelected > 11)
   {
      monthSelected=0;
      yearSelected++;
   }
   constructCalendar();
}

function decMonth ()
{
   monthSelected--;
   if (monthSelected < 0)
   {
      monthSelected=11;
      yearSelected--;
   }
   constructCalendar();
}

function constructMonth()
{
   popDownYear()
   if (!monthConstructed) {
      sHTML = "";
      for (i=0; i<12; i++)
      {
         sName = cal.monthName[i];
         if (i==monthSelected){
            sName = "<b>" + sName + "</b>"
         }
         sHTML += "<tr><td id='m" + i + "' onmouseover='this.className=\"calendarDropdownSelect\"' onmouseout='this.className=\"calendarDropdownNormal\"' onclick='monthConstructed=false;monthSelected=" + i + ";constructCalendar();popDownMonth();event.cancelBubble=true'>&nbsp;" + sName + "&nbsp;</td></tr>";
      }
      document.getElementById("selectMonth").innerHTML = "<table width=70 class='calendarDropdown' cellspacing=0 onmouseover='clearTimeout(timeoutID1)' onmouseout='clearTimeout(timeoutID1);timeoutID1=setTimeout(\"popDownMonth()\",100);event.cancelBubble=true'>" + sHTML + "</table>";

      monthConstructed=true;
   }
}

function popUpMonth() {
   constructMonth();
   xMonthObj.visibility = (xDom||xIE)? "visible" : "show";
   xMonthObj.left = parseInt(xObj.left) + 50;
   xMonthObj.top = parseInt(xObj.top) + 26;
   hideTags('SELECT', document.getElementById("selectMonth") );
   hideTags('APPLET', document.getElementById("selectMonth") );
}

function popDownMonth() {
   xMonthObj.visibility= "hidden";
}

/* Calendar Year Pulldown */

function incYear() {
   for (i=0; i<7; i++)
   {
      newYear = (i+nStartingYear)+1;
      if (newYear==yearSelected)
         { txtYear = "&nbsp;<b>" + newYear + "</b>&nbsp;" }
      else
         { txtYear = "&nbsp;" + newYear + "&nbsp;" }
      document.getElementById("y"+i).innerHTML = txtYear;
   }
   nStartingYear ++;
   bShow=true;
}

function decYear() {
   for (i=0; i<7; i++)
   {
      newYear = (i+nStartingYear)-1;
      if (newYear==yearSelected)
         { txtYear = "&nbsp;<b>" + newYear +    "</b>&nbsp;" }
      else
    { txtYear ="&nbsp;" + newYear + "&nbsp;" }
      document.getElementById("y"+i).innerHTML = txtYear;
   }
   nStartingYear --;
   bShow=true;
}

function selectYear(nYear) {
   yearSelected=parseInt(nYear+nStartingYear);
   yearConstructed=false;
   constructCalendar();
   popDownYear();
}

function constructYear() {
   popDownMonth();
   sHTML = "";
   if (!yearConstructed) {

      sHTML = "<tr><td align='center' onmouseover='this.className=\"calendarDropdownSelect\"' onmouseout='clearInterval(intervalID1);this.className=\"calendarDropdownNormal\"' onmousedown='clearInterval(intervalID1);intervalID1=setInterval(\"decYear()\",30)' onmouseup='clearInterval(intervalID1)'>-</td></tr>";
      j = 0;
      nStartingYear = yearSelected-3;
      for (i=(yearSelected-3); i<=(yearSelected+3); i++)
      {
         sName = i;
         if (i==yearSelected){
            sName = "<b>" + sName + "</b>";
         }

         sHTML += "<tr><td id='y" + j + "' onmouseover='this.className=\"calendarDropdownSelect\"' onmouseout='this.className=\"calendarDropdownNormal\"' onclick='selectYear("+j+");event.cancelBubble=true'>&nbsp;" + sName + "&nbsp;</td></tr>";
        j ++;
      }

      sHTML += "<tr><td align='center' onmouseover='this.className=\"calendarDropdownSelect\"' onmouseout='clearInterval(intervalID2);this.className=\"calendarDropdownNormal\"' onmousedown='clearInterval(intervalID2);intervalID2=setInterval(\"incYear()\",30)' onmouseup='clearInterval(intervalID2)'>+</td></tr>";

      document.getElementById("selectYear").innerHTML = "<table width=44 class='calendarDropdown' onmouseover='clearTimeout(timeoutID2)' onmouseout='clearTimeout(timeoutID2);timeoutID2=setTimeout(\"popDownYear()\",100)' cellspacing=0>" + sHTML + "</table>";

      yearConstructed = true;
   }
}

function popDownYear() {
   clearInterval(intervalID1);
   clearTimeout(timeoutID1);
   clearInterval(intervalID2);
   clearTimeout(timeoutID2);
   xYearObj.visibility= "hidden";
}

function popUpYear() {
   var leftOffset;
   constructYear();
   xYearObj.visibility = (xDom||xIE)? "visible" : "show";
   leftOffset = parseInt(xObj.left) + document.getElementById("spanYear").offsetLeft
   if (xIE) { leftOffset += 6; }
   xYearObj.left = leftOffset;
   xYearObj.top = parseInt(xObj.top) + 26;
}

function WeekNbr(today)
{
   Year = takeYear(today);
   Month = today.getMonth();
   Day = today.getDate();
   now = Date.UTC(Year,Month,Day+1,0,0,0);
   var Firstday = new Date();
   Firstday.setYear(Year);
   Firstday.setMonth(0);
   Firstday.setDate(1);
   then = Date.UTC(Year,0,1,0,0,0);
   var Compensation = Firstday.getDay();
   if (Compensation > 3) Compensation -= 4;
   else Compensation += 3;
   NumberOfWeek =  Math.round((((now-then)/86400000)+Compensation)/7);
   return NumberOfWeek;
}

function takeYear(theDate)
{
   x = theDate.getYear();
   var y = x % 100;
   y += (y < 38) ? 2000 : 1900;
   return y;
}

function constructCalendar ()
{
   var dateMessage;
   var startDate = new Date(yearSelected,monthSelected,1);
   var endDate = new Date(yearSelected,monthSelected+1,1);
   endDate = new Date(endDate - (24*60*60*1000));
   numDaysInMonth = endDate.getDate();

   datePointer= 0;
   dayPointer = startDate.getDay() - cal.startDay;

   if (dayPointer<0) { dayPointer = 6; }

   sHTML = "<table border=0 class='calendarMain'><tr>";

   if (cal.showWeekNumber==1)
   {
      sHTML += "<td width=27><b>" + cal.week + "</b></td><td width=1 rowspan=7 class='calendarWeekNumberDivider'><img src='"+cal.dividerImg +"' width=1></td>"
   }

        for (i=0; i<7; i++) {
            sHTML += "<td width='27' align='right'><B>"+ cal.dayName[i]+"</B></td>"
        }
        sHTML +="</tr><tr>"

        if (cal.showWeekNumber==1)
        {
            sHTML += "<td align=right>" + WeekNbr(startDate) + "&nbsp;</td>"
        }

        for ( var i=1; i<=dayPointer;i++ )
        {
            sHTML += "<td>&nbsp;</td>"
        }

        for ( datePointer=1; datePointer<=numDaysInMonth; datePointer++ )
        {
            dayPointer++;
            sHTML += "<td align=right>"

            var sStyle="calendarDay"; //regular day

            if ((datePointer==dateNow)&&(monthSelected==monthNow)&&(yearSelected==yearNow)) //today
            { sStyle = "calendarCurrentDay"; }
            else if (dayPointer % 7 == (cal.startDay * -1) +1) //end-of-the-week day
            { sStyle = "calendarWeekend"; }

            //selected day
            if ((datePointer==odateSelected) && (monthSelected==omonthSelected) && (yearSelected==oyearSelected))
            { sStyle += " calendarDaySelected"; }

            sHint = ""

            var regexp= /\"/g
            sHint=sHint.replace(regexp,"&quot;")

            dateMessage = "onmousemove='window.status=\""+cal.selectedDate.replace("[date]",constructDate(datePointer,monthSelected,yearSelected))+"\"' onmouseout='window.status=\"\"' "

            sHTML += "<a class='"+sStyle+"' "+dateMessage+" title=\"" + sHint + "\" href='javascript:dateSelected="+datePointer+";closeCalendar();'>&nbsp;" + datePointer + "&nbsp;</a>"

            sHTML += ""
            if ((dayPointer+cal.startDay) % 7 == cal.startDay) {
                sHTML += "</tr><tr>"
                if ((cal.showWeekNumber==1)&&(datePointer<numDaysInMonth))
                {
                    sHTML += "<td align=right>" + (WeekNbr(new Date(yearSelected,monthSelected,datePointer+1))) + "&nbsp;</td>"
                }
            }
        }

        document.getElementById("content").innerHTML = sHTML;
        document.getElementById("spanMonth").innerHTML = "&nbsp;" + cal.monthName[monthSelected] + "&nbsp;<img id='changeMonth' src='"+cal.dropdownImgOff+"' width='12' height='10' border=0>";
        document.getElementById("spanYear").innerHTML = "&nbsp;" + yearSelected + "&nbsp;<img id='changeYear' src='"+cal.dropdownImgOff+"' width='12' height='10' border=0>";
    }

function popUpCalendar(ctl, ctl2, format)
{
   var leftpos=0;
   var toppos=0;

   if (bPageLoaded)
   {
      if ( xObj.visibility == "hidden" )
      {
         ctlForValue = ctl2;
         dateFormat=format;
         formatChar = " ";
         aFormat = dateFormat.split(formatChar);
         if (aFormat.length<3)
         {
            formatChar = "/";
            aFormat = dateFormat.split(formatChar);
            if (aFormat.length<3)
            {
               formatChar = ".";
               aFormat = dateFormat.split(formatChar);
               if (aFormat.length < 3)
               {
                  formatChar = "-";
                  aFormat = dateFormat.split(formatChar);
                  if (aFormat.length<3)
                  {
                     // invalid date format
                     formatChar="";
                  }
               }
            }
         }

         tokensChanged = 0;
         if ( formatChar != "" );
         {
            // use user's date
            aData = ctl2.value.split(formatChar);
            for(i=0;i<3;i++)
            {
               if ((aFormat[i]=="d") || (aFormat[i]=="dd"))
               {
                  dateSelected = parseInt(aData[i], 10);
                  tokensChanged ++;
               }
               else if((aFormat[i]=="m") || (aFormat[i]=="mm"))
               {
                  monthSelected = parseInt(aData[i], 10) - 1;
                  tokensChanged ++;
               }
               else if(aFormat[i]=="yyyy")
               {
                  yearSelected = parseInt(aData[i], 10);
                  tokensChanged ++;
               }
               else if(aFormat[i]=="mmm")
               {
             for(j=0; j<12; j++){
                     if (aData[i]==cal.monthName[j]);
                     {
                         monthSelected=j;
                         tokensChanged ++;
                     }
                  }
               }
            }
         }

         if ((tokensChanged!=3)||isNaN(dateSelected)||isNaN(monthSelected)||isNaN(yearSelected))
         {
            dateSelected = dateNow;
            monthSelected = monthNow;
            yearSelected = yearNow;
         }

         odateSelected=dateSelected;
         omonthSelected=monthSelected;
         oyearSelected=yearSelected;

         aTag = ctl;
         foundPanel = false;
         foundLeftPanel = false;
         do {
            aTag = aTag.offsetParent;
            if (aTag.id == 'leftPanel' || aTag.id == 'rightPanel')
                foundPanel = true;
            if (aTag.id == 'leftPanel')
                foundLeftPanel = true;
            leftpos += aTag.offsetLeft;
            toppos += aTag.offsetTop;
         } while(aTag.tagName!="BODY" && aTag.tagName!="SPAN" && aTag.tagName!="DIV");

         if (foundPanel)
         {
             if (!foundLeftPanel)
             {
                 leftpos -= getWidth('leftPanel');
             }
             var hdr = getHeight("header");
             var ban = getHeight("banner");
             totalHdrHeight = ban + hdr;
             // todo... figure out the best way to handle this...
             if (getElement('todoArea'))
             {
                 totalHdrHeight += getHeight('todoArea');
             }
             toppos -= totalHdrHeight;
         }

         iconPosX = ctl.offsetLeft + leftpos;
         iconPosY = ctl.offsetTop + toppos + ctl.offsetHeight + 2
         elbowRoom = getClientWidth() - getWidth('sas_calendar');

         if ( (elbowRoom < iconPosX) && (iconPosX > getWidth('sas_calendar')) )
            posX = (iconPosX - getWidth('sas_calendar')) + 16;
         else posX = iconPosX;
         xObj.left = fixedX==-1 ? posX : fixedX;
         xObj.top = fixedY==-1 ? iconPosY : fixedY;
         constructCalendar (1, monthSelected, yearSelected);
         xObj.visibility=(xDom||xIE)? "visible" : "show";
         hideTags( 'SELECT', document.getElementById("sas_calendar") );
         hideTags( 'APPLET', document.getElementById("sas_calendar") );
         bShow = true;
      }
   }
   else
   {
   init();
   popUpCalendar(ctl, ctl2, format);
   }
}


// Calendar Pop-up Functions
// ...end...

// Directive Picker Functions
// ...start...

function showDirectiveProperties(val, formNum, elementName) {
    for (i=1; i<=5; i++) {
       resetDirectiveProperty(i, formNum);
    }
    dir = directives[val];
    if (dir.hasProperties==false)
       { setNoDirectiveProperties(formNum); hideDiv('parameterDiv'); }
    else {
       showDiv('parameterDiv');
       numProperties = document.forms[formNum].elements["numProperties"];
       numProperties.value = dir.propertyCount;
       for(i=0; i<dir.propertyCount; i++) {
          setDirectiveProperty(dir.properties[i], formNum, elementName);
       }
    }
}

function setDirectiveProperty(property, formNum, elementName) {
    var thisName = "sasdirName" + property.num;
    var thisPrompt = "sasdirPrompt" + property.num;
    var thisValue  = "sasdirValue" + property.num;
    var thisDisplay = "sasdirDisplayedValue" + property.num;
    var thisButton = "sasdirButton" + property.num;
    var p=getElement(thisPrompt);
    p.innerHTML = property.prompt;
    p.style.display="block";
    var v=getElement(thisValue);
    var valObj=document.forms[formNum].elements[thisValue];
    valObj.value=property.setting;
    valObj.disabled=false;
    v.style.display="block";
    var di=getElement(thisDisplay);
    var displayObj=document.forms[formNum].elements[thisDisplay];
    displayObj.value=property.displayValue;
    displayObj.disabled=false;
    di.style.display="block";
    if (property.editor != '')
    {
        var bi = getElement(thisButton);
        var buttonObj = document.forms[formNum].elements[thisButton];
        buttonObj.disabled = false;
        buttonObj.onClick="test()";
        bi.style.display="block";
        di.disabled=true;
    }
    var n=getElement(thisName);
    var nameObj = document.forms[formNum].elements[thisName];
    nameObj.value=property.prompt;
    nameObj.disabled=false;
    var hName=getElement("sasdirHdName");
    hName.style.display="block";
    var hVal=getElement("sasdirHdVal");
    hVal.style.display="block";
    box = document.forms[formNum].elements[elementName];
    desc = box.options[box.selectedIndex].text;
    if (document.forms[formNum].elements['directiveName'])
    {
        document.forms[formNum].elements['directiveName'].value = desc;
    }
}

function updateHiddenValue(item, directive, property)
{
    if (directives[directive].properties[property-1].editor == '')
    {
        var thisValue  = "sasdirValue" + property;
        var valObj=getElement(thisValue);
        valObj.value=item.value;
    }
}

function showDirectiveEditor(directive, propertyNum, formNum)
{
    dir = directives[directive];
    property = dir.properties[propertyNum-1];
    var iframe = getElement('directiveIframe');
    iframe.src = "Director.do?_directive=" + property.editor + "&propertyNumber=" + (property.num-1) + "&formNumber=" + formNum + "&directiveSelection=" + directive + directiveParms;
    var thisButton = "sasdirButton" + property.num;
    showPopupMenu('directiveIframeDiv', thisButton);
}

function resetDirectiveProperty(item, formNum) {
    var thisName = "sasdirName" + item;
    var thisPrompt = "sasdirPrompt" + item;
    var thisValue  = "sasdirValue" + item;
    var thisDisplay = "sasdirDisplayedValue" + item;
    var thisButton = "sasdirButton" + item;
    var p=getElement(thisPrompt);
    p.style.display="none";
    p.innerHTML="";
    var v=getElement(thisValue);
    var valObj=document.forms[formNum].elements[thisValue];
    valObj.value="";
    valObj.disabled=true;
    v.style.display="none";
    // display
    var di=getElement(thisDisplay);
    var displayObj=document.forms[formNum].elements[thisValue];
    displayObj.value="";
    displayObj.disabled=true;
    di.style.display="none";
    // end display
    // button
    var bi = getElement(thisButton);
    var buttonObj = document.forms[formNum].elements[thisButton];
    if (buttonObj)
    {
        buttonObj.disabled = false;
        buttonObj.onClick="test()";
    }
    if (bi)
        bi.style.display="none";
    // end button
    var n=getElement(thisName);
    var nameObj = document.forms[formNum].elements[thisName];
    nameObj.value="";
    nameObj.disabled=true;
    var hName=getElement("sasdirHdName");
    hName.style.display="none";
    var hVal=getElement("sasdirHdVal");
    hVal.style.display="none";
    var non=getElement("sasdirNoParams");
    non.style.display="none";
}

function setNoDirectiveProperties(formNum) {
    var hName=getElement("sasdirHdName");
    hName.style.display="none";
    var hVal=getElement("sasdirHdVal");
    hVal.style.display="none";
    var non=getElement("sasdirNoParams");
    non.style.display="block";
    numProperties = document.forms[formNum].elements["numProperties"];
    numProperties.value = "0";
}

function DirectiveProperty(s, prmpt, vl, displayVl, hasEditor) {
    this.num=s;
    this.prompt=prmpt;
    this.displayValue=displayVl;
    this.setting=vl;
    this.editor=hasEditor;
}

function Directive(n, d, props) {
    this.name=n;
    this.desc=d;
    this.propertyCount=0;
    if (props==null) { this.hasProperties=false; }
    else {
        this.hasProperties=true;
        this.properties=props;
        this.propertyCount=props.length;
    }
}

// Directive Picker Functions
// ...end...

// Color Picker Functions
    function updateColorPicker(formNum, formField, tableCell, color)
    {
        field = eval('document.forms['+formNum+'].'+formField);
        field.value = color;
        element = getElement(tableCell);
        element.style.backgroundColor=color;
        toggleDiv('div' + formField, true);
    }

// Color Picker Functions
// ...end...

// Icon Picker Functions
    function updateIconPicker(formNum, formField, imageId, imageName, image, path)
    {
        field = eval('document.forms['+formNum+'].'+formField);
        field.value = imageName;
        element = getElement(imageId);
        element.src=path + image;
        toggleDiv('div' + formField, true);
    }
// Icon Picker Functions
// ...end...

// Icon Picker Functions
    function updateCustomIconPicker(formNum, formField, imageId, imageName, image, path)
    {
        field = eval('document.forms['+formNum+'].'+formField);
        field.value = imageName;
        element = getElement(imageId);
        element.src=path + image;
        toggleDiv('div' + formField, true);
    }
// Icon Picker Functions
// ...end...


    function disable(name)
    {
        element = getElement(name);
        element.disabled = true;
    }

// Help Dialog Functions

    var dlg_help = null;
    var dlg_contents = null;
    function openHelpDialog(helpPath)
    {
         // nav.jsp is used for Contents and Index
         if ( helpPath.indexOf( "nav.jsp" ) != -1 )
         {
            dlg_contents=window.open(helpPath,"SASHelpNavV",
                         'width=250px,height=480px,left=5px,top=5px,resizable=yes,scrollbars=yes,toolbar=no');
            dlg_contents.focus();
         }
         else
         {
            dlg_help=window.open(helpPath,"SASHelpV",
                     'width=450px,height=480px,left=270px,top=5px,resizable=yes,scrollbars=yes,toolbar=no');
            dlg_help.focus();
         }
    }

// Help Dialog Functions
// ...end...

// ...begin...
// text area length limit function
	function maximumTextAreaLength(obj, maxLength)
	{
		var textLength = obj.value.length;
		if (textLength >= maxLength-1)
			obj.value = obj.value.substring(0, maxLength-1);

	}
// text area length limit function
// ...end...

// Double Click Functions
function disableAllForms() {
    // Loop through each form on this page
    for (var i = 0; i < document.forms.length; i++) {
        // Loop through each element in the form
        var form = document.forms[i];
        for (var j = 0; j < form.length; j++) {
            // Disable each element
            var element = form.elements[j];
            element.disabled = true;
        }
    }
}

function disableAllButtons()
{
    if (buttonArray)
    {
        for (i = 0; i < buttonArray.length; i++)
        {
            buttonID = buttonArray[i];
            obj = getElement(buttonID);
            obj.disabled = true;
        }
    }
}

function disableAllAnchors() {
    // Loop through each anchor on this page
    for (var i = 0; i < document.links.length; i++) {
        // Disable each element
        var anchor = document.links[i];
        anchor.disabled = true;
        anchor.onclick=alwaysReturnFalse;
    }
}

function disableEverything() {
    disableAllForms();
    disableAllButtons();
    disableAllAnchors();
}

function alwaysReturnFalse(evt)
{
    return false;
}

function documentClick(evt)
{
    evt = (evt) ? evt : ((window.event) ? window.event : "");
    obj = evt.target; // RAPTOR-2399

    if (obj.tagName != 'A' &&
        obj.tagName != 'INPUT')
        obj = checkParents(obj);

    if (!obj)
        return;

    if (obj.tagName == 'A')
    {
        var s = new String(obj.href);
        var o = new String(obj.onclick);
        var t = new String(obj.target);

        if (checkTarget(t) ||
            checkHref(s) ||
            checkPopup(o) ||
            checkTreeView(s, o) ||
            evaluateParentsForNodes(obj) ||
            siteDisable(obj))
            return;

        disableEverything();
    }
    else if (obj.tagName == 'INPUT' &&
             (obj.type == 'button' || obj.type == 'BUTTON'))
    {
        var o = new String(obj.onclick);
        if (obj.disabled == true)
            return;
        if (o &&
            (o.indexOf('doAction') < 0 ||
            o.indexOf('noDisable()') >= 0))
            return;
        disableEverything();
    }
}

function checkTreeView(s, o)
{
    // does the onclick contain a tree view function
    // and the href contain nothing?
    if (o.indexOf('sas_TreeView') >= 0 &&
        (s == null || s == ""))
        return true;
    return false;
}

function checkPopup(o)
{
    // does the onclick contain showpopup?
    if (o.indexOf('showPopup') >= 0)
        return true;
    return false;
}

function checkHref(s)
{
    // is the href a javascript call?
    if (s.indexOf('javascript:') >= 0 ||
        s == '')
        return true;
    return false;
}

function checkTarget(t)
{
    // does target have a value and is it something
    // other than this page (_self or _top).
    if (t != null &&
        t != "" &&
        (t.indexOf('_self') < 0 &&
         t.indexOf('_top') < 0))
        return true;
    return false;
}

function noDisable()
{
    // do nothing we use this as a key to tell if someone doesn't want disabling done
}

function evaluateParentsForNodes(obj)
{
    if (!obj || !obj.parentElement)
        return false;
    var c = new String(obj.parentElement.onclick);
    var m = new String(obj.parentElement.onmousedown);
    if (c.indexOf('tempList.nodeClick') >= 0 ||
        m.indexOf('tempList.nodeClick') >= 0)
        return true;
    return evaluateParentsForNodes(obj.parentElement);
}

function checkParents(obj)
{
    if (!obj || !obj.parentElement)
        return null;
    if (obj.parentElement.tagName == 'A')
        return obj.parentElement;
    return checkParents(obj.parentElement);
}

// Double Click Functions
// ...end...