<%@ include file="/common/taglibs.jsp" %>
<%@ page import="java.util.List" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<link rel="stylesheet" href="resources/sas/hc/ui/core/themes/sas_base/fonts.css" type="text/css"/>
<link rel="stylesheet" href="resources/sap/ui/core/themes/sas_corporate/library.css" type="text/css">
<link rel="stylesheet" href="resources/sap/ui/commons/themes/sas_corporate/library.css" type="text/css">
<link rel="stylesheet" href="resources/sas/hc/ui/core/themes/sas_corporate/library.css" type="text/css"/>
<link rel="stylesheet" href="resources/sas/hc/ui/commons/themes/sas_corporate/library.css" type="text/css"/>
<link rel="stylesheet" href="resources/sap/m/themes/sas_corporate/library.css" type="text/css"/>

<link rel='stylesheet' href='common/styles/sasStyles.css' type='text/css'>
<link rel='stylesheet' href='rules/styles/rules.css' type='text/css'>
<link rel='stylesheet' href='common/styles/cf.css' type='text/css'>
<link rel='stylesheet' href='admin/styles/admin.css' type='text/css'>

<script language="JavaScript" src='common/scripts/jquery.js'></script>
<SCRIPT language="JavaScript" src="common/scripts/cf.js"></SCRIPT>
<script language="JavaScript" src="common/scripts/jquery.fcm.dynaform.js"></script>
<script language="JavaScript" src="rules/scripts/rules.js"></script>
<script language="JavaScript" src="rules/scripts/tasks.js"></script>
<script language="JavaScript" src="rules/scripts/ruleActions.js"></script>
<script language="JavaScript" src="rules/scripts/dynamicRows.js"></script>
<script language="JavaScript" src="rules/scripts/itemPriorityList.js"></script>
<script language="JavaScript" src="rules/scripts/autoSizing.js"></script>
<SCRIPT language="JavaScript" src="common/scripts/calendar.js"></SCRIPT>
<SCRIPT language="JavaScript" src="rules/scripts/sort.js"></SCRIPT>

<link rel="stylesheet" href="/resources/demos/style.css">
<style>
     DIV.scrollableGrid
      {
         BORDER-RIGHT: none;
         BORDER-TOP:  none;
         BORDER-LEFT: none;
         BORDER-BOTTOM: none;
         OVERFLOW: auto;
         TOP:0px;
         LEFT:0px;
         position:relative;
         vertical-align:top;
      }

      DIV.scrollableGrid thead th {z-index:30; position:relative;top: expression(getElementById("ruleDiv").scrollTop); }

      .rowSelected
      {
         background-color:#ddddee;
         color:#648BB9;
      }

eXtremeTable .odd a, .even a {
   color: Black;
   font-size: .88rem;
   background-color : #FFFFFF;
}

.eXtremeTable .odd td, .eXtremeTable .even td {
   padding-top: 2px;
   padding-right: 3px;
   padding-bottom: 2px;
   padding-left: 3px;
   vertical-align: middle;
   font-family: AvenirNext,verdana, arial, helvetica, sans-serif;
   font-size: .88rem;
}

.eXtremeTable .odd {
   background-color: #FFFFFF;
}

.eXtremeTable .even {
   background-color : #f0f1f2;
}
.eXtremeTable .toolbar {

   font-family: AvenirNext,verdana, arial, helvetica, sans-serif;
   font-size: 9px;
   margin-right: 1px;

}

.eXtremeTable .toolbar td {
   color: #444444;
   padding: 0px 3px 0px 3px;
   text-align:center;
}

.eXtremeTable .separator {
   width: 7px;
}
.eXtremeTable .title {
   color: #444444;
   font-weight: bold;
   font-family: AvenirNext,'Trebuchet MS', Verdana, Arial, Helvetica, sans-serif;
   font-size: .88rem;
   vertical-align: bottom;

}

.eXtremeTable .title span {
   margin-left: 0px;

}
.eXtremeTable .tableHeaderSort {

   border-top: 1px solid #E6DAC2;
   border-bottom: 1px solid #E6DAC2;
   border-right:none;
   border-left: none;
   color:#353535;
   font-weight:bold;
   font-family : AvenirNext,'Trebuchet MS', Verdana, Arial, Helvetica, sans-serif;
   font-size : .88rem;
   background-color : #f0f1f2;
   text-decoration:underline;
   text-align:left;
}


</style>



<script type='text/javascript'>
$(document).ready(function(){  // RAPTOR-2399
	var table = $('table')[3];
	var rowGroups = {};
	//loop through the rows excluding the first two rows (the header rows)
	while(table.rows.length > 2){
	    var row = table.rows[2];
	    var id = $(row.cells[4]).text();
	    if(!rowGroups[id]) rowGroups[id] = [];
	    if(rowGroups[id].length > 0){
	        row.className = 'subrow';
	        $(row).slideUp();
	    }
	    rowGroups[id].push(row);
	    table.deleteRow(2);
	}
	//loop through the row groups to build the new table content
	for(var id in rowGroups){
	    var group = rowGroups[id];
	    for(var j = 0; j < group.length; j++){
	        var row = group[j];

	        if(group.length > 1 && j == 0) {
	            //add + button
	            var lastCell = row.cells[row.cells.length - 1];
	            $("<span class='collapsed'>").appendTo(lastCell).click(plusClick);
	        }
	        table.tBodies[0].appendChild(row);
	    }
	}
	//function handling button click
	function plusClick(e){
	    var collapsed = $(this).hasClass('collapsed');
	    $(this).closest('tr').nextUntil(':not(.subrow)').slideToggle(400).css('font-style','italic');;
	    $(this).toggleClass('collapsed');
	}
});

</script>
<style>
.subrow {
    font-size:0;
    transition:font-size 400ms;

}
td > span {
    float:right;
    width:1em;
    height:1em;
    position:relative;
    margin-right:3px;
}
td > span:before {
    content:'';
    position:absolute;
    width:100%;
    height:0;
    left:10%;
    top:60%;
    margin-top:-1px;
    border-top:2px solid black;
    border-color:inherit;
}
td > span.collapsed:after {
    content:'';
    position:absolute;
    height:100%;
    width:0;
    margin-left:-1px;
    border-left:2px solid black;
    border-color:inherit;
    left:60%;
    top:10%;

}
td > span:hover {
    border-color:blue;
}
</style>

<%-- Error handling code --%>
<style>
   .confirmationMessage { text-align:left; }
   .errorMessage { text-align:left; }
</style>
<div onclick="this.innerHTML='<br>'">
   <c:url var="reloadURL" value="/r_rules.do?method=listRules&ruleFolder=${esapi:encodeForURL(ruleFolder)}&showAll=true" />
   <tiles:insert page="rulesSystemMessages.jsp" flush="true">
     <tiles:put name="reloadURL" value="${reloadURL}" />
    <tiles:put name="refreshURL" value="${reloadURL}&refresh=true" />
     <tiles:put name="objectTypeName" value="Rule" />
   </tiles:insert>
</div>

<div id="preTableBlock" align="left">
	<H4>
	 	<fmt:message key="rules.diagnostic.transactionHistoryForUserVariable.fmt.txt">
 			<fmt:param value="${fieldName}"/>
 		</fmt:message>
	</H4>
</div>

<br>
<table style="width:96%">
<tr><td>

<ec:table
                items="uvHist"
                var="txnsFired"
                action="r_rules.do"
                title=""
                width="100%"
                sortable="true"
                filterable="false"
                showExports="false"
                showStatusBar="true"
                showPagination="true"
		        tableId="rulesTxns"
                styleClass="mainTable"
                view="html2"
                >
    <ec:row>
	<c:forEach var="cols" items="${colNames}">
	<c:set var="uv" value="${cols}"/>
			<c:choose>
				<c:when test="${fn:substring(cols,0,1)=='_'}">
						<ec:column property="${cols}" headerCell="XssAwareHeaderClass" title="${esapi:encodeForHTML(cols)}"  headerClass="tableHeader" headerStyle="background-color:#77e1dc;border-top:1px solid#7F9DB9;border-right:none;color:#353535;font-weight:bold;vertical-align: top;" styleClass="numericTableCell">
						<c:choose>
							<c:when test="${fn:substring(txnsFired[uv],0,3)=='***'}">
								<span style="color:#ff0000;font-style:italic;">${esapi:encodeForHTML(fn:substring(txnsFired[uv],3,50))}</span>
							</c:when>
							<c:otherwise>${esapi:encodeForHTML(txnsFired[uv])}</c:otherwise>
						</c:choose>
						</ec:column>

				</c:when>
				<c:otherwise>
					<c:if test="${!fn:containsIgnoreCase(cols,'FIELD_ID')}">
					<c:set var="title" value="${esapi:encodeForHTMLAttribute(cols)}"/>
						<c:if test="${fn:containsIgnoreCase(cols,'rqo_proc_utc_datetime') ||  fn:containsIgnoreCase(cols,'cmx_tran_id') || fn:containsIgnoreCase(cols,'trantype')|| fn:containsIgnoreCase(cols,'vxx_build_num')}">
							<c:set var="title">
								<fmt:message key='fcm.reports.column.header.${esapi:encodeForHTML(fn:toLowerCase(cols))}.txt'/>
							</c:set>
						</c:if>


						<ec:column property="${cols}"  headerCell="XssAwareHeaderClass" title="${title}"  headerClass="tableHeader" headerStyle="border-top:1px solid#7F9DB9;border-right:none;color:#353535;font-weight:bold;vertical-align: top;" styleClass="numericTableCell">
						<c:choose>
							<c:when test="${txnsFired[uv]=='NULL VALUE'}">
								&nbsp;
							</c:when>
							<c:otherwise>${esapi:encodeForHTML(txnsFired[uv])}</c:otherwise>
						</c:choose>
						</ec:column>

					</c:if>
				</c:otherwise>
			</c:choose>
		</c:forEach>
	</ec:row>
</ec:table>


</td></tr>
</table>


