<!DOCTYPE html>
<%@ page language="java" session="true" %>
<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<HTML>



<HEAD>
<meta http-equiv="X-UA-Compatible" content="IE=edge">

<title><fmt:message key="rules.lookupListFileTypePopup.download.title.txt"/></title>

<link rel="stylesheet" href="resources/sas/hc/ui/core/themes/sas_base/fonts.css" type="text/css"/>
<link rel="stylesheet" href="resources/sas/hc/ui/core/themes/sas_corporate/library.css" type="text/css"/>
<link rel="stylesheet" href="resources/sas/hc/ui/commons/themes/sas_corporate/library.css" type="text/css"/>
<link rel="stylesheet" href="resources/sap/m/themes/sas_corporate/library.css" type="text/css"/>
<style type='text/css'>@import 'common/styles/sasStyles.css';</style><link rel='stylesheet' href='common/styles/cf.css' type='text/css'>
<style type='text/css'>@import 'admin/styles/admin.css';</style>
<style type=text/css>@import "common/styles/calendar.css";</style>
<script language='JavaScript' src='common/scripts/jquery.js'></script>
<script language='JavaScript' src='common/scripts/i18n.js'></script>
<script language='JavaScript' src='rules/scripts/lookupLists.js'></script>
<script>
   function closeDialog()
   {
      window.close();
   }

   function returnRadio()
   {
      var fileType;
      if (document.fileTypeChoice.fileTypeRadio[0].checked)
         fileType = 'sas';
      else if (document.fileTypeChoice.fileTypeRadio[1].checked)
         fileType = 'csv';

      window.returnValue = fileType;
      $('#fileTypeChoice').prop('action', function (i, action) { return action.replace(/([\?&])(fileType=)[^&#]*/, '$1$2' + fileType); });

      document.fileTypeChoice.submit();
      window.close();
   }
</script>
</HEAD>

<BODY class="dialogBody sapUiBody sapUiSizeCompact" onload="i18n.init();document.fileTypeChoice.fileTypeRadio[1].blur()">
<c:url var="url" value="/r_lookupLists.do">
   <c:param name="method" value="${param.method}" />
   <c:param name="fileType" value="${fileType}" />
   <c:param name="inds" value="${param.inds}" />
   <c:param name="contentOrList" value="${param.contentOrList}" />
   <c:param name="downloadFrame" value="${param.downloadFrame}" />
</c:url>
<form name="fileTypeChoice"
      id="fileTypeChoice"
      action="${url}"
      onsubmit=""
      target="${param.downloadFrame}"
      enctype="multipart/form-data"
      method="post">
 <input type="text" style="display:none;">

 <table border ="0" width="100%" class="configurationTable" border="0" cellspacing="0" cellpadding="0" style="margin:0px">
 <c:if test="${not empty updtRules}">
    <tr style="margin:0px;">
      <td colspan="3" style="font-weight:bold;background-color:#287eab;color:white;padding:0px;" align="center"><fmt:message key="rules.lookupListFileTypePopup.download.title.txt"/></td>
    </tr>
    <tr class="configurationTableDataRow">
      <td valign="top" nowrap><img src="images/rules/help.gif"></td>
      <td valign="bottom"><fmt:message key="rules.lookupListFileTypePopup.selectFileType.txt"/></td>
      <td>&nbsp;&nbsp;</td>
    </tr>
    <tr class="configurationTableDataRow">
      <td valign="top"></td>
      <td valign="top" nowrap><input type="radio" name="fileTypeRadio" checked="checked"><fmt:message key="rules.lookupListFileTypePopup.selectFileTypeSAS.txt"/><br>
                              <input type="radio" name="fileTypeRadio"><fmt:message key="rules.lookupListFileTypePopup.selectFileTypeCSV.txt"/></td>
      <td>&nbsp;&nbsp;</td>
    </tr>
    <tr class="configurationTableDataRow"><td colspan="3"> &nbsp;</td></tr>
    <tr class="configurationTableDataRow">
      <td align="center" colspan="3" style="padding-top:4px;" nowrap>
	     <button class="sapMBarChild sapMBtn sapMBtnBase sasMButton" type="button" onclick="returnRadio();">
		   <span class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMBtnText sapMFocusable sapMIE">
    		 <span class="sapMBtnContent"><esapi:encodeForHTMLAttribute><fmt:message key="rules.lookupListFileTypePopup.button.ok.txt"/></esapi:encodeForHTMLAttribute></span>
    		 <span class="sapMBtnFocusDiv"></span>
  		   </span>
	     </button>
      </td>
    </tr>
 </c:if>
 <c:if test="${empty updtRules}">
	 <tr class="configurationTableDataRow"><td colspan="2">
	<fmt:message key="rules.privilege.unauthorized.for.service.txt"/> : <fmt:message key="rules.lookupListFileTypePopup.pageName.txt"/>
	  </td></tr>
 </c:if>

 </table>

</form>

</BODY>
</HTML>
