<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<html>
<head>
<title><fmt:message key="rules.printableVariables.pageTitle.txt"/></title>

<style type='text/css'>@import 'common/styles/sasStyles.css';</style><link rel='stylesheet' href='rules/styles/rules.css' type='text/css'>  <link rel='stylesheet' href='common/styles/cf.css' type='text/css'>  <style type='text/css'>@import 'admin/styles/admin.css';</style>

<script language='JavaScript' src='common/scripts/jquery.js'></script>
<script language='JavaScript' src='common/scripts/sasSolutions.js'></script><script language='JavaScript' src='common/scripts/cf.js'></script><script language='JavaScript' src='admin/scripts/admin.js'></script><script language='JavaScript' src='rules/scripts/ruleSasTest.js'></script>
<script>

  // Loads opener's variable table for display
  function loadVariablesFromOpener()
  {
    var theOpener = (window.opener) ? window.opener : window.dialogArguments;
    var title = theOpener.document.getElementById('variableListTitle').innerHTML;
    document.getElementById('variableListTitle').innerHTML = title;
    var lines = new Array();
    lines.push('<table width="100%" align="left" border="1" cellspacing="0" cellpadding="4">');

    // Copy column headers from opener
    var trs = theOpener.document.getElementById('tableHead').getElementsByTagName('TR');
    for (var r=0; r<trs.length; r++)
    {
      lines.push('<tr>');
      var ths = trs[r].getElementsByTagName('TH');
      for (var h=0; h<ths.length; h++) {
        var anchors = ths[h].getElementsByTagName('A');
        lines.push('<th nowrap>' + anchors[0].innerHTML + '</th>'); // S0881932
      }
      lines.push('</tr>');
    }

    // Copy data cells from opener
    var trs = theOpener.document.getElementById('ruleTableBody').getElementsByTagName('TR');
    for (var r=0; r<trs.length; r++)
    {

      if (trs[r].style.color && trs[r].style.color.toUpperCase()!='RGB(0, 0, 0)' && trs[r].style.color.toUpperCase()!='') {
        lines.push('<tr>');
        var tds = trs[r].getElementsByTagName('TD');
        for (var d=0; d<tds.length; d++) {
          lines.push('<td>' + tds[d].innerHTML + '&nbsp;</td>'); // S0881932
        }
        lines.push('</tr>');
      }
    }

    lines.push('</table>');
    document.getElementById('variableListTable').innerHTML = lines.join('\n');
  }
</script>

<style>
  TD {font-family: helvetica,ariel,sans-serif;
      vertical-align: top;
      color: black;
      font-size: x-small;
   }
  TH {font-family: helvetica,ariel,sans-serif;
      vertical-align: top;
      color: black;
      font-size: small;
   }
</style>
</head>

<body onload="loadVariablesFromOpener()">

  <div align="left" id='variableListTitle' style="font-size:small;font-weight:bold;font-family:helvetica,ariel,sans-serif;">
    <fmt:message key="rules.printableVariables.loading.txt"/>
  </div>

  <div style="font-size: x-small;font-family: helvetica,ariel,sans-serif;"><fmt:formatDate value="<%=new java.util.Date()%>" pattern="${dateTimeFormat}" timeZone="${userTimeZone}"/></div> <!-- S1047619 -->

  <br/>

  <div align="left" id='variableListTable'>
  </div>

</body>

</html>
