<%@ page language="java" session="true" %>
<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<script language="JavaScript" src="rules/scripts/rules.js"></script>

<!-- Overriding styles -->

<STYLE>

/* Override styles from admin.css */
BODY{
   text-align:center;
}

.ruleIdeTable
{
    background-color: #f0f1f2;
    border-collapse: separate;
    border: 0px;
    padding-left: 2px;
    vertical-align: top;
}
.ruleIdeTableLabel
{
   padding-left: 10px;
   text-align: left;
}
.ruleIdeTableValue
{
   padding-left: 0px;
   text-align: left;
   white-space: nowrap;
}
.ruleIdeTableDataRow TD
{
   padding-top: 2px;
}
.ruleIdeTableComponentRow TD
{
   padding-top: 0px;
}
.componentClosedHeadHover
{
   background-color: #287eab;
   border: 1px solid #719db9;
   padding-left:5px;
   cursor:pointer;
}
.componentOpenHeadHover
{
   background-color: #287eab;
   border: 1px solid #719db9;
   padding-left:5px;
   cursor:pointer;
}
.componentClosedHead
{
   background-color: #287eab;
   border: 1px solid #f0f1f2;
   padding-left:5px;
   cursor:pointer;
}
.componentOpenHead
{
   background-color: #287eab;
   border-top:1px solid #719db9;
   border-left:1px solid #719db9;
   border-right:1px solid #719db9;
   border-bottom:1px solid #719db9;
   padding-left:5px;
   cursor:pointer;
}
.componentSubTypeLabel
{
   background-color:white;
   border-left:1px solid #719db9;
   border-right:1px solid #719db9;
   padding-left:5px;
   text-align:left;
}
.componentSubTypeLine
{
   background-color:white;
}
.componentSubTypeLineLeft
{
   background-color:white;
   border-left:1px solid #719db9;
}
.componentSubTypeLineRight
{
   background-color:white;
   border-right:1px solid #719db9;
}
.componentSubTypeLineLabel
{
   text-align:left;
   cursor:pointer;
}
.componentValuesClosed
{
   background-color:#f0f1f2;
}
.componentValuesOpen
{
   background-color:#e0e2e5;
}

</STYLE>

<script language="JavaScript">
//<!--
i18n.init(); // RAPTOR-3136

var action = '<c:url value="/r_txnDefinition.do"/>';

//do we need all of these?
// Load user variable segment key segment IDs
var UserVarSegmentKeys = new Object();
<c:forEach var="userSeg" items="${userVariableSegments}">
  <c:if test="${userSeg.segmentKeyFieldCount>0}">
    UserVarSegmentKeys['${userSeg.segmentId}'] = ['<%= ((com.sas.finserv.creditfraud.rules.domain.UserSegment) pageContext.getAttribute("userSeg")).getSegmentKeySegmentIds("','") %>'];
  </c:if>
</c:forEach>


// Load valid transaction-to-component mapping
var TransactionComponentsMap = new Array();
<c:forEach var="t" items="${sasEditorSelectorMaps.tranLabelMap}"> TransactionComponentsMap["${t.key}"]=new Array();
</c:forEach>
<c:forEach var="t" items="${sasEditorSelectorMaps.tranLabelMap}"><c:forEach var="c" items="${sasEditorSelectorMaps.tranCompsMap[t.key]}">TransactionComponentsMap["${t.key}"]["${c}"]="${c}";
</c:forEach></c:forEach>

// Load valid component-to-segment mapping
var ComponentSegmentsMap = new Array();
<c:forEach var="c" items="${sasEditorSelectorMaps.compSegsMap}">ComponentSegmentsMap["${c.key}"]=${c.value};
</c:forEach>


// Load System component ids
var SystemComponentIds = new Array();
<c:forEach var="s" items="${sasEditorSelectorMaps.compLabelMap.SYSTEM}"> <c:if test="${s.value=='TRX'}">SystemComponentIds.push("${s.id}");</c:if>
</c:forEach>

// Load possible prereqs
<% pageContext.setAttribute("newLine", "\n"); %>
<% pageContext.setAttribute("return", "\r"); %>
var preRequisiteLabelMap = new Array();
<c:forEach var="p" items="${Possibles}"> preRequisiteLabelMap["#${p.baseRuleId}"]="<c:out value='${p.label}' escapeXml='false'/>";
</c:forEach>

// Load transactionKey to label mapping
var TransactionLabelMap = new Array();
<c:forEach var="t" items="${sasEditorSelectorMaps.tranLabelMap}">TransactionLabelMap["<c:out value='${t.key}'/>"]="<c:out value='${t.value}' escapeXml='false'/>";
</c:forEach>

// Load segmentId to label mapping (also note ID of RUV segment for ruleType=uservar)
var SegmentLabelMap = new Array();
<c:forEach var="s" items="${sasEditorSelectorMaps.segLabelMapEscaped}">SegmentLabelMap["<c:out value='${s.key}'/>"]="<c:out value='${s.value}' escapeXml='false'/>";
</c:forEach>

// Load fieldId to fieldLabel mapping
var FieldLabelMap = new Array();
<c:forEach var="f" items="${sasEditorSelectorMaps.fieldLabelMapEscaped}">FieldLabelMap["<c:out value='${f.key}'/>"]="<c:out value='${f.value}' escapeXml='false'/>";
</c:forEach>

// Load transactionKey to segmentId mapping (negative tranIds are for R/C common segment lists)
var TransactionSegmentsMap=new Array();
<c:forEach var="t" items="${sasEditorSelectorMaps.tranSegsMap}">TransactionSegmentsMap["<c:out value='${t.key}'/>"]=<c:out value='${t.value}' escapeXml='false'/>;
</c:forEach>

// Load segmentId to fieldId mapping
var SegmentFieldsMap=new Array();
<c:forEach var="s" items="${sasEditorSelectorMaps.segFieldsMap}">SegmentFieldsMap["<c:out value='${s.key}'/>"]=<c:out value='${s.value}' escapeXml='false'/>;
</c:forEach>

// Load lists of segments legal in each engine
var oseRuleSegmentIds = new Array();
<c:forEach var="c" items="${sasEditorSelectorMaps.consumerSegmentIds.OSE}">oseRuleSegmentIds["${c}"]=true;
</c:forEach>

// Load ruleTypeKey to label mapping
var ruleTypeLabelMap = new Array();
<c:forEach var="r" items="${sasEditorSelectorMaps.ruleTypeLabelMap}">ruleTypeLabelMap["<c:out value='${r.key}'/>"]="<c:out value='${r.value}' escapeXml='false'/>";
</c:forEach>

// Load ruleTypeKey to ruleTypeCode mapping
var ruleTypeCodeMap = new Array();
<c:forEach var="r" items="${sasEditorSelectorMaps.ruleTypeCodeMap}">ruleTypeCodeMap["<c:out value='${r.key}'/>"]="<c:out value='${r.value}' escapeXml='false'/>";
</c:forEach>

var reloadParams = '?method=listTransactions&treeSelectedTransaction=${transactionType.id}';

//-->
</script>

      <table  align="center" width="100%" name="searchView" cellspacing="0" cellpadding="0" style="margin-top:0px">
         <THEAD>
            <TR><TH scope="col" style="margin:0px;padding:0px;border:0px;" nowrap>
               
            </TH></TR>
         </THEAD>
         <TBODY><TR><TD valign="top" style="background-color:#f0f1f2">
<%-- Error handling code --%>
	<c:url var="reloadURL" value="/r_txnAdmin.do?method=listTransactions&treeSelectedTransaction=${transactionType.id}" />
	<tiles:insert page="/admin/adminDetailErrorHandling.jsp" flush="true">
		<tiles:put name="reloadURL" value="${reloadURL}" />
		<tiles:put name="refreshURL" value="${reloadURL}&refresh=true" />
		<tiles:put name="objectTypeName" value="transaction" />
	</tiles:insert>         
            <form name="transactionForm" id="transactionForm" action="<c:url value='/r_txnDefinition.do'/>" method="post" >

            <input type="hidden" name="method" id="method" value="saveTransactionType" />
            <input type="hidden" name="componentIds" style="width:650px;" id="componentIds" value="${transactionType.componentIds}" />

            <div id="transactionPropertiesDiv" style="display:;background-color:#f0f1f2;">
              <tiles:insert page="/rules/tiles/transactionProperties.jsp"/>
            </div>
            </form>

         </TD></TR></TBODY>
      </table>

<%-- Pre-load spinner so it appears quickly when we need it --%>
<image style="height:0px;width:0px" src="common/images/spinner.gif">




