<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>
   <style type="text/css">@import "common/styles/sasStyles.css";</style>
   <style type="text/css">@import "includes/view.css";</style>
   <script language='JavaScript' src='<c:url value="/common/scripts/jquery.js"/>'></script>
   <script language='JavaScript' src='<c:url value="/common/scripts/i18n.js"/>'></script>
   <script language="JavaScript" src="includes/view.js"></script>
   <script language="JavaScript" src="common/scripts/tree.js"></script>
   <script type="text/javascript" src="common/scripts/jquery.fcm.dynaform.js" ></script>
   <script language="JavaScript" src="rules/scripts/tasks.js"></script>
   <script language="JavaScript" src="rules/scripts/transactions.js"></script>

<tiles:insert page="/rules/rulesOverviewInitToolbar.jsp"/>

<!-- Tree header. -->
<div class="sapUiTreeHeader" id="lookupListsHeader" role="heading">
	<div class="sapUiTreeTitle"><fmt:message key="rules.listTransactions.title.txt"/> : ${_buNameSelected}</div>
</div>

<!-- Nested tables with fixed height -->
<table id="overview_table" cellspacing=0 cellpadding=2 border="0"  >
   <tr>
      <td id="navcol" align="left" valign="top" nowrap>
      <script language="JavaScript">
    //<!--
    var _canModify = false;
	<c:if test="${updtTrxTyp==true}">_canModify = true;</c:if>
    var priv='${updtTrxTyp}';

    // Remove padding so menubar appears to be glued to the top
	   document.body.style.padding = "0";
	   var _selectedObject = getCookieForTab("-1", "_listTransactionTypes");
	   var _openRoot="0";
	   // Predefined Nodes
	   var _preNodes =  new Array();
	   var _preRoot = "2";
	   _params = new Array();
	   _params=['<c:url value="/r_txnAdmin.do"/>?method=getPredefinedTransactions'];
	   _preNodes[0]   = new Node(_preRoot,  0, "File",   "<esapi:encodeForHTMLAttribute><fmt:message key='rules.transactionsOverviewContent.predefinedTransactions.txt' /></esapi:encodeForHTMLAttribute>","<esapi:encodeForHTMLAttribute><fmt:message key='rules.transactionsOverviewContent.predefinedTransactions.txt' /></esapi:encodeForHTMLAttribute>", _params, "", "", "");
	   <c:if test="${not empty treeSelectedTransaction && treeSelectedTransaction==2 }">
	          _selectedObject = _preRoot;
	          _openRoot=_preRoot;
	   </c:if>

	   // Custom Nodes
	   var _custNodes =  new Array()
	   var _custRoot = "99";


	   	_custNodes[0]= new Node(_custRoot, 0, "folder", "<fmt:message key='rules.transactionsOverviewContent.customTransactions.txt' />","<fmt:message key='rules.transactionsOverviewContent.customTransactions.txt' />",new Array('<c:url value="/r_txnAdmin.do"/>?method=returnBlank'), "", "", "");
	   	<c:if test="${not empty customTransactions}">
	   		<c:forEach var="customTransaction" items="${customTransactions}" varStatus="cStatus">
	   			var node = new Node(${cStatus.count+200}, _custRoot,     "File", "${esapi:encodeForHTMLAttribute(customTransaction.desc)}","${esapi:encodeForHTMLAttribute(customTransaction.desc)}",   new Array('<c:url value="/r_txnAdmin.do"/>?method=#methodName#TransactionType',"id=${customTransaction.id}"), "", "", "");
		   		_custNodes.push(node);
		   		<c:if test="${not empty treeSelectedTransaction && treeSelectedTransaction==customTransaction.id }">
	   		   	_selectedObject = "${cStatus.count+200}";
	   	   	  	 _openRoot=_custRoot;
		   		</c:if>
	   	    </c:forEach>
	   </c:if>

	   var _isSomethingSelected = false;

	   if (_selectedObject == "-2"){
		   <c:if test="${fn:length(customTransactions)>0}">
		   _selectedObject="201";
		   setCookieForTab("201",null,"_listTransactionTypes");
		   </c:if>
		   <c:if test="${fn:length(customTransactions)==0}">
		   _selectedObject="99";
		   setCookieForTab("99",null,"_listTransactionTypes");
		   </c:if>
	   }
	   else if (_selectedObject == "-1"){
		   _selectedObject =getCookieForTab("2","_listTransactionTypes");
	   }
	   else	_isSomethingSelected = true;

	   var _allNodes = _preNodes.concat(_custNodes);
	   if (_selectedObject>200)
	   {
	   	_openRoot=_custRoot;
	   }
	   else if (_openRoot=="2")
	   {
	   	_openRoot=_preRoot;
	   }

	   var transactionTree = new Tree("transactionTree", _allNodes, 0, _openRoot, _selectedObject,
	   			 'showDetail(\'detail\',\'modify\')', false, false, true,
	   			 "common/images/tree/", "common/images/" );

	   // Generic method defined to show selected node
	   Tree.showSelectedAdminNode = function(){ transactionTree.showNode();};

	 //-->
	   </script>

 </td>
   </tr>
</table>
<%-- Error handling code --%>
<tiles:insert page="/admin/adminOverviewErrorHandling.jsp" flush="true">
	<tiles:put name="treeObj" value="transactionTree" />
	<tiles:put name="showCommand" value="showDetail" />
	<tiles:put name="showCommandArgs" value="detail modify" />
	<tiles:put name="window" value="window"/>
</tiles:insert>


