<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<style>

     DIV.scrollableGrid
      {
         BORDER-RIGHT: none;
         BORDER-TOP:  none;
         BORDER-LEFT: none;
         BORDER-BOTTOM: none;
         OVERFLOW: auto;
         TOP:0px;
         LEFT:0px;
         position:relative;
         vertical-align:top;
      }

      DIV.scrollableGrid thead th {z-index:30; position:relative;top: expression(getElementById("ruleDiv").scrollTop); }

      .rowSelected
      {
         background-color:#ddddee;
         color:#3300CC;
      }



</style>

<script language='JavaScript' src='common/scripts/jquery.js'></script>              <!-- S1077519 -->
<script language="JavaScript" src="common/scripts/jquery.fcm.dynaform.js"></script> <!-- S1077519 -->
<script language="JavaScript" src='common/scripts/i18n.js'></script>
<script language="JavaScript" src="rules/scripts/dynamicRows.js"></script>
<script language="JavaScript" src="rules/scripts/itemPriorityList.js"></script>
<script language="JavaScript" src="rules/scripts/autoSizing.js"></script>
<SCRIPT language="JavaScript" src="common/scripts/calendar.js"></SCRIPT>
<SCRIPT language="JavaScript" src="rules/scripts/sort.js"></SCRIPT>
<script language="JavaScript" src="rules/scripts/rules.js"></script>
<script language="JavaScript" src="rules/scripts/variables.js"></script>
<script language="JavaScript">
//<!--

var action = '<c:url value="/r_rules.do"/>';
var variableAction = '<c:url value="/r_variables.do"/>';
var workflow = '${definer}_${activity}_${segment}_variables';
var definer = '${definer}';
var activity = '${activity}';
var segment = '${segment}';
var segmorgid = '${segmorgid}';
var depth = '${depth}';
var variableId = '${variableInfo.segmentFieldId}';
var variableUpNbr = '${variableInfo.lstUpdtNbr}';
<c:set var='quot' value='"'/>
<c:set var='escquot' value='\\"'/>
var variableName = "${fn:trim(fn:replace(variableInfo.fieldBusinessName,quot,escquot))}";

function ignoreReturn(evt)
{
   if(!evt) evt = window.event;
   if(evt.keyCode == 13) return false;
   return true;
}

//-->
</script>


 <div id="rulesTabScrollableDiv" class="rulesTabScrollableClass">

 <%-- Error handling code --%>
 <div onclick="this.innerHTML='<br>'">
   <c:url var="reloadURL" value="/r_rules.do?method=editVariable&definer=${definer}&activity=${activity}&segment=${segment}&depth=${depth}&segmorgid=${segmorgid}" />
   <tiles:insert page="rulesSystemMessages.jsp" flush="true">
     <tiles:put name="reloadURL" value="${reloadURL}" />
     <tiles:put name="refreshURL" value="${reloadURL}&refresh=true" />
     <tiles:put name="objectTypeName" value="Rule" />
   </tiles:insert>
 </div>

<br><br>

<form name="variableForm" id="variableForm" action='<c:url value="/r_variables.do"/>'>
  <input type="hidden" name="variableId" id="variableId" value="${variableInfo.segmentFieldId}"/>
  <input type="hidden" name="variableUpNbr" id="variableUpNbr" value="${variableInfo.lstUpdtNbr}"/>
  <input type="hidden" name="fieldId" id="fieldId" value="${variableInfo.segmentFieldId}"/>
  <input type="hidden" name="fieldName" id="fieldName" value="${variableInfo.fieldName}"/>
  <input type="hidden" name="segmentIdVersion" id="segmentIdVersion" value="${variableInfo.segmentIdVersion}"/>
  <input type="hidden" name="segmentAcronym" id="segmentAcronym" value="${variableInfo.segmentAcronym}"/>
  <input type="hidden" name="segmentPrefixChar" id="segmentPrefixChar" value="${variableInfo.segmentPrefixChar}"/>
  <input type="hidden" name="segmentDesc" id="segmentDesc" value="${fn:escapeXml(variableInfo.segmentDesc)}"/>
  <input type="hidden" name="lstUpdtTimestamp" id="lstUpdtTimestamp" value="${variableInfo.lstUpdtTimestamp.time}"/>
  <input type="hidden" name="createTimestamp" id="createTimestamp" value="${variableInfo.createTimestamp.time}"/>
  <input type="hidden" name="createUser" id="createUser" value="${fn:escapeXml(variableInfo.createUser)}"/>
  <input type="hidden" name="lstUpdtUser" id="lstUpdtUser" value="${fn:escapeXml(variableInfo.lstUpdtUser)}"/>
  <input type="hidden" name="testUseCount" id="testUseCount" value="${variableInfo.testUseCount}"/>
  <input type="hidden" name="prodUseCount" id="prodUseCount" value="${variableInfo.prodUseCount}"/>
  <input type="hidden" name="segmentId" id="segmentId" value="${variableInfo.segmentId}"/>
  <input type="hidden" name="startingPosition" id="startingPosition" value="${variableInfo.fieldStartingPos}"/>

<div align="center">
<TABLE name="variableCreationTable" class="configurationTable" style="width:95%;border:2px solid #e0e2e5;margin-left:10px" cellspacing="0" cellpadding="2" border="0" >

  <tr align="left" valign="top" >
    <c:if test="${fn:startsWith(variableInfo.segmentAcronym,'Y')}">
    <th colspan="5" class="configurationTableTitle" >&nbsp;<fmt:message key="variable.variableUpdateContent.clientVariableDefinition.txt" /><br>&nbsp;</th>
    </c:if>
    <c:if test="${fn:startsWith(variableInfo.segmentAcronym,'V') || fn:trim(variableInfo.segmentAcronym)=='RUA' }">
    <th colspan="5" class="configurationTableTitle" >&nbsp;<fmt:message key="variable.variableUpdateContent.userVariableDefinition.txt" /><br>&nbsp;</th>
 	</c:if>
  </tr>

  <tr class="configurationTableDataRow" valign="top">
    <td colspan="5"> &nbsp;</td>
  </tr>

  <tr class="configurationTableDataRow" valign="top">
    <td style="width:15%;" nowrap><fmt:message key="variable.variableUpdateContent.name.txt" />:</td>
    <td style="width:85%;" nowrap>
    	<c:choose>
    	<c:when test="${(variableInfo.testUseCount > 0) || (variableInfo.prodUseCount > 0)}">
    		${fn:trim(fn:escapeXml(variableInfo.fieldBusinessName))}
    		<input type="hidden" id="businessName" name="businessName" value="${fn:trim(fn:escapeXml(variableInfo.fieldBusinessName))}"/>
    	</c:when>
    	<c:otherwise>
      		<input style="width:100%;" type="text" id="businessName" name="businessName" class="famTextEntry" maxlength="30" value="${fn:trim(fn:escapeXml(variableInfo.fieldBusinessName))}"/>
   		</c:otherwise>
   		</c:choose>
   </td>
   <c:set var="prefix">
   ${fn:trim(fn:escapeXml(fn:substring(variableInfo.fieldBusinessName,0,3)))}
   </c:set>
    	<script language="JavaScript">
		   $(document).ready(function() {
		   	var readOnlyLength = "${prefix}".length;
		   	$('#businessName').keydown(function(event) {
		      var $field = $(this);
		      if ((event.which != 37 && (event.which != 39))
		          && ((this.selectionStart < readOnlyLength)
		          || ((this.selectionStart == readOnlyLength) && (event.which == 8)))) {
		          return false;
		      }
		  	});
		   });
   	 	</script>
    <td nowrap>
       <fmt:message key="variable.variableUpdateContent.replicationCount.txt" />:
    </td>
    <td nowrap align="right">
      <c:set var="readonly" value=""/>
      <c:if test="${fn:trim(variableInfo.segmentAcronym)=='RUA'}">
        <c:set var="readonly" value="readonly='readonly'"/>
      </c:if>
      <c:choose>
      <c:when test="${(variableInfo.testUseCount > 0) || (variableInfo.prodUseCount > 0)}">
      	<c:choose><c:when test='${empty repCount}'>1</c:when><c:otherwise>${repCount}</c:otherwise></c:choose>
      	<input type='hidden' id="repCount" name="repCount" value="<c:choose><c:when test='${empty repCount}'>1</c:when><c:otherwise>${repCount}</c:otherwise></c:choose>" />
      </c:when>
      <c:otherwise>
      	<input type='text' id="repCount" name="repCount" ${readonly} value="<c:choose><c:when test='${empty repCount}'>1</c:when><c:otherwise>${repCount}</c:otherwise></c:choose>" style="width:3em;text-align:right;" />
   	  </c:otherwise>
   	  </c:choose>
   </td>
    <td>&nbsp;</td>
  </tr>


  <c:choose>
  <c:when test="${fn:trim(variableInfo.segmentAcronym)=='RUA'}">
    <input type="hidden" id="variableInitial" name="variableInitial" value="0"/>
    <tr class="configurationTableDataRow" valign="top">
      <td style="width:15%;" nowrap><fmt:message key="variable.variableUpdateContent.type.txt" />:</td>
      <td colspan='3' style="width:85%;">
        <c:if test="${fn:trim(variableInfo.variableType)=='Character'}">
           ${variableInfo.fieldLength}-Byte ${variableInfo.variableType}
        </c:if>
        <c:if test="${fn:trim(variableInfo.variableType)!='Character'}">
           ${variableInfo.variableType}
        </c:if>
      <td>&nbsp;</td>
      <input type="hidden" id="fieldLength"  name="fieldLength"  value="${variableInfo.fieldLength}" >
      <input type="hidden" id="variableType" name="variableType" value="${fn:trim(variableInfo.variableType)}" >
    </tr>
  </c:when>
  <c:otherwise>
  <tr class="configurationTableDataRow" valign="top">
      <td nowrap><fmt:message key="variable.variableUpdateContent.dataPop.txt" />: </td>
      <td colspan='3'>
        <input type="hidden" id=dataPopValue" name="dataPopValue" value="${fn:trim(variableInfo.dataPopValue)}" >
      	<select name="dataPopValueSelector" id="dataPopValueSelector" style='width:100%;' XonChange="OnTypeChange('dataPopValueSelector')" >
      	<option value="" <c:if test="${variableInfo.dataPopValue==null}">selected</c:if>><fmt:message key="variable.variableUpdateContent.dataPop.none.txt"/></option>
      	<c:forEach var="dataPopValue" items="${enumSegmentVariables}">
      		<option value="${fn:trim(dataPopValue.ENUMSEGMENTVARIABLE)}" <c:if test="${fn:trim(variableInfo.dataPopValue)==fn:trim(dataPopValue.ENUMSEGMENTVARIABLE)}">selected</c:if>>${fn:trim(dataPopValue.ENUMSEGMENTVARIABLE)}</option>
      	</c:forEach>
      	</select>
      </td>
      <td>&nbsp;</td>
    </tr>
    <tr class="configurationTableDataRow" valign="top">
      <td nowrap><fmt:message key="variable.variableUpdateContent.type.txt" />:</td>
      <td colspan='3'>
      <c:choose>
  		<c:when test="${(variableInfo.testUseCount > 0) || (variableInfo.prodUseCount > 0)}">

        <c:if test="${fn:trim(variableInfo.variableType)=='Character'}">
           ${variableInfo.fieldLength}-Byte ${variableInfo.variableType}
        </c:if>
        <c:if test="${fn:trim(variableInfo.variableType)!='Character'}">
           ${variableInfo.variableType}
        </c:if>
	    <input type="hidden" id="fieldLength"  name="fieldLength"  value="${variableInfo.fieldLength}" >
        <input type="hidden" id="variableType" name="variableType" value="${fn:trim(variableInfo.variableType)}" >
  		</c:when>
  		<c:otherwise>
         <select name="variableTypeSelector" id="variableTypeSelector" style='width:100%;' XonChange="OnTypeChange('variableTypeSelector')" >
             <option                                                                                                                  value="${variableInfo.FORMAT_TYPE_NUMERIC}"     ><fmt:message key="variable.variableUpdateContent.numeric.type.txt" /></option>
             <option <c:if test='${fn:trim(variableInfo.variableType)==variableInfo.FORMAT_TYPE_DATE    }'>selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_DATE}"        ><fmt:message key="variable.variableUpdateContent.date.type.txt" /></option>
             <option <c:if test='${fn:trim(variableInfo.variableType)==variableInfo.FORMAT_TYPE_TIME    }'>selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_TIME}"        ><fmt:message key="variable.variableUpdateContent.time.type.txt" /></option>
             <option <c:if test='${fn:trim(variableInfo.variableType)==variableInfo.FORMAT_TYPE_DATETIME}'>selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_DATETIME}"    ><fmt:message key="variable.variableUpdateContent.datetime.type.txt" /></option>
             <option <c:if test='${fn:trim(variableInfo.variableType)==variableInfo.FORMAT_TYPE_CURRENCY}'>selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CURRENCY}"    ><fmt:message key="variable.variableUpdateContent.currency.type.txt" /></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==8       }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 8" ><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>8</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==16      }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 16"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>16</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==24      }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 24"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>24</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==32      }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 32"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>32</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==40      }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 40"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>40</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==48      }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 48"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>48</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==56      }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 56"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>56</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==64      }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 64"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>64</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==72      }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 72"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>72</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==80      }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 80"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>80</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==88      }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 88"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>88</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==96      }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 96"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>96</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==104     }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 104"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>104</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==112     }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 112"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>112</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==120     }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 120"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>120</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==128     }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 128"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>128</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==136     }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 136"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>136</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==144     }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 144"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>144</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==152     }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 152"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>152</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==160     }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 160"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>160</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==168     }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 168"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>168</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==176     }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 176"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>176</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==184     }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 184"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>184</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==192     }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 192"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>192</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==200     }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 200"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>200</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==400     }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 400"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>400</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==600     }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 600"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>600</fmt:param></fmt:message></option>
             <option <c:if test="${variableInfo.character && variableInfo.fieldLength==800     }">selected="selected"</c:if> value="${variableInfo.FORMAT_TYPE_CHARACTER} 800"><fmt:message key="variable.variableUpdateContent.character.type.fmt.txt"><fmt:param>800</fmt:param></fmt:message></option>
         </select>
         </c:otherwise>
         </c:choose>
      </td>
      <td>&nbsp;</td>
    </tr>
    <tr class="configurationTableDataRow" valign="top">
      <td style="width:15%;" nowrap><fmt:message key="variable.variableUpdateContent.initialValue.txt" />: </td>
      <td colspan='3' style="width:85%;">
       <c:choose>
  		<c:when test="${(variableInfo.testUseCount > 0) || (variableInfo.prodUseCount > 0)}">
  			${fn:trim(fn:escapeXml(variableInfo.initialValue))}
  			<input type="hidden" id="variableInitial" name="variableInitial" value="${fn:trim(fn:escapeXml(variableInfo.initialValue))}"/>
  		</c:when>
  		<c:otherwise>
  			<input style="width:100%" type="text" id="variableInitial" name="variableInitial" class="famTextEntry" maxlength="200" value="${fn:trim(fn:escapeXml(variableInfo.initialValue))}">
  		</c:otherwise>
  	   </c:choose>
  	  </td>
      <td>&nbsp;</td>
    </tr>


  <tr class="configurationTableDataRow" valign="top">
      <td style="width:15%;" nowrap><fmt:message key="variable.variableUpdateContent.maskingType.txt" />:</td>
      <td colspan='3' style="width:85%;">
        <input type="hidden" id="maskingType" name="maskingType" value="${fn:trim(variableInfo.maskingType)}" >
	  	<select id="maskingTypeSelector" name="maskingTypeSelector" style='width:100%' XonChange="OnTypeChange('maskingTypeSelector')">
   		<option value="" > <fmt:message key="fcm.preferences.dataMasking.transaction.maskingTypeNone.txt" /> </option>
        <c:forEach var="dataMaskingObj" items="${dataMaskingObjs}" varStatus="tloop">
        	<option value="${esapi:encodeForHTML(dataMaskingObj.maskingType)}" ${(esapi:encodeForHTML(variableInfo.maskingType) eq esapi:encodeForHTML(dataMaskingObj.maskingType)) ? 'selected="selected"' : ''} > ${esapi:encodeForHTML(dataMaskingObj.maskingName)} </option>
        </c:forEach>
        </select>
	  </td>
      <td>&nbsp;</td>
  </tr>
  </c:otherwise>
  </c:choose>
  <tr class="configurationTableDataRow" valign="top">
    <td nowrap><fmt:message key="variable.variableUpdateContent.description.txt" />:</td>
    <td colspan='3'><textarea name="variableDesc" id="variableDesc" style="height:60px;width:100%;" wrap="PHYSICAL">${fn:trim(variableInfo.desc)}</textarea></td>
    <td>&nbsp;</td>
  </tr>

  <tr class="configurationTableDataRow" valign="top">
    <td colspan="5"> &nbsp;</td>
  </tr>

  <tr class="configurationTableDataRow" valign="top">
    <td style="width:15%;" nowrap><fmt:message key="variable.variableUpdateContent.segment.txt" />:</td>
    <c:choose>
    <c:when test="${fn:trim(variableInfo.segmentAcronym)=='RUA'}">
            <td style="width:85%;" colspan="3">
               ${variableInfo.segmentAcronym}: ${variableInfo.segmentDesc}
            </td>
    </c:when>
    <c:otherwise>
            <td style="width:85%;" colspan="3">
               ${variableInfo.segmentAcronym}: ${variableInfo.segmentDesc}
            </td>
    </c:otherwise>
    </c:choose>

    <td>&nbsp;</td>
  </tr>

 <c:if test="${not empty variableInfo.fieldName}">
  <tr class="configurationTableDataRow" valign="top">
     <td nowrap><fmt:message key="variable.variableUpdateContent.messageAlias.txt" />:</td>
     <td>${fn:toUpperCase(variableInfo.fieldName)}</td>
     <td nowrap><fmt:message key="variable.variableUpdateContent.deploymentBuildNumber.txt" />:</td>
     <c:if test="${variableInfo.hasBeenBuilt}">
        <td>${variableInfo.buildId}</td>
     </c:if>
     <c:if test="${!variableInfo.hasBeenBuilt}">
        <td><i><fmt:message key="variable.variableUpdateContent.na.txt" /></i></td>
     </c:if>
     <td>&nbsp;</td>
  </tr>
 </c:if>

  <tr class="configurationTableDataRow" valign="top">
     <td><fmt:message key="variable.variableUpdateContent.created.txt" />:</td>
     <td style="width:45%" nowrap>
        <fmt:formatDate value='${variableInfo.createTimestamp}' pattern='${dateTimeFormat}' timeZone='${userTimeZone}'/>
        &nbsp;
        <fmt:message key="variable.variableUpdateContent.byUser.fmt.txt">
           <fmt:param>${variableInfo.createUser}</fmt:param>
        </fmt:message>
     </td>
     <td nowrap><fmt:message key="variable.variableUpdateContent.testingRuleUseCount.txt" />:</td>
     <td>${variableInfo.testUseCount}</td>
     <td>&nbsp;</td>
  </tr>

  <tr class="configurationTableDataRow" valign="top">
     <td nowrap><fmt:message key="variable.variableUpdateContent.updated.txt" />:</td>
     <td nowrap>
        <fmt:formatDate value='${variableInfo.lstUpdtTimestamp}' pattern='${dateTimeFormat}' timeZone='${userTimeZone}'/>
        &nbsp;
        <fmt:message key="variable.variableUpdateContent.byUser.fmt.txt">
           <fmt:param>${variableInfo.lstUpdtUser}</fmt:param>
        </fmt:message>
     </td>
     <td nowrap><fmt:message key="variable.variableUpdateContent.productionRuleUseCount.txt" />:</td>
     <td>${variableInfo.prodUseCount}</td>
     <td>&nbsp;</td>
  </tr>

  <c:if test="${fn:trim(variableInfo.segmentAcronym)!='RUA' &&  !fn:startsWith(variableInfo.segmentAcronym, 'I') && !fn:startsWith(variableInfo.segmentAcronym, 'O')}"> <%-- S1010617 --%>
    <tr class="configurationTableDataRow" valign="top">        <%-- S1010617 --%>
      <td style="width:15%;" nowrap>                           <%-- S1010617 --%>
         <fmt:message key="variable.variableUpdateContent.businessUnit.txt" />:                                        <%-- S1010617 --%>
      <td style="width:60%;">                                  <%-- S1010617 --%>
         ${variableInfo.businessUnitName}                      <%-- S1010617 --%>
      </td>                                                    <%-- S1010617 --%>
      <td>&nbsp;</td>                                          <%-- S1010617 --%>
      <td>&nbsp;</td>                                          <%-- S1010617 --%>
      <td>&nbsp;</td>                                          <%-- S1010617 --%>
    </tr>                                                      <%-- S1010617 --%>
  </c:if>                                                      <%-- S1010617 --%>

  <tr class="configurationTableDataRow" valign="top">
    <td colspan="5"> &nbsp;</td>
  </tr>

  <tr class="configurationTableDataRow" valign="top">
    <td colspan="5"> &nbsp;</td>
  </tr>

  <tr class="configurationTableDataRow" valign="top">
    <td colspan="5"> &nbsp;</td>
  </tr>

</TABLE>

</div>

</div>


</form>


