<%@ page contentType="text/html; charset=UTF-8" %>
<%@ include file="/common/taglibs.jsp" %>

<c:if test="${displayType != 'viewAlert' || not empty displayEntity.relatedContacts || not empty displayEntity.currentAlert.alertActivity}">



	<table class="minWidthTable" border="0" cellspacing="0" cellpadding="0" style="margin-top:6px;">
		<thead>
			<tr>
				<th style="margin:0px;padding:0px;border:0px" nowrap>
					<div id="wrapUpTabs" class="tabs">
						<ul>
							<li id="alertActivityTab" class="current"><a href="javascript:;" onmousedown="swapGridContents('alertActivity',2);"><span><fmt:message key="fcm.alert.alertActivity.txt"/></span></a></li>
							<c:if test="${displayType != 'viewAlert'}">
								<li id="wrapTab"><a href="javascript:;" onmousedown="swapGridContents('wrap',2);"><span><fmt:message key="fcm.alert.callWrapUp.txt"/></span></a></li>
							</c:if>
							<li id="relatedTab"><a href="javascript:;" onmousedown="swapGridContents('related',2);" ><span><fmt:message key="fcm.alert.relatedContacts.txt"/></span></a></li>
						</ul>
					</div>
				</th>
			</tr>
		</thead>
		<tbody>
			<tr>
				<td>
					<%-- ------------ Begin Alert Activity GRID  ----------------------- --%>
						<tiles:insert page="alertActivity.jsp" flush="true"/>
					<%-- ------------ End Alert Activity GRID  ----------------------- --%>
					<c:if test="${displayType != 'viewAlert'}">
						<%-- begin wrapUp grid --%>
							<tiles:insert page="wrapUp.jsp" flush="true"/>
						<%-- end wrapUp grid --%>
					</c:if>
					<%-- ------------ Begin Related Contacts Grid  ----------------------- --%>
						<tiles:insert page="relatedContacts.jsp" flush="true"/>
					<%-- ------------ End Related Contacts Grid  ----------------------- --%>
				</td>
			</tr>
	</table>
	<c:if test="${empty displayEntity.relatedContacts}">
		<script>
			$(document).ready(function(){
				disableTab('related');
			});
		</script>
    </c:if>
	<c:if test="${empty displayEntity.currentAlert.alertActivity}">
		<c:choose>
			<c:when test="${displayType != 'viewAlert'}">
				<script>
				$(document).ready(function(){ // RAPTOR-2399
					disableTab('alertActivity');
					swapGridContents('wrap',2);
				});
				</script>
			</c:when>
			<c:otherwise>
				<script>
				$(document).ready(function(){  // RAPTOR-2399
					disableTab('alertActivity');
					swapGridContents('related',2);
				});
				</script>
			</c:otherwise>
		</c:choose>
	</c:if>
</c:if>