<%-- this file uses leading tabs; don't insert leading spaces --%>
<%@ page contentType="text/html; charset=UTF-8" %>
<%@ include file="/common/taglibs.jsp" %>
<c:set var="currentAlert" value="${checkoutManager.currentAlert}"/>
<c:set var="isAlertTransaction" value="${empty notAlertTransactions or not notAlertTransactions}" />
<c:set var="isTransactionActionable" value="${isAlertTransaction or not empty currentAlert and currentAlert.alertType.tranViewAlertType eq displayEntity.entityType.type}" />
<c:set var="isAlertNonDefaultTranView" value="${currentAlert.alertType.tranViewAlertType ne currentAlert.alertType.type and currentAlert.alertType.tranViewAlertType eq displayEntity.entityType.type}" />
<c:set var="displayTransactionMenus" value="${isTransactionActionable and displayType eq 'updateAlert' && updateAlerts && (manualAlerts && enableCreateAlertOnTrans || (addDataToLists || removeDataFromLists) && not empty entityTransactionActivity.analystLists)}" />
<c:set var="displayTraceIcon" value="${isTransactionActionable and accessExplorer}" />
<c:set var="acronym" value="${entityTransactionActivity.acronym}"/>
<c:set var="theAllTab" value="${acronym == 'ALL'}"/>
<c:set var="tableName" value="${esapi:encodeForHTMLAttribute(acronym)}Table"/>
<c:if test="${empty startRow}">
<c:set var="startRow" value="1"/>
</c:if>

<c:set var="analystLists" value="${entityTransactionActivity.analystLists}"/>

<div id="${esapi:encodeForHTMLAttribute(acronym)}OverflowContainer" class="scrollableGrid" onscroll="repositionTHs(this)" >
<table id="${tableName}" cellspacing="0" cellpadding="2" class="mainTable txn-data-table" style="width:100%;border:0px;border-collapse:separate;" onmouseout="unhighlightDatapop(event)" onmouseover="highlightDatapop(event)">
<thead>
<tr>
<th class="txnTableHeader">&nbsp;</th>
<th class="txnTableHeader">&nbsp;</th>
<th class="txnTableHeader" title="<fmt:message key='fcm.alert.confirmedFraudWithAlert.txt'/>"><img src="analyst/images/fraudTxnInd.gif" class="icon" width="16" height="16"/></th>
<th class="txnTableHeader" title="<fmt:message key='fcm.alert.confirmedFraud.txt'/>" width="20px"><fmt:message key="fcm.alert.cf.txt"/></th>
<c:if test="${theAllTab}">
<th class="txnTableHeader" title="<fmt:message key='fcm.alert.transactionType.txt'/>"><fmt:message key="fcm.alert.type.txt"/></th>
</c:if>
<c:forEach var="fieldDefinition" items="${entityTransactionActivity.fieldDefinitions}" varStatus="status">
<c:set var="hotlist"/>
<c:if test="${analystLists.containsKey(fieldDefinition.id)}"><c:set var="hotlist" value="${analystLists[fieldDefinition.id]}"/></c:if>
<th class="txnTableHeader<c:if test="${status.last}"> lastCol</c:if>" title="${esapi:encodeForHTMLAttribute(fieldDefinition.labelDesc)}" <c:if test="${not empty hotlist}">hotlist="${hotlist.id}"</c:if>>
<c:if test="${not empty hotlist}"><img src="analyst/images/Bullets.gif" title="<esapi:encodeForHTMLAttribute><fmt:message key='fcm.alert.registeredAnalystList.txt'/></esapi:encodeForHTMLAttribute>: ${esapi:encodeForHTMLAttribute(hotlist.name)}"/></c:if> ${txns:addSortEvent(fieldDefinition, theAllTab)}</th>
</c:forEach>
</tr>
</thead>
<tbody>
<c:set var="confirmedFraudCounter" value="0"/>
<c:forEach var="dataValues" items="${entityTransactionActivity.dataValues}" varStatus="loop">
<c:set var="TRANSACTION_ID">${dataValues['TRANSACTION_ID']}</c:set>
<c:set var="TRANSACTION_NAME" value="${dataValues['TRANSACTION_NAME']}"/>
<c:set var="TRANSACTION_TIMESTAMP" value="${dataValues['TRANSACTION_TIMESTAMP'].getTime()}"/>
<%--
<c:if test="${dataValues['WAX_USER_FRAUD_IND'] eq '1'}">
<c:set var="confirmedFraudCounter" value="${confirmedFraudCounter+1}"/>
</c:if>
--%>
<tr class="dataRow${(loop.count-1)%2+1}_tableRow" ${txns:checkCreateAlert(dataValues)}>
<%-- permissions: can create manual and can update alerts
<c:choose>
<c:when test="${displayType eq 'updateAlert' && manualAlerts && updateAlerts && enableCreateAlertOnTrans}">
<td class="imageTableCell" style="cursor:pointer;" title="<esapi:encodeForHTMLAttribute><fmt:message key="fcm.alert.createAlertOnTransactionTitle.txt"/></esapi:encodeForHTMLAttribute>"
onclick="showAlertTypeSelection(event,'${TRANSACTION_ID}','${TRANSACTION_NAME}')">${startRow + loop.count -1}</td>
</c:when>
<c:otherwise>
<td class="imageTableCell">${startRow + loop.count -1}</td>
</c:otherwise>
</c:choose>
--%>
<td class="imageTableCell">${startRow + loop.count -1}</td>

<td class="imageTableCell" style="cursor:pointer;">
<%-- c:if test="${displayType eq 'updateAlert' and (dataValues['CREATE_ALERT_IND'] eq '1') or (isAlertTransaction  and dataValues['USER_FRAUD_LOCK_IND'] eq '0')}" --%>

<c:if test="${displayTransactionMenus}">
<img border="0" width="16" height="16" class="icon" src="analyst/images/menu.gif" title="<esapi:encodeForHTMLAttribute><fmt:message key='fcm.alert.transactionActionMenu.txt'/></esapi:encodeForHTMLAttribute>"
onclick="showTxnMenu(event, '${TRANSACTION_ID}', '${TRANSACTION_NAME}', '${tableName}');" />
</c:if>
</td>
<td class="imageTableCell">
<c:set var="cfAlerts" value="${txns:getTxnFraudAlerts(dataValues)}"/>
<c:if test="${not empty cfAlerts}">
<a href="javascript:;" onclick="getTxnFraudAlerts(event,'${cfAlerts}')"><img src="analyst/images/fraudTxnInd.gif" class="icon" width="16" height="16"/></a>
</c:if>
</td>
<c:choose>
<c:when test="${theAllTab}">
<td class="imageTableCell" style="padding:0px;">
<c:choose>
<c:when test="${isAlertTransaction and displayType eq 'updateAlert'}"> <%-- and dataValues['USER_FRAUD_LOCK_IND'] eq '0'}"--%>
<c:if test="${currentAlert.alertType.tranMarkInd}">
<c:if test="${dataValues['WAX_USER_FRAUD_IND'] eq '1'}"> <img border="0" width="10" height="8" class="icon" src="analyst/images/check.gif"/> </c:if>
</c:if>
<c:if test="${not currentAlert.alertType.tranMarkInd}">
<input id="ALL_${TRANSACTION_NAME}_${TRANSACTION_ID}_${TRANSACTION_TIMESTAMP}" type='checkbox' ${txns:checkUserFraud(dataValues)} onclick="markTransaction(this, 'ALL')" />
</c:if>
</c:when>
<c:when test="${dataValues['WAX_USER_FRAUD_IND'] eq '1'}">
<img border="0" width="10" height="8" class="icon" src="analyst/images/check.gif"/>
</c:when>
<c:otherwise>
<c:if test="${not isAlertNonDefaultTranView}">
<img border="0" width="10" height="8" class="icon" src="common/images/spacer.gif"/>
</c:if>
</c:otherwise>
</c:choose>
<!-- enable marking of the alerted transaction on contact view -->
<c:if test="${isAlertNonDefaultTranView}">
<c:set var="cfIndField">WAX_USER_FRAUD_${currentAlert.alertType.type}_IND</c:set>
<c:set var="cfIndChecked" value="${dataValues[cfIndField] eq '1'}" />
<c:choose>
<c:when test="${displayType eq 'updateAlert' and dataValues['CREATE_ALERT_IND'] eq '1'}">
<c:if test="${currentAlert.alertType.tranMarkInd}">
<c:if test="${cfIndChecked}"> (<img border="0" width="10" height="8" class="icon" src="analyst/images/check.gif"/>) </c:if>
</c:if>
<c:if test="${not currentAlert.alertType.tranMarkInd}">
(<input id="ALL_${TRANSACTION_NAME}_${TRANSACTION_ID}_${TRANSACTION_TIMESTAMP}" type='checkbox' onclick="markTransaction(this, 'ALL');"
<c:if test="${cfIndChecked}">checked="checked"</c:if>
/>)
</c:if>
</c:when>
<c:when test="${cfIndChecked}">
(<img border="0" width="10" height="8" class="icon" src="analyst/images/check.gif"/>)
</c:when>
<c:otherwise>
<img border="0" width="10" height="8" class="icon" src="common/images/spacer.gif"/>
</c:otherwise>
</c:choose>
</c:if>
</td>
<td class="textTableCell">${esapi:encodeForHTML(txns:getTransactionTypeLabel(TRANSACTION_NAME))}</td>
</c:when>
<c:otherwise>
<td class="imageTableCell" style="padding:0px;">
<c:choose>
<c:when test="${isAlertTransaction and displayType eq 'updateAlert'}"> <%-- and dataValues['USER_FRAUD_LOCK_IND'] eq '0'}"--%>
<c:if test="${currentAlert.alertType.tranMarkInd}">
<c:if test="${dataValues['WAX_USER_FRAUD_IND'] eq '1'}"> <img border="0" width="10" height="8" class="icon" src="analyst/images/check.gif"/> </c:if>
</c:if>
<c:if test="${not currentAlert.alertType.tranMarkInd}">
<input id="ONE_${TRANSACTION_NAME}_${TRANSACTION_ID}_${TRANSACTION_TIMESTAMP}" type='checkbox' ${txns:checkUserFraud(dataValues)} onclick="markTransaction(this, '${TRANSACTION_NAME}')" />
</c:if>
</c:when>
<c:when test="${dataValues['WAX_USER_FRAUD_IND'] eq '1'}">
<img border="0" width="10" height="8" class="icon" src="analyst/images/check.gif"/>
</c:when>
<c:otherwise>
<c:if test="${not isAlertNonDefaultTranView}">
<img border="0" width="10" height="8" class="icon" src="common/images/spacer.gif"/>
</c:if>
</c:otherwise>
</c:choose>
<!-- enable marking of the alerted transaction on contact view -->
<c:if test="${isAlertNonDefaultTranView}">
<c:set var="cfIndField">WAX_USER_FRAUD_${currentAlert.alertType.type}_IND</c:set>
<c:set var="cfIndChecked" value="${dataValues[cfIndField] eq '1'}" />
<c:choose>
<c:when test="${displayType eq 'updateAlert' and dataValues['CREATE_ALERT_IND'] eq '1'}">
<c:if test="${currentAlert.alertType.tranMarkInd}">
<c:if test="${cfIndChecked}"> (<img border="0" width="10" height="8" class="icon" src="analyst/images/check.gif"/>) </c:if>
</c:if>
<c:if test="${not currentAlert.alertType.tranMarkInd}">
(<input id="ONE_${TRANSACTION_NAME}_${TRANSACTION_ID}_${TRANSACTION_TIMESTAMP}" type='checkbox' onclick="markTransaction(this, '${TRANSACTION_NAME}')"
<c:if test="${cfIndChecked}">checked="checked"</c:if>
/>)
</c:if>
</c:when>
<c:when test="${cfIndChecked}">
(<img border="0" width="10" height="8" class="icon" src="analyst/images/check.gif"/>)
</c:when>
<c:otherwise>
<img border="0" width="10" height="8" class="icon" src="common/images/spacer.gif"/>
</c:otherwise>
</c:choose>
</c:if>
</td>
</c:otherwise>
</c:choose>
<c:forEach var="fieldDefinition" items="${entityTransactionActivity.fieldDefinitions}" varStatus="loop">
<c:set var="FIELD_NAME" value="${fieldDefinition.uniqueName.toUpperCase()}"/>
<c:set var="FIELD_VALUE" value="${dataValues[FIELD_NAME]}"/>
<c:set var="FIELD_NAME_ALT" value="${fieldDefinition.practicalName.toUpperCase()}"/>

<c:choose>
<c:when test="${FIELD_NAME eq 'ALL_RULES_FIRED'}">
<td dpIdxCol="true" class="${txns:getDataClassName(fieldDefinition,dataValues,loop.last)}">
<c:if test="${not empty FIELD_VALUE}">
<a href="javascript:;" onclick="getRulesFired(event,{entityType: '${displayEntity.entityType.type}', tranName: '${TRANSACTION_NAME}', tranID: '${TRANSACTION_ID}'})">
<img class="icon" border="0" src="analyst/images/Rules.gif" width="16" height="16"/></a>
</c:if>
</td>
</c:when>
<c:when test="${FIELD_NAME eq 'LAST_RULE_FIRED'}">
<td dpIdxCol="true" class="${txns:getDataClassName(fieldDefinition,dataValues,loop.last)}">
<c:if test="${FIELD_VALUE ne '.'}">${FIELD_VALUE}</c:if>
</td>
</c:when>
<c:otherwise>
<c:set var="hotlist"/>
<c:set var="compositeValue"/>
<c:set var="showCompositeValue" value="none"/>
<c:set var="cellFontStyle" value=""/>
<c:if test="${analystLists.containsKey(fieldDefinition.id)}">
<c:set var="hotlist" value="${analystLists[fieldDefinition.id]}" />
<c:if test="${not empty FIELD_VALUE}">
<c:set var="compositeValue" value="${hotlist.getCompositeValue(TRANSACTION_ID)}"/>
<c:if test="${hotlist.fields.size() gt 1}">
<c:set var="showCompositeValue" value=""/>
</c:if>
<c:if test="${hotlist.onListTranIds.contains(TRANSACTION_ID)}">
<c:set var="cellFontStyle" value="font-weight:bold;" />
</c:if>
</c:if>
</c:if>
<c:set var="href"></c:set>
<c:if test="${not empty fieldDefinition.hyperlinkTemplate and (not mask or empty fieldDefinition.maskingType)}">
<c:set var="href">${fieldDefinition.resolveHyperlink(dataValues)}</c:set>
</c:if>
<td dpIdxCol="true" class="${txns:getDataClassName(fieldDefinition,dataValues,loop.last)}" <c:if test="${not empty hotlist}">hotlist="${hotlist.id}"</c:if> style="${cellFontStyle}"><sfmfmt:formatData value="${FIELD_VALUE}" dataType="${fieldDefinition.dataType}" maskType="${fieldDefinition.maskingType}" href="${href}"/>
<c:if test="${not empty compositeValue}"><img name="compositeValue" style="display:${showCompositeValue}" src="analyst/images/Ellipsis.gif" data-composite-value="${esapi:encodeForHTMLAttribute(compositeValue)}" title="${esapi:encodeForHTMLAttribute(compositeValue)}"/></c:if>
<c:if test="${not empty FIELD_VALUE and displayTraceIcon and traceableFieldList.contains(FIELD_NAME_ALT)}">
<a href="#" onclick="event.stopPropagation(); parent.sas.fscf.explore('${currentAlert.tenantOrgNodeId}', '${FIELD_NAME_ALT}', '${esapi:encodeForHTMLAttribute(esapi:encodeForJavaScript(FIELD_VALUE))}');"><img src="analyst/images/Explore.gif" width="16" height="16" title="<esapi:encodeForHTMLAttribute><fmt:message key="fcm.alert.tran.launchExplore.txt"/></esapi:encodeForHTMLAttribute>"/></a>
</c:if>
</td>
</c:otherwise>
</c:choose>
</c:forEach>
</tr>
</c:forEach>
</tbody>
</table>
</div>
<table id="${esapi:encodeForHTMLAttribute(acronym)}TotalsTbl" class="mainTable" cellpadding="0" cellspacing="0" width="100%" style="border:0">
<tbody>
<tr>
<th class="centeredTableHeader" style="border-right:none;border-bottom:none;text-align:left;width:30%;padding-left:6px;" nowrap="true">
<c:if test="${isAlertTransaction and displayType eq 'updateAlert' and not currentAlert.alertType.tranMarkInd}">
<%--				<a id="${esapi:encodeForHTMLAttribute(acronym)}CheckAllTransactions" href="javascript:;" onclick="checkAllTransactions(this,'${esapi:encodeForJavaScript(acronym)}',false);"></a> --%>
<a id="${esapi:encodeForHTMLAttribute(acronym)}CheckAllTransactionsFraud" style="display:none" href="javascript:;" onclick="markAllTransactions(this,'${esapi:encodeForJavaScript(acronym)}',true);"><fmt:message key="fcm.analyst.markAllConfirmedFraud.txt"/></a>
<a id="${esapi:encodeForHTMLAttribute(acronym)}CheckAllTransactionsOK" style="display:none" href="javascript:;" onclick="markAllTransactions(this,'${esapi:encodeForJavaScript(acronym)}',false);"><fmt:message key="fcm.analyst.markAllVerifiedOK.txt"/></a>
</c:if>
</th>
<th class="centeredTableHeader" style="border-right:none;border-bottom:none;text-align:center;" nowrap>
<c:if test="${entityTransactionActivity.transactionTimeWindow eq 'HISTORY'}">
<a href="#" onclick="switchTransactionTimeWindow('${esapi:encodeForJavaScript(acronym)}','LOOKBACK');return false;">
<fmt:message key="fcm.alert.transaction.recent.txt"/>
( ${entityTransactionActivity.lookBackRowCount},
<fmt:message key="fcm.alert.transaction.throughDate.fmt.txt">
<fmt:param>
<fmt:formatDate value="${entityTransactionActivity.lookBackCutoffDate}" pattern="${dateFormat}" timeZone="GMT"/>
</fmt:param>
</fmt:message>
)
</a> |
</c:if>

<c:if test="${entityTransactionActivity.rowCount>0}">
<fmt:message key="fcm.alert.transactionStartRowAndRowCount.fmt.txt">
<fmt:param>${startRow}</fmt:param>
<fmt:param>${startRow + fn:length(entityTransactionActivity.dataValues) - 1}</fmt:param>
<fmt:param>${entityTransactionActivity.rowCount}</fmt:param>
</fmt:message>
</c:if>
<c:if test="${entityTransactionActivity.rowCount eq 0}">0</c:if>

( <fmt:message key="fcm.alert.transaction.throughDate.fmt.txt">
<fmt:param>
<c:if test="${entityTransactionActivity.transactionTimeWindow eq 'HISTORY'}">
<fmt:formatDate value="${entityTransactionActivity.historyCutoffDate}" pattern="${dateFormat}" timeZone="GMT"/>
</c:if>
<c:if test="${entityTransactionActivity.transactionTimeWindow eq 'LOOKBACK'}">
<fmt:formatDate value="${entityTransactionActivity.lookBackCutoffDate}" pattern="${dateFormat}" timeZone="GMT"/>
</c:if>
</fmt:param>
</fmt:message>
)

<c:if test="${entityTransactionActivity.transactionTimeWindow eq 'LOOKBACK' and entityTransactionActivity.historyAvailable}">
| <a href="#" onclick="switchTransactionTimeWindow('${esapi:encodeForJavaScript(acronym)}','HISTORY');return false;">
<fmt:message key="fcm.alert.transaction.history.txt"/>
( ${entityTransactionActivity.historyRowCount},
<fmt:message key="fcm.alert.transaction.throughDate.fmt.txt">
<fmt:param>
<fmt:formatDate value="${entityTransactionActivity.historyCutoffDate}" pattern="${dateFormat}" timeZone="GMT"/>
</fmt:param>
</fmt:message>
)
</a>
</c:if>
</th>
<th class="centeredTableHeader" style="border-right:none;border-bottom:none;text-align:right;width:30%;padding-right:6px;" nowrap="true">
<a
<c:if test="${startRow <= 1}">
class="disabledLink" disabled="disabled"
</c:if>
<c:if test="${startRow > 1}">
href="#" onclick="scrollTransactions('${esapi:encodeForJavaScript(acronym)}',${esapi:encodeForJavaScript(startRow)},'PREV');return false;"
</c:if>
><fmt:message key="fcm.alert.previous.txt"/></a> &nbsp;
<a
<c:if test="${not entityTransactionActivity.moreRows}">
class="disabledLink" disabled="disabled"
</c:if>
<c:if test="${entityTransactionActivity.moreRows}">
href="#" onclick="scrollTransactions('${esapi:encodeForJavaScript(acronym)}','${esapi:encodeForJavaScript(startRow)}','NEXT');return false;"
</c:if>
><fmt:message key="fcm.alert.next.txt"/></a>
</th>
</tr>
</tbody>
</table>
<script>
$('#${tableName}').data('startRow', ${esapi:encodeForJavaScript(startRow)})
.data('entityObj', <sfmfmt:entityToJSON entity="${displayEntity}"/>)
.data('gridID', ${displayEntity.gridTemplateId})
.data('acronym', '${esapi:encodeForJavaScript(entityTransactionActivity.acronym)}')
.data('sortColumns', '${esapi:encodeForJavaScript(sortColumns)}')
.data('displayType', '${esapi:encodeForJavaScript(displayType)}')
.data('rowCount', '${esapi:encodeForJavaScript(entityTransactionActivity.rowCount)}')
.data('moreRows', ${entityTransactionActivity.moreRows || 1 < entityTransactionActivity.startRow})
//	.data('confirmedFraudCount',${esapi:encodeForJavaScript(confirmedFraudCounter)})
.data('totalRows',${fn:length(entityTransactionActivity.dataValues)})
.data('txnTableDataPops',${txns:getDataPopJSON(entityTransactionActivity.fieldDefinitions, theAllTab)})
.data('timeWindow', '${esapi:encodeForJavaScript(entityTransactionActivity.transactionTimeWindow)}')
.data('hasAnalystLists', ${not empty entityTransactionActivity.analystLists})
.data('initLoaded', ${not empty entityTransactionActivity.dataValues})
;

switchMarkAllLink('${esapi:encodeForJavaScript(entityTransactionActivity.acronym)}');

//hide explore if this is an admin view;
if (isAdminView)
$('img[src="analyst/images/Explore.gif"]').parent().css('display', 'none');
</script>

