<!DOCTYPE html>
<%@ page contentType="text/html; charset=UTF-8"%>
<%@ page isErrorPage="true"%>
<%@ page language="java" session="false"%>
<%@ include file="/common/taglibs.jsp"%>
<html>
<head>
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta http-equiv="CACHE-CONTROL" content="NO-CACHE" />
	<meta http-equiv="Pragma" content="no-cache" />
	<meta http-equiv="Expires" content="-1" />

<tiles:insert page="header.jsp">
	<tiles:put name="subtitle" value="fcm.subtitle.error.txt" />
	<tiles:put name="cssLib">
		<link rel="stylesheet" href="resources/sas/hc/ui/core/themes/sas_base/fonts.css" type="text/css"/>
		<link rel="stylesheet" href="resources/sas/hc/ui/core/themes/sas_corporate/library.css" type="text/css"/>
		<link rel="stylesheet" href="resources/sas/hc/ui/commons/themes/sas_corporate/library.css" type="text/css"/>
		<link rel="stylesheet" href="resources/sap/m/themes/sas_corporate/library.css" type="text/css"/>
		<link rel='stylesheet' href='common/styles/sasStyles.css' type='text/css'/>
		<link rel='stylesheet' href='common/styles/cf.css' type='text/css'/>
	</tiles:put>
	<tiles:put name="scriptLib">
		<script language='JavaScript' src='common/scripts/jquery.js' type="text/javascript"></script>
		<script language='JavaScript' src='common/scripts/sasSolutions.js' type="text/javascript"></script>
		<script language='JavaScript' src='common/scripts/cf.js' type="text/javascript"></script>
	</tiles:put>
</tiles:insert>
</head>
<body class="details sapUiBody sapUiSizeCompact">

	<tiles:insert page="errorMessage.jsp">
		<tiles:put name="hideErrorMessage" value="true"/>
	</tiles:insert>

	<script type="text/javascript">
	$(document).ready(function(){

		removeBusy();

		if(window.top != window)
		{
			$(top.document).find("#frameDiv, #busyMessageDiv").hide();

			var errMsgTop = $(top.document).find("#errorMessageDiv");

			if(errMsgTop.length == 1) // RAPTOR-2399
			{
				var pageError = $("#errorMessageDiv").html();
				errMsgTop.html(pageError).show();

				var busyTimer= top._busyTimer;
				if(isDefined(busyTimer) && busyTimer != null)
				{
					top.clearTimeout(busyTimer);
				}
			}
			else
			{ // Interior frame not in main window has no header
				$("#errorMessageDiv").show();
			   if(window.top.clearStatus)
					$("#resumeButton").click(window.top.clearStatus);
			}
		}
		else
		{
			$("#errorMessageDiv").show();
		}
	});

	</script>

</body>
</html>
