<%@ include file="/common/taglibs.jsp" %>
<%@ page import="java.util.List" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<link rel="stylesheet" href="resources/sas/hc/ui/core/themes/sas_base/fonts.css" type="text/css"/>
<link rel="stylesheet" href="resources/sap/ui/core/themes/sas_corporate/library.css" type="text/css">
<link rel="stylesheet" href="resources/sap/ui/commons/themes/sas_corporate/library.css" type="text/css">
<link rel="stylesheet" href="resources/sas/hc/ui/core/themes/sas_corporate/library.css" type="text/css"/>
<link rel="stylesheet" href="resources/sas/hc/ui/commons/themes/sas_corporate/library.css" type="text/css"/>
<link rel="stylesheet" href="resources/sap/m/themes/sas_corporate/library.css" type="text/css"/>

<link rel='stylesheet' href='common/styles/sasStyles.css' type='text/css'>
<link rel='stylesheet' href='rules/styles/rules.css' type='text/css'>
<link rel='stylesheet' href='common/styles/cf.css' type='text/css'>
<link rel='stylesheet' href='admin/styles/admin.css' type='text/css'>

<script language="JavaScript" src='common/scripts/jquery.js'></script>
<SCRIPT language="JavaScript" src="common/scripts/cf.js"></SCRIPT>
<script language="JavaScript" src="common/scripts/jquery.fcm.dynaform.js"></script>
<script language="JavaScript" src="rules/scripts/rules.js"></script>
<script language="JavaScript" src="rules/scripts/tasks.js"></script>
<script language="JavaScript" src="rules/scripts/ruleActions.js"></script>
<script language="JavaScript" src="rules/scripts/dynamicRows.js"></script>
<script language="JavaScript" src="rules/scripts/itemPriorityList.js"></script>
<script language="JavaScript" src="rules/scripts/autoSizing.js"></script>
<SCRIPT language="JavaScript" src="common/scripts/calendar.js"></SCRIPT>
<SCRIPT language="JavaScript" src="rules/scripts/sort.js"></SCRIPT>

<link rel="stylesheet" href="/resources/demos/style.css">

<style>
     DIV.scrollableGrid
      {
         BORDER-RIGHT: none;
         BORDER-TOP:  none;
         BORDER-LEFT: none;
         BORDER-BOTTOM: none;
         OVERFLOW: auto;
         TOP:0px;
         LEFT:0px;
         position:relative;
         vertical-align:top;
      }

      DIV.scrollableGrid thead th {z-index:30; position:relative;top: expression(getElementById("ruleDiv").scrollTop); }

      .rowSelected
      {
         background-color:#ddddee;
         color:#648BB9;
      }

eXtremeTable .odd a, .even a {
   color: Black;
   font-size: .88rem;
   background-color : #FFFFFF;
}

.eXtremeTable .odd td, .eXtremeTable .even td {
   padding-top: 2px;
   padding-right: 3px;
   padding-bottom: 2px;
   padding-left: 3px;
   vertical-align: middle;
   font-family: AvenirNext,verdana, arial, helvetica, sans-serif;
   font-size: .88rem;
}

.eXtremeTable .odd {
   background-color: #FFFFFF;
}

.eXtremeTable .even ,.eXtremeTable .even a:link,.eXtremeTable .even a:visited{
   background-color : #f0f1f2;
}
.eXtremeTable .even a:hover ,.eXtremeTable .odd a:hover{
         background-color:#ddddee;
         color:#648BB9;
}



.eXtremeTable .toolbar {

   font-family: AvenirNext,verdana, arial, helvetica, sans-serif;
   font-size: .7rem;
   margin-right: 1px;

}

.eXtremeTable .toolbar td {
   color: #444444;
   padding: 0px 3px 0px 3px;
   text-align:center;
}

.eXtremeTable .separator {
   width: 7px;
}
.eXtremeTable .title {
   color: #444444;
   font-weight: bold;
   font-family: AvenirNext,'Trebuchet MS', Verdana, Arial, Helvetica, sans-serif;
   font-size: .88rem;
   vertical-align: bottom;

}

.eXtremeTable .title span {
   margin-left: 0px;

}
.eXtremeTable .tableHeaderSort {

   border-top: 1px solid #E6DAC2;
   border-bottom: 1px solid #E6DAC2;
   border-right:none;
   border-left: none;
   color:#353535;
   font-weight:bold;
   font-family : AvenirNext,'Trebuchet MS', Verdana, Arial, Helvetica, sans-serif;
  font-size : .88rem;
   background-color : #f0f1f2;
      text-decoration:underline;
      text-align:left;
}

.eXtremeTable{
	table-layout: auto;
}

/* HOVER STYLES */
      div#pop-up {
        display: none;
        position: absolute;
        width: 325px;
        padding: 0px;
        background: #eeeeee;
        color: #000000;
        border: 1px solid #1a1a1a;
        font-size: 90%;
      }
    </style>
</style>
<script type="text/javascript">
    var uvRules=[
	{'When': 'placeholder','Text':''}
    <c:forEach var="cols" items="${colNames}" varStatus="colStatus">
    	<c:set var="uv" value="${cols}"/>
    	<c:if test="${uvRules[uv]!=null}">
  		<c:forEach var="uvRule" items="${uvRules[uv]}" varStatus="uvRuleStatus">
			,{'When': '${uv}','Text':'${esapi:encodeForJavaScript(uvRule.RULE_NAME)} (${esapi:encodeForJavaScript(uvRule.RULE_ID)})'}
	    </c:forEach>
	    </c:if>
	</c:forEach>
    ];

      $(function() {
        var moveLeft = -100;
        var moveDown = 10;
        $('.tableHeader').hover(function(e) {
          var uv=$(this).html();
          var ruleText='';
          if(uv.substring(0,1)=='_'){
        	  for (var i=0; i < uvRules.length; i++) {
        		  if(uvRules[i].When==uv){
	        		  if(ruleText=='')
	        			  ruleText+='<p style="font-weight:bold;">'+"<fmt:message key='rules.diagnostic.rulesAssociatedWithUV.txt'/>"+'</p>';
        			  ruleText+="<p>"+uvRules[i].Text+"</p>";
        		  }
        	  }
        	  if(ruleText=='')ruleText="<fmt:message key='rules.diagnostic.noRulesAssociatedWithUV.txt'/>";

        	$('div#pop-up p').html(ruleText);
        	$('div#pop-up p').css('margin','0').css('padding','0');
        	$("div#pop-up").css('top', e.pageY + moveDown).css('left', e.pageX + moveLeft);
        	$('div#pop-up').show();
          }
        }, function() {
          $('div#pop-up').hide();
        });
      });

    </script>


      <!-- HIDDEN / POP-UP DIV -->
      <div id="pop-up"><p>&nbsp;</p></div>
<span style='height:0.5em'/>


<%-- Error handling code --%>
<style>
   .confirmationMessage { text-align:left; }
   .errorMessage { text-align:left; }
</style>
<div onclick="this.innerHTML='<br>'">
   <c:url var="reloadURL" value="/r_rules.do?method=listRules&ruleFolder=${esapi:encodeForURL(ruleFolder)}&showAll=true" />
   <tiles:insert page="rulesSystemMessages.jsp" flush="true">
     <tiles:put name="reloadURL" value="${reloadURL}" />
    <tiles:put name="refreshURL" value="${reloadURL}&refresh=true" />
     <tiles:put name="objectTypeName" value="Rule" />
   </tiles:insert>
</div>

<div id="preTableBlock" align="left">
<H4>
 		<fmt:message key="rules.diagnostic.transactionsThatCausedRuleToFire.fmt.txt">
 			<fmt:param value="${ruleName}"/>
 			<fmt:param value="${ruleId}"/>
 			<fmt:param value="${build}"/>
 		</fmt:message>

</H4>
</div>
<br>
<div>
<table width="98%">

<tr><td>

<ec:table
                items="txnsFired"
                var="txnsFired"
                action="r_rules.do"
                title=""
                width="100%"
                sortable="true"
                filterable="false"
                showExports="false"
                showStatusBar="true"
                showPagination="true"
		        tableId="rulesTxns"
                styleClass="mainTable"
                view="html2"
                >

		<ec:row>
		<c:forEach var="cols" items="${colNames}"><!-- startForLoop -->
		<c:set var="uv" value="${cols}"/>
			<c:choose>
				<c:when test="${fn:substring(cols,0,1)=='_'}">
						<ec:column property="${cols}" headerCell="XssAwareHeaderClass" title="${esapi:encodeForHTML(cols)}"  headerClass="tableHeader" headerStyle="background-color:#77e1dc;border-top:1px solid#7F9DB9;border-right:none;color:#353535;font-weight:bold;vertical-align: top;" styleClass="numericTableCell">
						<c:choose>
							<c:when test="${fn:substring(txnsFired[uv],0,3)=='***'}">
								<span style="color:#ff0000;font-style:italic;">${esapi:encodeForHTML(fn:substring(txnsFired[uv],3,50))}</span>
							</c:when>
							<c:otherwise>
								<c:set var="vxx_uvr_id" value="VXX_UVR_ID${uv}"/>
								<c:set var="vxx_lookup_key" value="VXX_LOOKUP_KEY${uv}"/>
								<c:set var="field_id" value="FIELD_ID${uv}"/>
									<c:if test="${txnsFired[vxx_uvr_id]!=null && txnsFired[vxx_uvr_id]!='' && txnsFired[vxx_uvr_id]!='NULL VALUE'}" ><a href="javascript:getUVHistory('${uv}','${txnsFired[field_id]}', '${txnsFired[vxx_uvr_id]}', '${txnsFired[vxx_lookup_key]}');">${txnsFired[uv]}</a></c:if>
									<c:if test="${txnsFired[vxx_uvr_id]==null || txnsFired[vxx_uvr_id]=='' || txnsFired[vxx_uvr_id]=='NULL VALUE'}" >${txnsFired[uv]}</c:if>
							</c:otherwise>
						</c:choose>
						</ec:column>
				</c:when>
				<c:otherwise>
					<c:if test="${!fn:containsIgnoreCase(cols,'VXX_UVR_ID') && !fn:containsIgnoreCase(cols,'VXX_LOOKUP_KEY') && !fn:containsIgnoreCase(cols,'FIELD_ID')}">
						<c:set var="title" value="${esapi:encodeForHTMLAttribute(cols)}"/>
						<c:if test="${fn:containsIgnoreCase(cols,'rqo_proc_utc_datetime') ||  fn:containsIgnoreCase(cols,'cmx_tran_id') || fn:containsIgnoreCase(cols,'trantype')}">
							<c:set var="title">
								<fmt:message key='fcm.reports.column.header.${esapi:encodeForHTML(fn:toLowerCase(cols))}.txt'/>
							</c:set>
						</c:if>
						<ec:column property="${cols}" headerCell="XssAwareHeaderClass" title="${title}"  headerClass="tableHeader" headerStyle="border-top:1px solid#7F9DB9;border-right:none;color:#353535;font-weight:bold;vertical-align: top;" styleClass="numericTableCell"><!-- ${cols} is NOT a user variable -->
						<c:choose>
							<c:when test="${txnsFired[uv]=='NULL VALUE'}">
								&nbsp;
							</c:when>

							<c:otherwise>${esapi:encodeForHTML(txnsFired[uv])}</c:otherwise>
						</c:choose>
						</ec:column>
					</c:if>
				</c:otherwise>
			</c:choose>
		</c:forEach> <!-- endForLoop -->
		</ec:row>

</ec:table>

</td></tr>
</table>
</div>
<script language="JavaScript">
function getUVHistory(fieldName,field_id, vxx_uvr_id, vxx_lookup_key){
	 var ruleAction = '<c:url value="/r_rules.do"/>';
	 var action=ruleAction + '?method=showUserVariableHistory' + '&buildID=${build}&fieldName='+fieldName+'&field_id=' +field_id + '&vxx_uvr_id=' + vxx_uvr_id + '&vxx_lookup_key=' +vxx_lookup_key;
	 frames[ "userVariableHistory" ].location.href = action;
	 showProgressBar();
}
function showProgressBar(){
	   var busyMsgTop = document.getElementById("busyUVMessageDiv");
	   if(busyMsgTop)
	      busyMsgTop.style.display="block";
}
function removeProgressBar(){
	   var busyMsgTop = document.getElementById("busyUVMessageDiv");
	   if(busyMsgTop)
	      busyMsgTop.style.display="none";
}
</script>
<br><br>

<div id="uvHistDiv" style="height:550px;margin-left:22px;">
<div id="busyUVMessageDiv" style="display:none;">
	<table border="0" >
		<tr>
			<td class="progressBarContainer">
				<fmt:message key="creditfraud.application.processingRequest.txt" />
				<p>
				<img id="busyLogo" src="common/images/loadingAnimation.gif">
				<p>
			</td>
		</tr>
	</table>
</div>

<iframe onload="removeProgressBar();" id="userVariableHistory" name="userVariableHistory" src="blank.html" width="100%" height="100%" frameborder="0" marginwidth="0" marginheight="0" ></iframe>
</div>

