<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<style type='text/css'>@import 'common/styles/sasStyles.css';</style><link rel='stylesheet' href='common/styles/cf.css' type='text/css'>
<style type='text/css'>@import 'admin/styles/admin.css';</style>
<style type=text/css>@import "common/styles/calendar.css";</style>
<style type=text/css>@import "common/styles/jquery-ui.css";</style>
<STYLE>
   .bumperInput
   {
       background-color: white;
       color: black;
       font-weight: normal;
   }
   .bumperInputSelected
   {
       background-color: #A1B8CD;
       color: navy;
       font-weight: bold;
   }
   .ui-draggable .ui-dialog-titlebar{
	   display:none;
   }

</STYLE>
<script language='JavaScript' src='common/scripts/jquery.js'></script>
<script language='JavaScript' src='common/scripts/i18n.js'></script>
<script language='JavaScript' src='common/scripts/cf.js'></script>
<script language="JavaScript" src="common/scripts/jquery.fcm.dynaform.js"></script>
<script language='JavaScript' src="rules/scripts/rules.js"></script>
<script language='JavaScript' src="rules/scripts/ruleActions.js"></script>
<script language='JavaScript' src="common/scripts/calendar.js"></script>
<script language='JavaScript' src='common/scripts/sasSolutions.js'></script>
<script language='JavaScript' src='admin/scripts/admin.js'></script>
<script language="JavaScript" src="rules/scripts/rules.js"></script>
<script language="JavaScript" src="rules/scripts/ruleSasTest.js"></script>
<script language="JavaScript" src="rules/scripts/bumper.js"></script>
<script language="JavaScript" src="rules/scripts/estimate.js"></script>
<script language="JavaScript" src='common/scripts/jquery-ui.js'></script>
<script language="JavaScript" src='common/scripts/jquery.ui.position.js'></script>

<script>
<c:if test="${not empty promptForPath}">
$( function() {
	var cancelButtonName = "<fmt:message key='rules.estimationInfo.continueEstimationDialog.cancel.txt'/>";
	var continueButtonName =  "<fmt:message key='rules.estimationInfo.continueEstimationDialog.continue.txt'/>";

    $( "#dialog-confirm" ).dialog( {
		resizable: false,
		height: "auto",
		width: 400,
		modal: true,
		position: { my: "center-100 center-100", at: "center", of: window },
		buttons: [ {
				text : continueButtonName,
				click : function () {
					// S1396156 - Disable both the Continue and Cancel buttons.
					$(".ui-dialog-buttonpane button").each(function (i, each) {
							$(each)
								.prop("disabled", true)
								.addClass("ui-state-disabled");
						}
					);
					// Run estimation
					var estimateAction = "r_ruleEstimates.do?method=createEstimate&confirmedSlowPath=Y&__sfmrt=" + getCookie("__sfmrt");
					$df.postURL("detail", estimateAction);
				}
			}, {
    		  	text : cancelButtonName,
    		  	click : function () {
    			  	$( this ).dialog( "close" );
    		  	}
    	  	},
		]
	} );
} );
</c:if>
</script>

<%-- Push component attributes in page context --%>
<tiles:importAttribute/>

<!-- These values are overridden in initializeBumper() in the onload handler if there are values (cookies) from a previous session available -->
<c:set var="edate" value="  -  -  "/>
<c:set var="etime" value="  :  :  "/>
<c:set var="ldate" value="  -  -  "/>
<c:set var="ltime" value="  :  :  "/>

<c:if test='${not empty transactionEarliestDate}'>
   <fmt:formatDate var="edate" value="${transactionEarliestDate}"  type="date" pattern="MM-dd-yyyy" timeZone="GMT"/>
   <fmt:formatDate var="etime" value="${transactionEarliestDate}"  type="time" pattern="HH:mm:ss"   timeZone="GMT"/>
</c:if>
<c:if test='${not empty transactionLatestDate}'>
   <fmt:formatDate var="ldate" value="${transactionLatestDate}"  type="date" pattern="MM-dd-yyyy" timeZone="GMT"/>
   <fmt:formatDate var="ltime" value="${transactionLatestDate}"  type="time" pattern="HH:mm:ss"   timeZone="GMT"/>
</c:if>

<div id="dialog-confirm" title="<fmt:message key='rules.estimationInfo.continueEstimation.txt'/>"><p style="text-align:left;">${promptForPath}</p></div>


<form name="estimateForm" id="estimateForm" action='<c:url value="/r_rules.do"/>'>
<input type="hidden" name="method" value="estimateRules">
<input type="hidden" name="estimationStartDate" id="estimationStartDate" value='${edate} ${etime} GMT'>
<input type="hidden" name="estimationEndDate" id="estimationEndDate" value='${ldate} ${ltime} GMT'>

<br>

<table width="94%" border="0" style="text-align:left;margin:0px 0px 0px 0px;color:black;" cellpadding="0">
  <tr>
    <td colspan='6' style="color:#353535;font-weight:bold;font-size:1.2em;" nowrap><fmt:message key="rules.estimationInfo.title.newEstimation.txt"/><br>&nbsp; </td>
  </tr>

  <tr class="configurationTableDataRow1">
    <td nowrap align="left" width="1%"><fmt:message key="rules.estimationInfo.name.txt"/>:&nbsp;</td>
    <td colspan='7' nowrap width="98%">
      <input style="width:100%" type="text" id="estimateName" name="estimateName" class="famTextEntry" maxlength="50" value="">
    </td>
    <td width="1%;">&nbsp;&nbsp;&nbsp;</td>
  </tr>

  <tr class="configurationTableDataRow1"> <td>&nbsp;</td></tr>

  <tr class="configurationTableDataRow1">
    <td nowrap align="left" valign="top" width="1%"><fmt:message key="rules.estimationInfo.metrics.txt"/>:&nbsp;</td> <%-- S0838078 --%>
    <td colspan='5' nowrap>
      <input type="checkbox" id="dampenFirings" name="dampenFirings" style="margin-left:-3;"/><fmt:message key="rules.estimationInfo.metrics.option.dampenFirings.txt"/><br>
      <input type="checkbox" name="noRecontactBox" id="noRecontactBox" onclick="toggleNoRecontactDays(this)" style="margin-left:-3;" /><fmt:message key="rules.estimationInfo.metrics.option.noRecontactDays.txt"/>
      <input type="text" id="noRecontactDays" name="noRecontactDays" class="famTextEntry" disabled="disabled" style="background-color:#EEEEEE;width:30px;text-align:right;" value="14"/> <br>
      <input type="checkbox" id="reportTotalCounts" name="reportTotalCounts" style="margin-left:-3;"/><fmt:message key="rules.estimationInfo.metrics.option.totalAllCounts.txt"/><br>
      <c:if test="${isEligibleForRedistribution}">
         <input type="checkbox" id="reportRedistributableAlerts" name="reportRedistributableAlerts" style="margin-left:-3;"/><fmt:message key="rules.estimationInfo.metrics.option.enableRedistribution.txt"/>
      </c:if>
      <br>&nbsp;
    </td>
    <td nowrap align="right" valign="top" width="90%"><fmt:message key="rules.estimationInfo.summary.txt"/>:&nbsp;</td>
    <td nowrap rowspan='8' valign="top">
       <c:forEach var="e" items="${alertTypeInfo}">
         <c:set var="display" value="" />
         <c:if test="${false && e.value.highlightable}"> <%-- TODO: Should we suppress this? --%>
           <c:set var="display" value="none" />
         </c:if>
         <span style="display:${display}">
           <input name="reportPer${e.value.longName}" id="reportPer${e.value.longName}" type="checkbox"><fmt:message key="rules.estimationInfo.summary.option.perAlertType.fmt.txt"><fmt:param>${e.value.desc}</fmt:param></fmt:message><br>
         </span>
       </c:forEach>
       <br>
       <input name="reportPerRule" id="reportPerRule" type="checkbox"><fmt:message key="rules.estimationInfo.summary.option.perRule.txt"/> <br>
       <input name="reportPerFraudType" id="reportPerFraudType" type="checkbox"><fmt:message key="rules.estimationInfo.summary.option.perFraudType.txt"/>
    </td>
    <td>&nbsp;</td>
  </tr>

  <tr class="configurationTableDataRow1">
    <td nowrap>&nbsp;</td>
    <td colspan='5' nowrap>&nbsp;</td>
    <td nowrap>&nbsp;</td>
    <td>&nbsp;</td>
  </tr>

  <tr class="configurationTableDataRow1">
    <td nowrap align="left" width="1%"><fmt:message key="rules.estimationInfo.filters.txt"/>:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>
    <td nowrap colspan='2' width="2%"><fmt:message key="rules.estimationInfo.filters.option.sampleSize.txt"/>&nbsp;</td>
    <td colspan='3' nowrap>
      <select id="samplePercent" name="samplePercent" onchange="setCookieFromTuningValue(this.id)">
        <option value="100" selected='selected'>&nbsp;&nbsp;<fmt:message key="rules.estimationInfo.filters.option.sampleSize.all.txt"/></option>
        <option value="1">&nbsp;&nbsp;1%</option>
        <option value="2">&nbsp;&nbsp;2%</option>
        <option value="3">&nbsp;&nbsp;3%</option>
        <option value="4">&nbsp;&nbsp;4%</option>
        <option value="5">&nbsp;&nbsp;5%</option>
        <option value="10">&nbsp;10%</option>
        <option value="15">&nbsp;15%</option>
        <option value="20">&nbsp;20%</option>
        <option value="25">&nbsp;25%</option>
        <option value="30">&nbsp;30%</option>
        <option value="40">&nbsp;40%</option>
        <option value="50">&nbsp;50%</option>
        <option value="75">&nbsp;75%</option>
        <option value="100">100%</option>
      </select>
    </td>
    <td nowrap>&nbsp;</td>
    <td>&nbsp;</td>
  </tr>

  <tr class="configurationTableDataRow1">
    <td nowrap align="left">&nbsp;</td>
    <td nowrap colspan='2' width="2%"><fmt:message key="rules.estimationInfo.filters.option.account.txt"/>&nbsp;</td>
    <td nowrap colspan='3'><input style="width:100%" type="text" id="filterAccount" name="filterAccount" class="famTextEntry" maxlength="100" value=""></td>
    <td nowrap>&nbsp;</td>
    <td>&nbsp;</td>
  </tr>
  <tr class="configurationTableDataRow1">
    <td>&nbsp;</td>
    <td nowrap align="right" valign='bottom' width="1%" colspan='2'><span style="vertical-align:top;"><fmt:message key="rules.estimationInfo.filters.option.dateTime.start.txt"/></span><img id="copyDateFromEnd" src="images/rules/copyFromBelow.gif" title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.estimationInfo.filters.option.dateTime.setStartDate.txt'/></esapi:encodeForHTMLAttribute>" /></td>
    <td nowrap width="1%" class="startDate" valign="bottom" style="padding-left:1px;">
        <span class="datetime" style="width:42px;"><fmt:message key="rules.estimationInfo.filters.option.dateTime.year.txt"/></span>
        <span class="datetime" style="width:32px;"><fmt:message key="rules.estimationInfo.filters.option.dateTime.month.txt"/></span>
        <span class="datetime" style="width:32px;"><fmt:message key="rules.estimationInfo.filters.option.dateTime.day.txt"/></span>
       <br>
        <input id="startYear"  class="bumperInput" style="width:42px;text-align:center;" type="text" value="${fn:split(edate,'-')[2]}">
        <input id="startMonth" class="bumperInput" style="width:32px;text-align:center;" type="text" value="${fn:split(edate,'-')[0]}">
        <input id="startDay"   class="bumperInput" style="width:32px;text-align:center;" type="text" value="${fn:split(edate,'-')[1]}">
        <img class="bumpUp"   src="images/rules/plus.gif"/>
        <img class="bumpDown" src="images/rules/minus.gif"/>
    </td>
    <td width="1%">&nbsp;&nbsp;&nbsp;</td>
    <td nowrap class="startTime" align="right" nowrap width="1%">
        <span class="datetime" style="width:32px;" ><fmt:message key="rules.estimationInfo.filters.option.dateTime.hour.txt"/></span>
        <span class="datetime" style="width:32px;"><fmt:message key="rules.estimationInfo.filters.option.dateTime.minute.txt"/></span>
        <span class="datetime" style="width:32px;" ><fmt:message key="rules.estimationInfo.filters.option.dateTime.second.txt"/></span>
        <span id="timezoneLabel" class="datetime" style="width:38px;" >???</span>
       <br>
        <img id="copyTimeFromEnd" style="vertical-align:bottom;" src="images/rules/copyFromBelow.gif" title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.estimationInfo.filters.option.dateTime.setStartTime.txt'/></esapi:encodeForHTMLAttribute>" />
        <input id="startHour"   class="bumperInput" style="width:32px;text-align:center;" type="text" value="${fn:split(etime,':')[0]}">
        <input id="startMinute" class="bumperInput" style="width:32px;text-align:center;" type="text" value="${fn:split(etime,':')[1]}">
        <input id="startSecond" class="bumperInput" style="width:32px;text-align:center;" type="text" value="${fn:split(etime,':')[2]}">
        <img class="bumpUp"   src="images/rules/plus.gif"/>
        <img class="bumpDown" src="images/rules/minus.gif"/>
    </td>

    <td nowrap>&nbsp;</td>
    <td>&nbsp;</td>
    <td>&nbsp;</td>
  </tr>

  <tr class="configurationTableDataRow1">
    <td>&nbsp;</td>
    <td nowrap align="right" valign='bottom' colspan='2'><span style="vertical-align:top;"><fmt:message key="rules.estimationInfo.filters.option.dateTime.end.txt"/></span><img id="copyDateFromStart" src="images/rules/copyFromAbove.gif" title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.estimationInfo.filters.option.dateTime.setEndDate.txt'/></esapi:encodeForHTMLAttribute>" /></td>
    <td nowrap class="endDate" valign="bottom" style="padding-left:1px;">
        <input id="endYear"  class="bumperInput" style="width:42px;text-align:center;" type="text" value="${fn:split(ldate,'-')[2]}">
        <input id="endMonth" class="bumperInput" style="width:32px;text-align:center;" type="text" value="${fn:split(ldate,'-')[0]}">
        <input id="endDay"   class="bumperInput" style="width:32px;text-align:center;" type="text" value="${fn:split(ldate,'-')[1]}">
        <img class="bumpUp"   src="images/rules/plus.gif"/>
        <img class="bumpDown" src="images/rules/minus.gif"/>
    </td>
    <td>&nbsp;&nbsp;</td>
    <td nowrap class="endTime" valign=bottom align="right">
        <img id="copyTimeFromStart" style="vertical-align:bottom;" src="images/rules/copyFromAbove.gif" title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.estimationInfo.filters.option.dateTime.setEndTime.txt'/></esapi:encodeForHTMLAttribute>" />
        <input id="endHour"   class="bumperInput" style="width:32px;text-align:center;" type="text" value="${fn:split(ltime,':')[0]}">
        <input id="endMinute" class="bumperInput" style="width:32px;text-align:center;" type="text" value="${fn:split(ltime,':')[1]}">
        <input id="endSecond" class="bumperInput" style="width:32px;text-align:center;" type="text" value="${fn:split(ltime,':')[2]}">
        <img class="bumpUp"   src="images/rules/plus.gif"/>
        <img class="bumpDown" src="images/rules/minus.gif"/>
    </td>
    <td nowrap>&nbsp;</td>
    <td>&nbsp;</td>
    <td>&nbsp;</td>
  </tr>

  <tr class="configurationTableDataRow1">
    <td>&nbsp;</td>
    <td nowrap valign='bottom'>&nbsp;</td>
    <td colspan="4" align="right" valign="top">
<%--      <input type="button" class="littleButton" style="font-size:0.7rem;" onclick="loadBumperDatetimes();" value="<esapi:encodeForHTMLAttribute><fmt:message key='rules.estimationInfo.filters.option.dateTime.reset.txt'/></esapi:encodeForHTMLAttribute>" /> --%>
      <button title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.estimationInfo.filters.option.dateTime.reset.txt'/></esapi:encodeForHTMLAttribute>" class="cfTinyBtn sapMBtn" onclick="javascript:loadBumperDatetimes();" type="button">
		<div class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMFocusable">
			<span class="sapMBtnContent"><esapi:encodeForHTML><fmt:message key='rules.estimationInfo.filters.option.dateTime.reset.txt'/></esapi:encodeForHTML></span>
		</div>
	  </button>
    </td>
    <td>&nbsp;</td>
    <td>&nbsp;</td>
  </tr>


  <tr id="advancedTuningSpacer" class="configurationTableDataRow1" style="display:">
    <td>&nbsp;</td>
    <td colspan='6'></td>
    <td>&nbsp;</td>
    <td>&nbsp;</td>
  </tr>

  <tr id="showAdvancedButton" class="configurationTableDataRow1">
    <td colspan='6'>
<%--      <input type="button" class="littleButton" style='font-size:1em;font-weight:normal;color:#005959;' onclick="showAdvanced();" value="<esapi:encodeForHTMLAttribute><fmt:message key='rules.estimationInfo.showAdvacedOptions.txt'/></esapi:encodeForHTMLAttribute>" /><br> --%>
      <button title="<esapi:encodeForHTMLAttribute><fmt:message key='rules.estimationInfo.showAdvacedOptions.txt'/></esapi:encodeForHTMLAttribute>" class="cfSmallBtn sapMBtn" onclick="javascript:showAdvanced();" type="button">
		<div class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMBtnPaddingLeft sapMBtnPaddingRight sapMFocusable">
			<span class="sapMBtnContent"><esapi:encodeForHTML><fmt:message key='rules.estimationInfo.showAdvacedOptions.txt'/></esapi:encodeForHTML></span>
		</div>
	  </button>
      <br>&nbsp;
    </td>
    <td>&nbsp;</td>
    <td>&nbsp;</td>
  </tr>

  <tr id="advancedTuningOptions" style="display:none;" class="configurationTableDataRow1">
    <td nowrap valign='top' onclick="hideAdvanced()"><fmt:message key="rules.estimationInfo.tuning.txt"/>:&nbsp;</td>
    <td colspan='5' nowrap>

         <input type="checkbox" id="splitTransactions" name="splitTransactions" style="margin-left:-3;" onchange="setCookieFromTuningValue(this.id)" /><fmt:message key="rules.estimationInfo.tuning.option.splitTransaction.txt"/>
         <select id="sampleKey" name="sampleKey" onchange="setCookieFromTuningValue(this.id)">
            <c:forEach var="rd" items="${requestScope.randomDigitList}">
               <option value="${rd.name}" <c:if test="${rd.name == defaultRandDigName}">selected="selected"</c:if>>${fn:escapeXml(rd.label)}</option>
            </c:forEach>
         </select>
         <br>

         <input type="checkbox" id="useMultiThreading" name="useMultiThreading" style="margin-left:-3;" onchange="setCookieFromTuningValue(this.id)" /><fmt:message key="rules.estimationInfo.tuning.option.parallelProcessing.txt"/>
         <select id="sampleThreads" name="sampleThreads" onchange="setCookieFromTuningValue(this.id)">
            <c:forEach var="thd" begin="2" end="${estimationMaxThreadCount}">
               <option value="${thd}" <c:if test="${thd==estimationDefaultThreadCount}">selected='selected'</c:if>  >&nbsp;${thd}&nbsp;</option>
            </c:forEach>
         </select>
         <br>
         <input type='hidden' id='estimationMaxThreadCount' name='estimationMaxThreadCount' value='${estimationMaxThreadCount}'/>

         <input type="checkbox" id="cacheUserVars" name="cacheUserVars" style="margin-left:-3;" checked='checked' onchange="setCookieFromTuningValue(this.id)" /><fmt:message key="rules.estimationInfo.tuning.option.cacheSignatureInMemory.txt"/><br>

         <%-- Following is not an option for now, so we always use bucket 1 --%>
         <input type='hidden' id="sampleBucket" name="sampleBucket" value='1' style="width:20px;text-align:right;" maxlength='4' checked='checked'/>

         <input type="checkbox" id="sortInSas" name="sortInSas" style="margin-left:-3;" checked='checked' onchange="setCookieFromTuningValue(this.id)" /><fmt:message key="rules.estimationInfo.tuning.option.sortTransactions.txt"/><br>

    </td>
    <td nowrap>&nbsp;</td>
    <td>&nbsp;</td>
  </tr>

</table>


<table border='0' width="94%">
  <tr><td>&nbsp;</td></tr>

  <tr>
      <td style="color:#353535;font-weight:bold;font-size:1.2em;"
          valign="top" align="left" nowrap><fmt:message key="rules.estimationInfo.selectRules.txt"/></td>
      <td style="color:#353535;font-weight:bold;"
          valign="top" align="right" nowrap><span ondblclick="runEstimation(true,true)"><fmt:message key="rules.estimationInfo.excludeTestingRules.txt"/></span> <input type='checkbox' name="excludeTestingRules"  id="excludeTestingRules" onclick="showHideRowsPerRuleState()"/></td>
  </tr>
</table>


