<!DOCTYPE html>
<%@ page language="java" session="true" %>
<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<HTML>



<HEAD>
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title><fmt:message key="rules.lookupListUploadPopup.title.txt"/></title>

<link rel="stylesheet" href="resources/sas/hc/ui/core/themes/sas_base/fonts.css" type="text/css"/>
<link rel="stylesheet" href="resources/sas/hc/ui/core/themes/sas_corporate/library.css" type="text/css"/>
<link rel="stylesheet" href="resources/sas/hc/ui/commons/themes/sas_corporate/library.css" type="text/css"/>
<link rel="stylesheet" href="resources/sap/m/themes/sas_corporate/library.css" type="text/css"/>
<style type='text/css'>@import 'common/styles/sasStyles.css';</style><link rel='stylesheet' href='common/styles/cf.css' type='text/css'>
<style type='text/css'>@import 'admin/styles/admin.css';</style>
<style type=text/css>@import "common/styles/calendar.css";</style>

<script language='JavaScript' src='common/scripts/jquery.js'></script>
<script language='JavaScript' src='common/scripts/i18n.js'></script>
<script language='JavaScript' src='common/scripts/sasSolutions.js'></script>
<script language='JavaScript' src='common/scripts/cf.js'></script>
<script language='JavaScript' src='admin/scripts/admin.js'></script>
<script language='JavaScript' src='rules/scripts/lookupLists.js'></script>
<script>
   function closeDialog()
   {
      // window.returnValue = 'cancel'; // No return value when cancel or X window
      window.close();
   }

   function submitForm()
   {
      var parts = document.getElementById('fileToUpload').value.split("/");
      if (parts && parts.length > 0)
         parts = parts[parts.length-1].split("\\");
      if (parts && parts.length > 0)
      {
         var fileName = parts[parts.length-1];
         var contentName="${param.inds}";
         errmsg = getIndsBadFileNameMessage(fileName);
      }
      else
         errmsg = $i18n("rules.lookupListUploadPopup.js.missingFileName.txt");
      if (errmsg)
         alert(errmsg);
      else
      {
         window.returnValue = parts[parts.length-1];
         document.uploadForm.submit();
         window.close();
      }
   }
</script>
</HEAD>


<BODY class="sapUiBody sapUiSizeCompact" style="background-color:#f0f1f2;" onLoad="i18n.init();">

<!-- lookupListContentsFrame -->
<c:url var="url" value="/r_lookupLists.do">
  <c:param name="method"  value="${param.method}"/>
  <c:param name="inds"    value="${param.inds}"/>
  <c:param name="lookupListId" value="${param.lookupListId}" />
  <c:param name="contentOrList" value="${param.contentOrList}"/>
  <c:param name="__sfmrt" value="${param.__sfmrt}"/>
</c:url>
<form name="uploadForm"
      id="uploadForm"
      action="${url}"
      onsubmit=""
      target="${param.target}"
      enctype="multipart/form-data"
      method="post">

 <table border ="0" width="100%" class="configurationTable" border="0" cellspacing="0" cellpadding="0" style="margin:0px">
 <c:if test="${not empty updtRules}">
    <tr style="margin:0px;">
      <td colspan="2" align="center"><h1><fmt:message key="rules.lookupListUploadPopup.title.txt"/></h1></td>
    </tr>
    <tr class="configurationTableDataRow"><td colspan="2"> &nbsp;</td></tr>
    <tr class="configurationTableDataRow">
      <td valign="top" nowrap width="1%">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key="rules.lookupListUploadPopup.file.txt"/>:&nbsp; </td>
      <td valign="top"> <input type="file" name="fileToUpload" id="fileToUpload" accept=".csv,.sas7bdat" style="width:320px;"></td>
    </tr>
    <tr class="configurationTableDataRow"><td colspan="2"> &nbsp;</td></tr>
    <tr class="configurationTableDataRow">
     <td colspan="2" align="center" style="padding-top:4px">
	    <button class="sapMBarChild sapMBtn sapMBtnBase sasMButton" type="button" onclick="submitForm();">
		  <span class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMBtnText sapMFocusable sapMIE">
    		<span class="sapMBtnContent"><esapi:encodeForHTMLAttribute><fmt:message key="rules.lookupListUploadPopup.button.upload.txt"/></esapi:encodeForHTMLAttribute></span>
    		<span class="sapMBtnFocusDiv"></span>
  		  </span>
	    </button>
	    <button class="sapMBarChild sapMBtn sapMBtnBase sasMButton" type="button" onclick="closeDialog();">
		  <span class="sapMBtnDefault sapMBtnHoverable sapMBtnInner sapMBtnText sapMFocusable sapMIE">
    		<span class="sapMBtnContent"><esapi:encodeForHTMLAttribute><fmt:message key="rules.lookupListUploadPopup.button.cancel.txt"/></esapi:encodeForHTMLAttribute></span>
    		<span class="sapMBtnFocusDiv"></span>
  		  </span>
	    </button>
     </td>
     </tr>
  </c:if>
  <c:if test="${empty updtRules}">
          <tr class="configurationTableDataRow"><td colspan="2">
               <fmt:message key="rules.privilege.unauthorized.for.service.txt"/> : <fmt:message key="rules.lookupListUploadPopup.pageName.txt"/>
          </td></tr>
  </c:if>


 </table>

</form>

</BODY>
</HTML>
