<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<style>

     DIV.scrollableGrid
      {
         BORDER-RIGHT: none;
         BORDER-TOP:  none;
         BORDER-LEFT: none;
         BORDER-BOTTOM: none;
         OVERFLOW: auto;
         TOP:0px;
         LEFT:0px;
         position:relative;
         vertical-align:top;
      }

      DIV.scrollableGrid thead th {z-index:30; position:relative;top: expression(getElementById("ruleDiv").scrollTop); }

      .rowSelected
      {
         background-color:#ddddee;
         color:#3300CC;
      }

      table.keyTable
      {
         width:100%;
         padding:0px;
      }
      table.keyTable td
      {
         padding:0px;
         text-align: left;
      }
      table.keyTable td:hover
      {
         background-color:#cfdeeb;
         border:1px solid #719db9;
      }
      table.keyTable td
      {
         border:1px solid #f0f1f2;
      }
</style>


<script language="JavaScript" src='common/scripts/jquery.js'></script>
<script language="JavaScript" src='common/scripts/i18n.js'></script>
<SCRIPT language="JavaScript" src="common/scripts/cf.js"></SCRIPT>
<script language="JavaScript" src="common/scripts/jquery.fcm.dynaform.js"></script>
<script language="JavaScript" src="rules/scripts/dynamicRows.js"></script>
<script language="JavaScript" src="rules/scripts/itemPriorityList.js"></script>
<script language="JavaScript" src="rules/scripts/autoSizing.js"></script>
<SCRIPT language="JavaScript" src="common/scripts/calendar.js"></SCRIPT>
<SCRIPT language="JavaScript" src="rules/scripts/sort.js"></SCRIPT>
<script language="JavaScript" src="rules/scripts/rules.js"></script>
<script language="JavaScript" src="rules/scripts/segments.js"></script>
<script language="JavaScript" src="rules/scripts/segmentActions.js"></script>
<script language="JavaScript" src="rules/scripts/variables.js"></script>
<script language="JavaScript">
//<!--

var action = '<c:url value="/r_rules.do"/>';
var segmentAction = '<c:url value="/r_variables.do"/>';
var variableAction = '<c:url value="/r_variables.do"/>';
var workflow = '${definer}_segments';
var definer = '${definer}';
var activity = '${activity}';
var segment = '${segment}';
var segmorgid = '${segmorgid}';
var depth = '${depth}';
var segmentId = '${segmentInfo.segmentId}';
var segmentUpNbr = '${segmentInfo.lstUpdtNbr}';
var segmentAcronym = '${segmentInfo.segmentAcronym}';

<c:if test="${refreshOverview}">
refreshVariableFolders(segmentAction);
</c:if>

function ignoreReturn(evt)
{
   if(!evt) evt = window.event;
   if(evt.keyCode == 13) return false;
   return true;
}

//-->
</script>


 <div id="rulesTabScrollableDiv" class="rulesTabScrollableClass">

 <%-- Error handling code --%>
 <div onclick="this.innerHTML='<br>'">
   <c:url var="reloadURL" value="/r_rules.do?method=viewSegment" />
   <tiles:insert page="rulesSystemMessages.jsp" flush="true">
     <tiles:put name="reloadURL" value="${reloadURL}" />
     <tiles:put name="refreshURL" value="${reloadURL}&refresh=true" />
     <tiles:put name="objectTypeName" value="Rule" />
   </tiles:insert>
 </div>

<br><br>

<%--
<form name="segmentForm" id="segmentForm" action='<c:url value="/r_variables.do"/>'>
  <input type="hidden" name="segmentId" id="segmentId" value="${segmentInfo.segmentId}"/>
  <input type="hidden" name="segmentUpNbr" id="segmentUpNbr" value="${segmentInfo.lstUpdtNbr}"/>
  <input type="hidden" name="segmentIdVersion" id="segmentIdVersion" value="${segmentInfo.segmentIdVersion}"/>
  <input type="hidden" name="lstUpdtNbr" id="lstUpdtNbr" value="${segmentInfo.lstUpdtNbr}"/>
  <input type="hidden" name="lstUpdtTimestamp" id="lstUpdtTimestamp" value="${segmentInfo.lstUpdtTimestamp.time}"/>
  <input type="hidden" name="createTimestamp" id="createTimestamp" value="${segmentInfo.createTimestamp.time}"/>
  <input type="hidden" name="lstUpdtUser" id="lstUpdtUser" value="${fn:escapeXml(segmentInfo.lstUpdtUser)}"/>
  <input type="hidden" name="createUser" id="createUser" value="${fn:escapeXml(segmentInfo.createUser)}"/>
--%>


<div align="center">
<TABLE name="segmentViewingTable" id="segmentViewingTable" class="configurationTable" style="width:95%;border:2px solid #e0e2e5;margin-left:10px" cellspacing="0" cellpadding="2" border="0" >

  <tr align="left" valign="top" >


    <th colspan="5" class="configurationTableTitle" >&nbsp;<fmt:message key="variable.${definer}.segmentDetailContent.title.fmt.txt"><fmt:param>${segmentInfo.segmentAcronym}</fmt:param></fmt:message><br>&nbsp; </th>
  </tr>

  <tr class="configurationTableDataRow" valign="top">
    <td colspan="5"> &nbsp;</td>
  </tr>

  <tr class="configurationTableDataRow" valign="top">
    <td style="width:10%;" nowrap><fmt:message key="variable.segmentDetailContent.label.txt"/>:</td>
    <td style="width:55%;" nowrap colspan='3'>${fn:escapeXml(segmentInfo.segmentDesc)}</td>
    <td>&nbsp;</td>
  </tr>

  <tr class="configurationTableDataRow" valign="top">
    <td nowrap><fmt:message key="variable.segmentDetailContent.prefix.txt"/>:</td>
    <c:choose>
      <c:when test='${not empty segmentInfo.segmentPrefixChar && fn:trim(segmentInfo.segmentPrefixChar) != ""}'>
        <td nowrap colspan='3'>${fn:toUpperCase(segmentInfo.segmentPrefixChar)}</td>
      </c:when>
      <c:otherwise>
        <td nowrap colspan='3'><i><fmt:message key="variable.segmentDetailContent.none.txt"/></i></td>
      </c:otherwise>
    </c:choose>
    <td>&nbsp;</td>
  </tr>
  <c:if test="${definer!='I' && definer!='O'}">
  <tr class="configurationTableDataRow" valign="top">
    <td nowrap><fmt:message key="variable.segmentDetailContent.keys.txt"/>:</td>
    <td nowrap>
       <span id="keyNames">
       <table class="keyTable">
         <c:choose>
           <c:when test="${empty segmentInfo.segmentKeyFieldBusinessNames}">
             <tr><td><i><fmt:message key="variable.segmentDetailContent.none.txt"/></i></td></tr>
           </c:when>
           <c:otherwise>
             <c:forEach var="key" items="${segmentInfo.segmentKeyFieldBusinessNames}" varStatus="status">
                <tr><td>${fn:toUpperCase(key)} (${segmentInfo.segmentKeyFieldLengths[status.index]} <fmt:message key="variable.segmentDetailContent.bytes.txt"/>)</td></tr>
             </c:forEach>
           </c:otherwise>
         </c:choose>
      </table>
      </span>
    </td>
    <td nowrap><fmt:message key="variable.segmentDetailContent.keyLength.txt"/>:</td>
    <td nowrap><span id="keyLength">${segmentInfo.segmentKeyFieldsTotalSize}</span> <fmt:message key="variable.segmentDetailContent.bytesOfMax.fmt.txt"><fmt:param value="100"/></fmt:message> </td>
    <td>&nbsp;</td>
  </tr>

  <tr class="configurationTableDataRow" valign="top">
    <td colspan="5"> &nbsp;</td>
  </tr>
  </c:if>


  <tr class="configurationTableDataRow" valign="top">
    <td style="width:10%;" nowrap><fmt:message key="variable.segmentDetailContent.segmentLength.txt"/>:</td>
    <td style="width:55%;" nowrap>${segmentInfo.segmentLength} <fmt:message key="variable.segmentDetailContent.bytesOfMax.fmt.txt"><fmt:param>${maxSegmentLength}</fmt:param></fmt:message></td>
    <td style="width:10%;" nowrap><fmt:message key="variable.segmentDetailContent.created.txt"/>:</td>
    <td style="width:25%;" nowrap>
       <fmt:formatDate value='${segmentInfo.createTimestamp}' pattern='${dateTimeFormat}' timeZone='${userTimeZone}'/>
       &nbsp;
       <c:if test="${isAccessibleBU}">
          <fmt:message key="variable.segmentDetailContent.byUser.fmt.txt">
             <fmt:param>${segmentInfo.createUser}</fmt:param>
          </fmt:message>
       </c:if>
    </td> <%-- S1010617 --%>
    <td>&nbsp;</td>
  </tr>

  <tr class="configurationTableDataRow" valign="top">
    <c:choose>      <%-- S1010617 --%>
    <c:when test="${isAccessibleBU}"> <%-- S1010617 --%>
      <td style="width:10%;" nowrap><fmt:message key="variable.segmentDetailContent.businessUnit.txt"/>:</td>
      <c:choose>
        <c:when test='${not empty segmentInfo.segmentBusinessUnitName && fn:trim(segmentInfo.segmentBusinessUnitName) != ""}'>
          <td nowrap>${fn:escapeXml(segmentInfo.segmentBusinessUnitName)}</td>
        </c:when>
        <c:otherwise>
          <td nowrap><i><fmt:message key="variable.segmentDetailContent.none.txt"/></i></td>
        </c:otherwise>
      </c:choose>
    </c:when>         <%-- S1010617 --%>
    <c:otherwise>     <%-- S1010617 --%>
      <td style="width:10%;">&nbsp;</td>  <%-- S1010617 --%>
      <td></td>       <%-- S1010617 --%>
    </c:otherwise>    <%-- S1010617 --%>
    </c:choose>       <%-- S1010617 --%>
    <td style="width:10%;" nowrap><fmt:message key="variable.segmentDetailContent.updated.txt"/>:</td>
    <td style="width:25%;" nowrap>
       <fmt:formatDate value='${segmentInfo.lstUpdtTimestamp}' pattern='${dateTimeFormat}' timeZone='${userTimeZone}'/>
       &nbsp;
       <c:if test="${isAccessibleBU}">
          <fmt:message key="variable.segmentDetailContent.byUser.fmt.txt">
             <fmt:param>${segmentInfo.lstUpdtUser}</fmt:param>
          </fmt:message>
       </c:if>
    </td> <%-- S1010617 --%>
    <td>&nbsp;</td>
  </tr>

  <c:if test='${isAccessibleBU && isTenantInstall && not empty segmentInfo.segmentMultiOrgLabel && fn:trim(segmentInfo.segmentMultiOrgLabel) != ""}'>  <%-- S1010617 --%>
    <tr class="configurationTableDataRow" valign="top">
      <td style="width:10%;" nowrap><fmt:message key="variable.segmentDetailContent.multiOrgNode.txt"/>:</td>
      <td nowrap>${fn:escapeXml(segmentInfo.segmentMultiOrgLabel)}</td>
      <td style="width:10%;" nowrap></td>
      <td style="width:25%;" nowrap></td>
      <td>&nbsp;</td>
    </tr>
  </c:if>

  <tr class="configurationTableDataRow" valign="top">
    <td colspan="5"> &nbsp;</td>
  </tr>

  <tr class="configurationTableDataRow" valign="top">
    <td colspan="5"> &nbsp;</td>
  </tr>

</TABLE>

</div>

</form>

</div>




<script>

   // Array will contain key field info
   var keyItems = new Array();

   // Create a new keyItem (contains info about segment key field)
   function getKeyItem(fieldName, fieldLength, fieldId) {
       var keyItem = new Object();
       keyItem.fieldName   = fieldName.toUpperCase().split(":")[0];
       keyItem.fieldLength = parseInt(fieldLength);
       keyItem.fieldId     = fieldId;
       return keyItem;
   }

   // Fill in current key fields
   <c:if test="${not empty segmentInfo.segmentKeyFieldBusinessNames}">
     <c:forEach var="key" items="${segmentInfo.segmentKeyFieldBusinessNames}" varStatus="status">
       keyItems[${status.index}] = getKeyItem('${key}', ${segmentInfo.segmentKeyFieldLengths[status.index]}, '${segmentInfo.segmentKeyFieldIds[status.index]}');
     </c:forEach>
   </c:if>
</script>


