
<%@ include file="/common/taglibs.jsp" %>
<%@ page import="java.util.List" %>
<%@ page contentType="text/html; charset=UTF-8" %>


<SCRIPT language="JavaScript" src="common/scripts/cf.js"></SCRIPT>
<script language="JavaScript" src="common/scripts/jquery.fcm.dynaform.js"></script>
<script language="JavaScript" src="rules/scripts/rules.js"></script>
<script language="JavaScript" src="rules/scripts/tasks.js"></script>
<script language="JavaScript" src="rules/scripts/ruleActions.js"></script>
<script language="JavaScript" src="rules/scripts/dynamicRows.js"></script>
<script language="JavaScript" src="rules/scripts/autoSizing.js"></script>
<SCRIPT language="JavaScript" src="common/scripts/calendar.js"></SCRIPT>
<SCRIPT language="JavaScript" src="rules/scripts/sort.js"></SCRIPT>
<SCRIPT language="JavaScript" src="rules/scripts/transactions.js"></SCRIPT>
<style>
     DIV.scrollableGrid
      {
         BORDER-RIGHT: none;
         BORDER-TOP:  none;
         BORDER-LEFT: none;
         BORDER-BOTTOM: none;
         OVERFLOW: auto;
         TOP:0px;
         LEFT:0px;
         position:relative;
         vertical-align:top;
      }

      DIV.scrollableGrid thead th {z-index:30; position:relative;top: expression(getElementById("ruleDiv").scrollTop); }

      .rowSelected
      {
         background-color:#ddddee;
         color:#648BB9;
      }


</style>


<c:choose>
	<c:when test="${empty productName}">
<pre id="tabTitle" style="display:none;">SAS&reg; Fraud Management - <fmt:message key="creditfraud.tab.rules.txt" /></pre>
	</c:when>
	<c:otherwise>
 <pre id="tabTitle" style="display:none;">${fn:replace(fn:replace(productName, "<sup>", ""), "</sup>", "")} - <fmt:message key="creditfraud.tab.rules.txt" /></pre>
	</c:otherwise>
</c:choose>
<script language="JavaScript">
if (parent.document)
  parent.document.title = document.getElementById("tabTitle").innerHTML;

var action = '<c:url value="/r_txnAdmin.do"/>';

function ignoreReturn(evt)
{
   if(!evt) evt = window.event;
   if(evt.keyCode == 13) return false;
   return true;
}
var reloadParams = '?method=listTransactions&treeSelectedTransaction=${transactionType.id}';
</script>

<span style='height:0.5em'/>
<div id="rulesTabScrollableDiv" class="rulesTabScrollableClass">
<%-- Error handling code --%>
	<c:url var="reloadURL" value="/r_txnAdmin.do?method=listTransactions&treeSelectedTransaction=${transactionType.id}" />
	<tiles:insert page="/admin/adminDetailErrorHandling.jsp" flush="true">
		<tiles:put name="reloadURL" value="${reloadURL}" />
		<tiles:put name="refreshURL" value="${reloadURL}&refresh=true" />
		<tiles:put name="objectTypeName" value="transaction" />
	</tiles:insert>

<div id="preTableBlock" align="left">
<h4>
	<fmt:message key="rules.transactionsOverviewContent.predefinedTransactions.txt"/>

 	<c:set var="stock" value="1" scope="request"/>

</h4>
</div>

	<script>
	$(document).ready(function(){  // RAPTOR-2399
		$("#checkAll").change(function () {
			 $('input:checkbox:enabled').prop('checked', this.checked);
		});
		<c:if test="${updtTrxTyp==false}">
			$('#predefinedForm input[type=checkbox]').prop('disabled', true); // RAPTOR-2399
		</c:if>
	});
	</script>

<div >
<c:set var="checkAction">
<c:if test="${ fn:length(transactionList)== fn:length(stockTransactionList)}">
checked
</c:if>
</c:set>

	<form name="predefinedForm" id="predefinedForm" action="<c:url value='/r_txnDefinition.do'/>" method="post" >
	<input type="hidden" name="method" id="method" value="saveStockTransactionsBusinessUnit" />

<table width="98%">

<tr><td>
<table class="mainTable" id="ruleListTable" align="left" style="margin:0px 0px 0px 0px;-moz-user-select:none;" onselectstart="return false;" border="0" cellspacing="0" cellpadding="0">
   <thead>
       <TR class="tableColumnHeaderRow">
        	<TH class="centeredTableHeader" nowrap style="text-align:center;" title="<fmt:message key='rules.transactionsDetailContent.tableHeader.active.txt'/>"><div>&nbsp;<fmt:message key="rules.transactionsDetailContent.tableHeader.active.txt"/></div><input type="checkbox" id="checkAll" ${checkAction}></TH>
	        <TH class="centeredTableHeader" nowrap >&nbsp;<fmt:message key="rules.transactionsDetailContent.tableHeader.desc.txt"/></TH>
        	<TH class="centeredTableHeader" nowrap >&nbsp;<fmt:message key="rules.transactionsDetailContent.tableHeader.acronym.txt"/></TH>
       </TR>
   </thead>
   <TBODY id="ruleTableBody">

	     	<c:forEach var="stockTransaction" items="${stockTransactionList}" varStatus="status">
	     	 <TR  id="${status.count}" class="dataRow${status.count%2+1}_tableRow"
	                  style="cursor:pointer;" ondblclick="showTxnDef('modifyTransactionType','','','${stockTransaction.id}','${stock}');"
	             onclick='handleTxnSelection("${esapi:encodeForJavaScript(stockTransaction.id)}", "${esapi:encodeForJavaScript(stockTransaction.desc)}", "${esapi:encodeForJavaScript(stockTransaction.acronym)}","${esapi:encodeForJavaScript(stockTransaction.tableName)}", this,"rowSelected",event);'
	             >

					<TD class="textTableCell" style="text-align:center;" title="${esapi:encodeForHTMLAttribute(stockTransaction.id)}">&nbsp;<input type="checkbox" name="id" id="id" value="${esapi:encodeForHTML(stockTransaction.id)}"
					<c:forEach var="transaction" items="${transactionList}" varStatus="status">
						 <c:if test="${transaction.id==stockTransaction.id}">checked</c:if>
						 <c:forEach var="disabledTxnType" items="${disabledTxnTypes}">
							 	<c:if test="${stockTransaction.id==disabledTxnType}">disabled</c:if>
					     </c:forEach>
					</c:forEach>
					></TD>
	            <TD class="textTableCell" title="${esapi:encodeForHTMLAttribute(stockTransaction.desc)}">&nbsp;${esapi:encodeForHTML(stockTransaction.desc)}</TD>
				<TD class="textTableCell" title="${esapi:encodeForHTMLAttribute(stockTransaction.acronym)}">&nbsp;${esapi:encodeForHTML(stockTransaction.acronym)}</TD>
	         </TR>
	      </c:forEach>

   </TBODY>
</table>
</td></tr>
</table>
</div>

</div>
	</form>


  <%-- Invisible iframe used to dispatch a save --%>
 <!--  <iframe id="saveTransactionsFrame" name="saveResultsFrame" src="blank.html" style="position:absolute; top:500px; left:0px; height:0px; width:0px; border:0px;"></iframe>-->

  <%-- Debug log --%>
  <pre id="debugLog" style="position:absolute; top:300px; left:0px; height:0px; width:0px; border:0px; background:yellow;text-align:left;"></pre>


