<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<style>

     DIV.scrollableGrid
      {
         BORDER-RIGHT: none;
         BORDER-TOP:  none;
         BORDER-LEFT: none;
         BORDER-BOTTOM: none;
         OVERFLOW: auto;
         TOP:0px;
         LEFT:0px;
         position:relative;
         vertical-align:top;
      }

      DIV.scrollableGrid thead th {z-index:30; position:relative;top: expression(getElementById("ruleDiv").scrollTop); }

      .rowSelected
      {
         background-color:#ddddee;
         color:#3300CC;
      }


eXtremeTable .odd a, .even a {
   color: Black;
   font-size: 0.88rem;
   background-color : #FFFFFF;
}

.eXtremeTable .odd td, .eXtremeTable .even td {
   padding-top: 2px;
   padding-right: 3px;
   padding-bottom: 2px;
   padding-left: 3px;
   vertical-align: middle;
   font-family: 'AvenirNext', verdana, arial, helvetica, sans-serif;
   font-size: 0.88rem;
}

.eXtremeTable .odd {
   background-color: #FFFFFF;
}

.eXtremeTable .even {
   background-color : #f0f1f2;
}
.eXtremeTable .toolbar {

   font-family: 'AvenirNext', verdana, arial, helvetica, sans-serif;
   font-size: 0.70rem;
   margin-right: 1px;

}

.eXtremeTable .toolbar td {
   color: #444444;
   padding: 0px 3px 0px 3px;
   text-align:center;
}

.eXtremeTable .separator {
   width: 7px;
}
.eXtremeTable .title {
   color: #444444;
   font-weight: bold;
   font-family: 'AvenirNext', 'Trebuchet MS', Verdana, Arial, Helvetica, sans-serif;
   font-size: 1rem;
   vertical-align: bottom;

}

.eXtremeTable .title span {
   margin-left: 0px;

}
.eXtremeTable .tableHeaderSort {

   border-top: 1px solid #E6DAC2;
   border-bottom: 1px solid #E6DAC2;
   border-right:none;
   border-left: none;
   color:#353535;
   font-weight:bold;
   font-family : 'AvenirNext', 'Trebuchet MS', Verdana, Arial, Helvetica, sans-serif;
   font-size : 0.70rem;
   background-color : #e0e2e5;
      text-decoration:underline;
}
.eXtremeTable .calcRow {
   background-color: #e0e2e5;
   border-top: solid 1px;
   border-color: #c6cad0;
}

.eXtremeTable .calcTitle {
   background-color: #e0e2e5;
   color: black;
   font-family: 'AvenirNext', verdana, arial, helvetica, sans-serif;
   font-weight: bold;
   font-size: 0.88rem;
   border-top: solid 1px;
   border-color: #c6cad0;
}

.eXtremeTable .calcResult {
   background-color: #e0e2e5;
   color: black;
   font-family: 'AvenirNext', verdana, arial, helvetica, sans-serif;
   border-top: solid 1px;
   border-color: #c6cad0;
   text-align:right;
}

</style>



<%-- ----------------------------------------------- --%>
<%-- Include non-PDF info only if not creating a PDF --%>
<%-- ----------------------------------------------- --%>
<c:if test="${empty param.ec_eti}">

  <script language='JavaScript' src='common/scripts/jquery.js'></script>
    <script language="JavaScript" src="common/scripts/jquery.fcm.dynaform.js"></script>
  <script language="JavaScript" src='common/scripts/i18n.js'></script>
  <script language="JavaScript" src="rules/scripts/dynamicRows.js"></script>
  <script language="JavaScript" src="rules/scripts/itemPriorityList.js"></script>
  <script language="JavaScript" src="rules/scripts/autoSizing.js"></script>
  <SCRIPT language="JavaScript" src="common/scripts/calendar.js"></SCRIPT>
  <SCRIPT language="JavaScript" src="rules/scripts/sort.js"></SCRIPT>
  <script language="JavaScript" src="rules/scripts/rules.js"></script>
  <script language="JavaScript" src="rules/scripts/variables.js"></script>
  <script language="JavaScript" src="rules/scripts/segments.js"></script>

<c:choose>
	<c:when test="${empty productName}">
<pre id="tabTitle" style="display:none;">SAS&reg; Fraud Management - <fmt:message key="creditfraud.tab.userVariables.txt" /></pre>
	</c:when>
	<c:otherwise>
<pre id="tabTitle" style="display:none;">${fn:replace(fn:replace(productName, "<sup>", ""), "</sup>", "")} - <fmt:message key="creditfraud.tab.userVariables.txt" /></pre>
	</c:otherwise>
</c:choose>
  <script language="JavaScript">
  //<!--
  if (parent.document)
    parent.document.title = document.getElementById("tabTitle").innerHTML;

  var action = '<c:url value="/r_rules.do"/>';
  var variableAction = '<c:url value="/r_variables.do"/>';
  var segmentAction = '<c:url value="/r_variables.do"/>';
  var workflow = '${definer}Variables';
  var definer = '${definer}';
  var activity = '${activity}';
  var segment = '${segment}';
  var segmorgid = '${segmorgid}';
  var componentType='${componentType}';
  var depth = '${depth}';
  <c:set var="wildBuId"><%= com.sas.finserv.creditfraud.webapp.web.AuthorizationFilter.WILD_BU_ID %></c:set>
  var workingBuId = ${workingBuId};
  var wildBuId = ${wildBuId};
  var reloadParams = '?method=listVariables&definer=${definer}&activity=${activity}&segment=${segment}&segmorgid=${segmorgid}&depth=${depth}';

  <c:if test="${refreshOverview}">
  refreshVariableFolders(variableAction);
  </c:if>
  <c:if test="${definer=='V'}">
  <c:set var="canUpdate" value="${updtSegment}"/>
  </c:if>
  <c:if test="${definer=='I' || definer=='O'}">
  <c:set var="canUpdate" value="${updtAPISegment}"/>
  </c:if>
  var canNewSegment = ${not empty canUpdate && canUpdate && empty noMoreSegments};
  if (canNewSegment) {
	  parent.sas.fscf.getCurrentDetailToolbar().enableNewSegment();
  }
  var canEditSegment = ${not empty canUpdate && canUpdate && (fn:length(variables)==0) && (wildBuId==workingBuId || segmentInfo.segmentBusinessUnitId==workingBuId || (segmentInfo.segmentBusinessUnitId==null && (fn:startsWith(segmentInfo.segmentAcronym,'I'))||(fn:startsWith(segmentInfo.segmentAcronym,'O'))) )};
  if (canEditSegment) {
	  parent.sas.fscf.getCurrentDetailToolbar().makeSegmentEditable();
  }
  var canEditRUAVariable = ${segment=='RUA' && not empty updtRuas && updtRuas};
  if (canEditRUAVariable) {
	  parent.sas.fscf.getCurrentDetailToolbar().makeRUAVariableEditable();
  }

  function ignoreReturn(evt)
  {
     if(!evt) evt = window.event;
     if(evt.keyCode == 13) return false;
     return true;
  }

  var variableUpNbrs = new Array();
  var variableNames = new Array();
  var variableSegments = new Array();

  <c:forEach var="variable" items="${variables}" >
  //-->
  </script>
     <pre id="variableUpNbr${variable.segmentFieldId}" style="display:none">${fn:escapeXml(variable.lstUpdtNbr)}</pre>
     <pre id="variableName${variable.segmentFieldId}" style="display:none">${fn:escapeXml(variable.fieldBusinessName)}</pre>
     <pre id="variableSegment${variable.segmentFieldId}" style="display:none">${fn:escapeXml(variable.segmentAcronym)}</pre>
  <script>
  //<!--
     variableUpNbrs[${variable.segmentFieldId}] = document.getElementById("variableUpNbr${variable.segmentFieldId}").innerHTML;
     variableNames[${variable.segmentFieldId}] = document.getElementById("variableName${variable.segmentFieldId}").innerHTML;
     variableSegments[${variable.segmentFieldId}] = document.getElementById("variableSegment${variable.segmentFieldId}").innerHTML;
  </c:forEach>

  //-->
  </script>

   <span style='height:0.5em'/>
   <div id="rulesTabScrollableDiv" class="rulesTabScrollableClass">

   <%-- Error handling code --%>
   <div onclick="this.innerHTML='<br>'">
     <c:url var="reloadURL" value="/r_rules.do?method=listVariables&definer=${definer}&activity=${activity}&segment=${segment}&segmorgid=${segmorgid}&depth=${depth}" />
     <tiles:insert page="rulesSystemMessages.jsp" flush="true">
       <tiles:put name="reloadURL" value="${reloadURL}" />
       <tiles:put name="refreshURL" value="${reloadURL}&refresh=true" />
       <tiles:put name="objectTypeName" value="Rule" />
     </tiles:insert>
   </div>


  <%-- Title --%>
  <div align="left" style="width:98%;">
    <h4 style="float:left" id='variableListTitle'>
      <c:choose>
        <c:when test="${definer=='system' && componentType!='' && componentType!=null}">
          <fmt:message key="rules.variables.system.${componentType}.${activity}.list.fmt.txt"><fmt:param value="${segment}"/></fmt:message> : ${segmentInfo.segmentDesc}
        </c:when>
        <c:when test="${definer=='system' && segment!='all'}">
          <fmt:message key="rules.variables.system.${activity}.list.fmt.txt"><fmt:param value="${segment}"/></fmt:message> : ${segmentInfo.segmentDesc}
        </c:when>
        <c:when test="${definer=='V' && segment!='all'}">
          <c:choose>
            <c:when test="${segment=='RUA'}"><fmt:message key="rules.variables.RUA.${activity}.list.txt"/></c:when>
            <c:when test="${segmentInfo.segmentKeyFieldCount == 1}"><fmt:message key="rules.variables.V.${activity}.list.fmt.txt"><fmt:param>_${fn:toUpperCase(segmentInfo.segmentPrefixChar)}_</fmt:param></fmt:message>: ${segmentInfo.segmentDesc}
                 (<fmt:message key="variable.variablesDetailContent.segment.key.txt"/>=${fn:toUpperCase(segmentInfo.segmentKeyFieldBusinessNames[0])})
            </c:when>
            <c:when test="${segmentInfo.segmentKeyFieldCount > 1}"><fmt:message key="rules.variables.V.${activity}.list.fmt.txt"><fmt:param>_${fn:toUpperCase(segmentInfo.segmentPrefixChar)}_</fmt:param></fmt:message>: ${segmentInfo.segmentDesc}
                 (<fmt:message key="variable.variablesDetailContent.segment.keys.txt"/>=${fn:replace(fn:replace(fn:toUpperCase(segmentInfo.segmentKeyFieldBusinessNames),'[',''),']','')})
            </c:when>
            <c:otherwise><fmt:message key="rules.variables.${definer}.${activity}.list.fmt.txt"><fmt:param>${fn:toUpperCase(segment)}</fmt:param></fmt:message>
                         <c:if test="{not empty updtSegment && updtSegment}"><span style="font-weight:normal;"> &nbsp;&nbsp;<fmt:message key="variable.variablesDetailContent.defineSegmentFirst.txt"/></span></c:if> <%-- S1010617 --%>
            </c:otherwise>
          </c:choose>
        </c:when>
        <c:when test="${segment!='all'}">
        	<fmt:message key="rules.variables.${definer}.${activity}.list.fmt.txt"><fmt:param>_${fn:toUpperCase(segmentInfo.segmentPrefixChar)}_</fmt:param></fmt:message>: ${segmentInfo.segmentDesc}
        	<c:if test="{not empty updtSegment && updtSegment}"><span style="font-weight:normal;"> &nbsp;&nbsp;<fmt:message key="variable.variablesDetailContent.defineSegmentFirst.txt"/></span></c:if> <%-- S1010617 --%>
        </c:when>
        <c:otherwise>
        <c:if test="${segment=='RUA'}"><c:set var='definer' value='RUA'/></c:if>
         <fmt:message key="rules.variables.${definer}.${activity}.all.list.txt"/>
        </c:otherwise>
      </c:choose>
    </h4>
    <div style="float:right;font-weight:normal;margin-top:18px;">
      <c:if test="${depth=='full'}"><a style="font-weight:normal;" href="javascript:showHideDepth()" title="<esapi:encodeForHTMLAttribute><fmt:message key='variable.variablesDetailContent.tableView.less.title.txt'/></esapi:encodeForHTMLAttribute>"><fmt:message key="variable.variablesDetailContent.tableView.less.txt" />&nbsp;<img border="0" src="images/rules/chevrons-left.gif"></a>&nbsp;</c:if>
      <c:if test="${depth!='full'}"><a style="font-weight:normal;" href="javascript:showHideDepth()" title="<esapi:encodeForHTMLAttribute><fmt:message key='variable.variablesDetailContent.tableView.more.title.txt'/></esapi:encodeForHTMLAttribute>"><fmt:message key="variable.variablesDetailContent.tableView.more.txt" />&nbsp;<img border="0" src="images/rules/chevrons-right.gif"></a>&nbsp;</c:if>
    </div>
  </div>

  <table class="mainTable" id="variablesTable" width="98%" align="left" style="margin:0px 0px 0px 0px;-moz-user-select:none;" onselectstart='return false;' border="0" cellspacing="0" cellpadding="0">
     <thead id='tableHead'>
       <TR class="tableColumnHeaderRow">
         <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="variable.variablesDetailContent.tableHeader.name.txt" /></TH>
         <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="variable.variablesDetailContent.tableHeader.type.txt" /></TH>
         <c:if test="${(isUsingWildBu || depth=='full') && definer=='V' && segment!='RUA'}"> <%-- S1010617 --%>
           <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="variable.variablesDetailContent.tableHeader.businessUnit.txt" /></TH>
         </c:if>
         <c:if test="${not empty tenantMultiOrgLabel || depth=='full'}">
             <TH class="centeredTableHeader" nowrap rules:sortAsText>&nbsp;<fmt:message key="variable.variablesDetailContent.tableHeader.multiOrg.txt" /></TH>
         </c:if>
         <TH class="centeredTableHeader" nowrap rules:sortAsNum title="<esapi:encodeForHTMLAttribute><fmt:message key='variable.variablesDetailContent.tableHeader.rules.title.txt'/></esapi:encodeForHTMLAttribute>">&nbsp;<fmt:message key="variable.variablesDetailContent.tableHeader.rules.txt" /></TH>
         <c:if test="${definer=='V' || definer=='I' || definer=='O'}">
           <c:if test="${depth=='full'}">
             <TH class="centeredTableHeader" nowrap rules:sortAsText title="<esapi:encodeForHTMLAttribute><fmt:message key='variable.variablesDetailContent.tableHeader.messageAlias.title.txt'/></esapi:encodeForHTMLAttribute>">&nbsp;<fmt:message key="variable.variablesDetailContent.tableHeader.messageAlias.txt" /></TH>
             <TH class="centeredTableHeader" nowrap rules:sortAsText title="<esapi:encodeForHTMLAttribute><fmt:message key='variable.variablesDetailContent.tableHeader.initialValue.title.txt'/></esapi:encodeForHTMLAttribute>">&nbsp;<fmt:message key="variable.variablesDetailContent.tableHeader.initialValue.txt" /></TH>
           </c:if>
           <TH class="centeredTableHeader" nowrap rules:sortAsText title="<esapi:encodeForHTMLAttribute><fmt:message key='variable.variablesDetailContent.tableHeader.build.title.txt'/></esapi:encodeForHTMLAttribute>">&nbsp;<fmt:message key="variable.variablesDetailContent.tableHeader.build.txt" /></TH>
         </c:if>
         <c:if test="${depth=='full'}">
           <TH class="centeredTableHeader" nowrap rules:sortAsText title="<esapi:encodeForHTMLAttribute><fmt:message key='variable.variablesDetailContent.tableHeader.description.title.txt'/></esapi:encodeForHTMLAttribute>">&nbsp;<fmt:message key="variable.variablesDetailContent.tableHeader.description.txt" /></TH>
         </c:if>
         <TH class="centeredTableHeader" nowrap rules:sortAsText title="<esapi:encodeForHTMLAttribute><fmt:message key='variable.variablesDetailContent.tableHeader.segment.title.txt'/></esapi:encodeForHTMLAttribute>">&nbsp;<fmt:message key="variable.variablesDetailContent.tableHeader.segment.txt" /></TH>
         <c:if test="${depth=='full'}">
           <TH class="centeredTableHeader" nowrap rules:sortAsText title="<esapi:encodeForHTMLAttribute><fmt:message key='variable.variablesDetailContent.tableHeader.components.title.txt'/></esapi:encodeForHTMLAttribute>">&nbsp;<fmt:message key="variable.variablesDetailContent.tableHeader.components.txt" /></TH>
         </c:if>
         <c:if test="${definer=='V' || definer=='I' || definer=='O'}">
           <%-- Initial sort order of user variables is by 1st column (see function initVariablesSortOrder() in variables.js) --%>
           <TH class="centeredTableHeader" nowrap rules:sortAsLocalDate width="1%">&nbsp;<fmt:message key="variable.variablesDetailContent.tableHeader.lastUpdated.txt" /></TH>
         </c:if>
       </TR>
     </thead>

     <TBODY id="ruleTableBody">

      <c:if test="${empty variables}">
        <TR rowspan="2">
           <TD align="right" style="font-size:10pt;" colspan="100%"><center><em><fmt:message key="variable.variablesDetailContent.table.noVariables.txt" /></center></em></TD>
        </TR>
      </c:if>

      <c:if test="${not empty variables}">
        <c:forEach var="variable" items="${variables}" varStatus="status">

           <TR style="cursor:pointer;" id="${status.count}" class="dataRow${status.count%2+1}_tableRow"
               onClick='handleRowSelectionVariable(${variable.segmentFieldId}, variableUpNbrs[${variable.segmentFieldId}], variableNames[${variable.segmentFieldId}], variableSegments[${variable.segmentFieldId}], this,"rowSelected", event)';
               ondblclick='viewVariable();'>

              <TD class="textTableCell" ><c:choose><c:when test="${fn:substring(variable.fieldBusinessName,0,1)=='_'}">${fn:toUpperCase(fn:escapeXml(variable.fieldBusinessName))}</c:when><c:otherwise>${fn:toUpperCase(fn:escapeXml(variable.fieldName))}</c:otherwise></c:choose> </TD>
              <TD class="textTableCell" >
                 <c:if test="${variable.character}">
                    ${variable.fieldLength} <fmt:message key="variable.variablesDetailContent.${fn:toLowerCase(fn:trim(fn:escapeXml(variable.variableType)))}.type.txt"/>
                 </c:if>
                 <c:if test="${variable.numeric}">
                    <fmt:message key="variable.variablesDetailContent.${fn:toLowerCase(fn:trim(fn:escapeXml(variable.variableType)))}.type.txt"/>
                 </c:if>
              </TD>
              <c:if test="${(isUsingWildBu || depth=='full') && definer=='V' && segment!='RUA'}"> <%-- S1010617 --%>
                <TD class="textTableCell" ><c:choose><c:when test='${empty variable.businessUnitName}'><i><fmt:message key="variable.variablesDetailContent.value.none.txt"/></i></c:when><c:otherwise>${fn:escapeXml(variable.businessUnitName)}</c:otherwise></c:choose> </TD> <%-- S1010617 --%>
               </c:if>
                <c:if test="${not empty tenantMultiOrgLabel || depth=='full'}">
                  <TD class="textTableCell" ><c:choose><c:when test='${empty variable.segmentMultiOrgLabel}'><i><fmt:message key="variable.variablesDetailContent.value.none.txt"/></i></c:when><c:otherwise>${fn:escapeXml(variable.segmentMultiOrgLabel)}</c:otherwise></c:choose> </TD> <%-- S1010617 --%>
                </c:if>

              <TD class="textTableCell" ><c:if test="${variable.testUseCount+variable.prodUseCount>0}" > ${variable.testUseCount+variable.prodUseCount} </c:if></TD>
              <c:if test="${definer=='V' || definer=='I' || definer=='O'}">
                <c:if test="${depth=='full'}">
                  <TD class="textTableCell" >${fn:toUpperCase(variable.fieldName)}</TD>
                  <TD class="textTableCell">
                     <c:if test="${variable.segmentAcronym!='RUA'}">${fn:escapeXml(variable.initialValue)}</c:if> <%-- S0881932 --%>
                     <c:if test="${variable.segmentAcronym=='RUA'}"><i><fmt:message key="variable.variablesDetailContent.value.none.txt"/></i></c:if> <%-- S1010617 --%>
                  </TD>
                </c:if>
                <TD class="textTableCell" >
                   <c:if test="${variable.hasBeenBuilt}">${variable.buildId}</c:if>
                   <c:if test="${variable.segmentAcronym=='RUA'}"><i><fmt:message key="variable.variablesDetailContent.value.none.txt"/></i></c:if> <%-- S1010617 --%>
                </TD>
              </c:if>
              <c:if test="${depth=='full'}">
                <TD class="textTableCell" >${fn:trim(fn:escapeXml(variable.desc))}</TD>
              </c:if>
              <TD class="textTableCell" >
                ${fn:trim(fn:escapeXml(variable.segmentAcronym))}<c:if test="${depth=='full'}">: ${fn:trim(fn:escapeXml(variable.segmentDesc))}</c:if>
              </TD>

              <c:if test="${depth=='full'}">
                <TD class="textTableCell" >
                  <c:set var="prevCompType" value=""/>
                  <c:forEach var="comp" items="${variable.components}" varStatus='stat'>
                     <c:if test="${comp.componentType != prevCompType}">
                        <c:set var="prevCompType" value="${comp.componentType}"/>
                        <c:if test="${stat.index!=0}">
                          <br>
                        </c:if>
                        ${fn:trim(comp.componentType)}:
                     </c:if>
                     <c:if test="${fn:trim(comp.componentValue)!='CMD' && fn:trim(comp.componentValue)!='MON'}">
                       ${fn:trim(comp.componentValue)}
                     </c:if>
                  </c:forEach>
                </TD>
              </c:if>
              <c:if test="${definer=='V' || definer=='I' || definer=='O'}">
                <TD class="textTableCell" style="white-space:nowrap;">
                   <span sortValue="${variable.lstUpdtTimestampUtcMillis}">
                      <fmt:formatDate value='${variable.lstUpdtTimestamp}' pattern='${dateTimeFormat}' timeZone='${userTimeZone}'/>
                   </span>
                   &nbsp;&nbsp;
                </TD>
              </c:if>
           </TR>

        </c:forEach>
      </c:if>

     </TBODY>
  </table>
  </div>

</c:if>


<div id="rulesExportDiv" style="display:none;">

<%-- Set the title based on the kind of variables printed --%>
<c:set var="pdfTitle">
      <c:choose>
        <c:when test="${segment!='all' && definer=='system'}">
          <fmt:message key="rules.variables.system.${activity}.list.fmt.txt"><fmt:param value="${segment}"/></fmt:message>
        </c:when>
        <c:when test="${segment!='all' && definer=='V'}">
          <fmt:message key="rules.variables.V.${activity}.list.fmt.txt"><fmt:param>${fn:toUpperCase(segment)}</fmt:param>></fmt:message>
        </c:when>
        <c:otherwise>
          <fmt:message key="rules.variables.${definer}.${activity}.all.list.txt" />
        </c:otherwise>
      </c:choose>
</c:set>

<span id="ruleData" style="width:98%">
      <ec:table
         items="variables"
         var="variables"
         action="r_variables.do"
         title="Ignored Title"
         width="100%"
         sortable="false"
         filterable="false"
         showExports="true"
         showStatusBar="true"
         tableId="ruleData"
         styleClass="mainTable"
         rowsDisplayed="20"
         view="html2"
       >
       <ec:exportPdf
          imageName="pdf"
          fileName="variables.pdf"
          tooltip="Export PDF"
          headerColor="#353535"
          headerBackgroundColor="#e0e2e5"
          headerTitle="${pdfTitle}"
          view="pdfRulesList"
       />
       <ec:row>
         <c:set var="color" value="black" />
         <%-- ------------------------------------------------------- --%>
         <%-- Include rows if PDF requested and based on request type --%>
         <%-- ------------------------------------------------------- --%>
         <c:if test="${not empty param.ec_eti}">
           <ec:column  property="name"             title="Name"          headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
           <ec:column  property="typeInfo"         title="Type"          headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
           <ec:column  property="useCounts"        title="Counts"        headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
           <ec:column  property="desc"             title="Description"   headerClass="tableHeader" headerStyle="border-top:1px solid #c6cad0;border-right:none;color:#353535;font-weight:bold;" styleClass="textTableCell" />
         </c:if>
       </ec:row>
   </ec:table>
   <br><br>
</span>
</div>



<script>
   attachEventHandlerToTableCells(['variablesTable']);

   // Restore previous sort order if not the default
   if (getSortOrder()!="")
      sortVariables("variablesTable");

</script>





